// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.services' is found in services.js
// 'starter.controllers' is found in controllers.js
angular.module('starter', ['ionic','ionic.service.core', 'starter.controllers', 'starter.services', 'ngCordova', 'angular-filepicker', 'ngIOS9UIWebViewPatch'])

        .run(function($ionicPlatform, $rootScope, $ionicLoading, $ionicHistory, $localstorage, EVENTS, AuthService, $ionicNavBarDelegate, $cordovaStatusbar, $state) {


            // Used for functions that are only associated with mobile website
            // This will be overwritten in device.ready (which is never called on mobilesite)
            linkPlatform = 'mobilesite'            
            // Reset state on save for mobilesites
            // window.onload = function() { $state.go('index', {}); } 

            // A way to check for analytics before isDeviceReady
            var isCordova = document.URL.indexOf( 'http://' ) === -1 && document.URL.indexOf( 'https://' ) === -1;
            
            if (isCordova) {
                 isMobileWebsite = false 
            } else {
                isMobileWebsite = document.URL.indexOf( 'localhost' ) === -1 && document.URL.indexOf( 'giftster.' ) === -1 ? false: true;
            }
    
            if (isMobileWebsite) {
                window.ga=window.ga||function(){(ga.q=ga.q||[]).push(arguments)};ga.l=+new Date;
                ga('create', 'UA-34279059-1', 'auto', {'allowLinker': true});
                ga('require', 'linker');
                ga('linker:autoLink', ['www.giftster.com'] );                
            }

            $ionicPlatform.ready(function() {

                // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
                // for form inputs)
                if (window.cordova && window.cordova.plugins.Keyboard) {
                    cordova.plugins.Keyboard.hideKeyboardAccessoryBar(false);
                }

                if (window.StatusBar) {
                    // org.apache.cordova.statusbar required
                    StatusBar.styleDefault();
                    StatusBar.overlaysWebView(false);

                    StatusBar.styleLightContent();
                    StatusBar.backgroundColorByHexString('#ad181f');
                }
                            
                // Don't Reset state on save for actual devices
                window.onload = null;

                // Platform used for monetizing links
                if (isMobileWebsite) {
                    linkPlatform = 'mobilesite';
                } 
                else if ( ionic.Platform.isIOS() ) {
                    linkPlatform = 'ios';
                }
                else if ( ionic.Platform.isAndroid() ) {
                    linkPlatform = 'android'
                } else {
                    // Insurance
                    linkPlatform = 'mobilesite';
                }


                // Google analytics init
                if (typeof analytics !== 'undefined') {
                   
                    if ( ionic.Platform.isIOS() ) {
                        analytics.startTrackerWithId("UA-34279059-9");
                        console.log('starting tracker with iOS')

                    } else if ( ionic.Platform.isAndroid() ) {
                        analytics.startTrackerWithId("UA-34279059-10");
                    }

                } else {
                    console.log("Google Analytics Unavailable");
                }



            });
            $rootScope.$on('loading:show', function() {
                $ionicLoading.show(); //({template: 'Logging In...'})
            });

            $rootScope.$on('loading:hide', function() {
                $ionicLoading.hide();
            });

        })
        .service('Session', function() {
            this.create = function(user) {
                this.user = user;
            };
            this.destroy = function() {
                this.user = null;
            };
            return this;
        })
        .constant('EVENTS', {
            loginSuccess: 'auth-login-success',
            loginFailed: 'auth-login-failed',
            logoutSuccess: 'auth-logout-success',
            sessionTimeout: 'auth-session-timeout',
            notAuthenticated: 'auth-not-authenticated',
            signupSuccess: 'auth-signup-success'
        })
        .config(function( $stateProvider, $urlRouterProvider, apiUrl, $ionicConfigProvider, $httpProvider, filepickerProvider) {

            // ionic.Platform.ready(function(){
            //     // Facebook Login
            //     var appID = 1761949500746378;
            //     var version = 'v2.7';
            //     $cordovaFacebookProvider.browserInit(appID, version);
            // });
            
            filepickerProvider.setKey('A8uebfJuwTeuzM7mvZwntz');

            // $httpProvider.interceptors.push('timeoutHttpIntercept', function($rootScope) {
            //     return {
            //         request: function(config) {
            //             return config;
            //         },
            //         responseError: function(response) {
            //             // console.log(response)
            //             return response;
            //         },
            //         response: function(response) {
            //             // console.log(response)
            //             return response;
            //         }
            //     }
            // });

            $httpProvider.interceptors.push(function ($rootScope, $q, $window, $location) {
                    return {
                        request: function (config) {
                            config.timeout = 70000;
                            return config;
                        },
                        responseError: function (rejection) {
                            
                            if ($location.path() != '/timeout') {
                                $location.path('/timeout')
                                console.log('rejected')
                            }
                            // switch (rejection.status){
                            //     case 408 :
                            //         console.log('connection timed out');
                            //         break;
                            // }
                            return $q.reject(rejection);
                        }
                    }
                })


            $httpProvider.interceptors.push(function($rootScope) {
                return {
                    request: function(config) {
                        if (config.url != (apiUrl + '/api/fetch/'))
                            $rootScope.$broadcast('loading:show');
                        return config;
                    },
                    response: function(response) {
                        $rootScope.$broadcast('loading:hide');
                        return response;
                    }
                }
            });

            $ionicConfigProvider.tabs.style('ios'); //even if you're on android
            $ionicConfigProvider.tabs.position('ios'); //even if you're on android
            $ionicConfigProvider.platform.android.views.transition('none');
            /*
             $ionicConfigProvider.platform.ios.tabs.style('standard');
             $ionicConfigProvider.platform.ios.tabs.position('bottom');
             $ionicConfigProvider.platform.android.tabs.style('standard');
             $ionicConfigProvider.platform.android.tabs.position('standard');
             
             $ionicConfigProvider.platform.ios.navBar.alignTitle('center');
             $ionicConfigProvider.platform.android.navBar.alignTitle('left');
             
             $ionicConfigProvider.platform.ios.backButton.previousTitleText('').icon('ion-ios-arrow-thin-left');
             $ionicConfigProvider.platform.android.backButton.previousTitleText('').icon('ion-android-arrow-back');
             
             $ionicConfigProvider.platform.ios.views.transition('ios');
             $ionicConfigProvider.platform.android.views.transition('android');
             */
            // Ionic uses AngularUI Router which uses the concept of states
            // Learn more here: https://github.com/angular-ui/ui-router
            // Set up the various states which the app can be in.
            // Each state's controller can be found in controllers.js
            $stateProvider

                    .state('index', {
                        cache: false,
                        url: '/index',
                        templateUrl: 'templates/index.html',
                        controller: 'IndexCtrl'
                    })
                    .state('signup', {
                        cache: false,
                        url: '/signup',
                        templateUrl: 'templates/entry/signup.html',
                        controller: 'SignupCtrl'
                    })

                    /// Index->Login page
                    .state('login-tabs', {
                        cache: false,
                        url: '/login/:tabId',
                        templateUrl: 'templates/entry/login-tabs.html',
                        controller: 'LoginTabsCtrl'
                    })
                    .state('login-forgotpassword', {
                        cache: false,
                        url: '/login/forgotpassword',
                        templateUrl: 'templates/entry/login-tabs-forgotpassword.html',
                        controller: 'LoginForgotPasswordCtrl'

                    })

                    /// Index->Login page
                    .state('login-auto', {
                        cache: false,
                        url: '/login/server-token/:serverToken',
                        templateUrl: 'templates/entry/login-tabs.html',
                        controller: 'AutoLoginCtrl'
                    })

                    /// Index->Login page->Group tab
                    .state('login-auto-group-tab', {
                        cache: false,
                        url: '/login/server-token/:serverToken/tab/:tab',
                        templateUrl: 'templates/entry/login-tabs.html',
                        controller: 'AutoLoginCtrl'
                    })

                
                    // Redirect links passed to mobile app to correct point in app
                    .state('redirectgiftlist', {
                        cache: false,
                        url: '/r/shop/member/:memberID/list/:listID/locator/:locator',
                        controller: 'redirectToGiftListCtrl'
                    })

                    // Redirect request to group tab, taking into account if user not signed in
                    .state('redirectgrouptab', {
                        cache: false,
                        url: '/r/groups',
                        controller: 'redirectToGroupsTabCtrl'
                    })

                    // Redirect request to my lists tab, taking into account if user not signed in
                    .state('redirectliststab', {
                        cache: false,
                        url: '/r/lists',
                        controller: 'redirectToListsCtrl'
                    })


                    ///End Index->Login page

                    .state('search', {
                        url: '/search',
                        templateUrl: 'templates/search/search.html',
                        controller: 'SearchCtrl'
                    })
                    .state('search-results', {
                        url: '/search/:name/:tab',
                        templateUrl: 'templates/search/search-results.html',
                        controller: 'SearchResultsCtrl'
                    })
                    .state('search-result-member', {
                        cache: false,
                        url: '/search/result/:memberId',
                        templateUrl: 'templates/search/search-memberlists.html',
                        controller: 'SearchResultMemberCtrl'
                    })
                    //shopforothers->memberlists->memberpreferences
                    .state('search-preferences', {
                        url: '/search/result/:memberId/preferences/:tab',
                        templateUrl: 'templates/search/search-preferences.html',
                        controller: 'SearchPreferencesCtrl'

                    })
                    .state('search-mylists-list', {
                        cache: false,
                        url: '/search/result/mylists/:mylistId/:tab/type/:type',
                        templateUrl: 'templates/mylists/mylists-list.html',
                        controller: 'MyListsListCtrl'
                    })
                    .state('search-memberlists-list', {
                        cache: false,
                        url: '/search/result/:memberlistId/list/:listId/tab/:tab',
                        //url: '/groups/:memberlistId/list/:listId/tab/:tab',
                        templateUrl: 'templates/shop/memberlists-list.html',
                        controller: 'MemberListsListCtrl'

                    })
                    .state('search-mylists-list-item', {
                        cache: false,
                        // url: '/search/result/mylists/:memberlistId/list/:listId/item/:listitemId/tab/:tab/type/:type',
                        url: '/search/result/:memberlistId/list/:listId/item/:listitemId/tab/:tab/type/:type',
                        templateUrl: 'templates/mylists/list-item.html',
                        controller: 'MemberListsListItemCtrl'
                    })
                    //
                    .state('about', {
                        url: '/about',
                        templateUrl: 'templates/about.html',
                        controller: 'AboutCtrl'

                    })

                    // setup an abstract state for the tabs directive
                    .state('tab', {
                        url: "/tab",
                        abstract: true,
                        templateUrl: "templates/tabs.html",
                        controller: 'MainCtrl'
                    })

                    ///
                    /// Index->Login page with tab2 (not works good)/////
                    ///

                    .state('tab2', {
                        // cache: true,
                        url: "/tab2",
                        abstract: true,
                        templateUrl: "templates/tabs2.html"
                    })
                    .state('tab2.login', {
                        cache: false,
                        url: '/login',
                        views: {
                            'tab2-login': {
                                templateUrl: 'templates/entry/login.html',
                                controller: 'LoginCtrl'
                            }
                        }
                    })
                    .state('tab2.login-forgotpassword', {
                        cache: false,
                        url: '/login/forgotpassword',
                        views: {
                            'tab2-login': {
                                templateUrl: 'templates/entry/forgotpassword.html',
                                controller: 'ForgotPasswordCtrl'
                            }
                        }
                    })
                    .state('tab2.search', {
                        cache: false,
                        url: '/search',
                        views: {
                            'tab2-search': {
                                templateUrl: 'templates/entry/search.html',
                                controller: 'SearchTabsCtrl'
                            }
                        }
                    })
                    //search -> search results
                    .state('tab2.search-results', {
                        url: '/search/:name',
                        views: {
                            'tab2-search': {
                                templateUrl: 'templates/search/search-results.html',
                                controller: 'SearchResultsCtrl'
                            }
                        }
                    })
                    //search -> search results-> select member
                    .state('tab2.search-result-member', {
                        url: '/search/result/:memberId',
                        views: {
                            'tab2-search': {
                                templateUrl: 'templates/search/search-memberlists.html',
                                controller: 'SearchResultMemberCtrl'
                            }
                        }
                    })
                    //search -> search results-> select member->memberpreferences
                    .state('tab2.search-preferences', {
                        url: '/search/preferences/:memberId',
                        views: {
                            'tab2-search': {
                                templateUrl: 'templates/search/search-preferences.html',
                                controller: 'SearchPreferencesCtrl'
                            }
                        }
                    })
                    //search -> search results-> select member->public lists
                    .state('tab2.search-mylists-list', {
                        cache: false,
                        url: '/search/result/mylists/:mylistId/:tab/type/:type',
                        views: {
                            'tab2-search': {
                                templateUrl: 'templates/mylists/mylists-list.html',
                                controller: 'MyListsListCtrl'
                            }
                        }
                    })
                    /// /END Index->Login page with tab2/////

                    // Each tab has its own nav history stack:
                    // 
                    // Tab Shop (firstsecond)
                    // 
                    //shopforothers
                    .state('tab.members', {
                        cache: false,
                        url: '/members',
                        views: {
                            'tab-members': {
                                templateUrl: 'templates/tab-shop.html',
                                controller: 'MembersCtrl'
                            }
                        }
                    })//
                    .state('tab.shop-groups-add-edit', {
                        cache: false,
                        url: '/members/addeditgroup/:name/tab/:tab',
                        views: {
                            'tab-members': {
                                templateUrl: 'templates/groups/groups-add-edit.html',
                                controller: 'GroupsAddEditCtrl'
                            }
                        }
                    })
                    .state('tab.shop-search', {
                        cache: false,
                        url: '/members/search/:tab',
                        views: {
                            'tab-members': {
                                templateUrl: 'templates/search/search.html',
                                controller: 'SearchCtrl'
                            }
                        }
                    })
                    //tab shop->search->results
                    .state('tab.shop-search-results', {
                        url: '/members/search/:name/tab/:tab',
                        views: {
                            'tab-members': {
                                templateUrl: 'templates/search/search-results.html',
                                controller: 'SearchResultsCtrl'
                            }
                        }
                    })
                    //tab shop->search->results->member
                    .state('tab.shop-search-result-member', {
                        cache: false,
                        url: '/members/search/result/:memberId/:tab',
                        views: {
                            'tab-members': {
                                templateUrl: 'templates/search/search-memberlists.html',
                                controller: 'SearchResultMemberCtrl'
                            }
                        }
                    })
                    .state('tab.shop-search-preferences', {
                        url: '/members/search/preferences/:memberId/:tab',
                        views: {
                            'tab-members': {
                                templateUrl: 'templates/search/search-preferences.html',
                                controller: 'SearchPreferencesCtrl'
                            }
                        }
                    })
                    .state('tab.shop-search-mylists-list', {
                        cache: false,
                        url: '/members/search/mylists/:mylistId/:tab/type/:type',
                        views: {
                            'tab-members': {
                                templateUrl: 'templates/mylists/mylists-list.html',
                                controller: 'MyListsListCtrl'
                            }
                        }
                    })
                    //more search -> search results-> select member->public lists -> sendreminder
                    .state('tab.shop-search-mylists-list-sendreminder', {
                        cache: false,
                        url: '/members/search/result/mylists/:mylistId/sendreminder/:tab',
                        views: {
                            'tab-members': {
                                templateUrl: 'templates/search/search-sendreminder.html',
                                controller: 'SearchSendRemindertCtrl'
                            }
                        }
                    })

                    //tab.members-mylists-add
                    .state('tab.shop-mylists-add', {
                        cache: false,
                        url: '/members/mylists/addlist/:idchild/tab/:tab',
                        views: {
                            'tab-members': {
                                templateUrl: 'templates/mylists/mylists-add.html',
                                controller: 'MyListsAddCtrl'
                            }
                        }
                    })

                    //shopforothers->shoppinglist
                    .state('tab.shop-shoppinglist', {
                        cache: false,
                        url: '/members/shoppinglist/:tab',
                        views: {
                            'tab-members': {
                                templateUrl: 'templates/shop/shop-shoppinglist.html',
                                controller: 'ShoppingListsCtrl'
                            }
                        }
                    })
                    //shopforothers->memberlists
                    .state('tab.shop-memberlists', {
                        cache: false,
                        url: '/members/:memberlistId/:name/tab/:tab',
                        views: {
                            'tab-members': {
                                templateUrl: 'templates/shop/shop-memberlists.html',
                                controller: 'MemberListsCtrl'
                            }
                        }
                    })
                    .state('tab.shop-childaccounts-create-edit', {
                        url: '/members/tab/:tab/:name/id/:idchild',
                        views: {
                            'tab-members': {
                                templateUrl: 'templates/mylists/mylists-childaccounts-create-edit.html',
                                controller: 'MyListsCreateEditChildAccountCtrl'
                            }
                        }
                    })
                    //shopforothers->memberlists->Preferences
                    .state('tab.shop-memberlists-preferences', {
                        url: '/members/preferences/:memberId',
                        views: {
                            'tab-members': {
                                templateUrl: 'templates/search/search-preferences.html',
                                controller: 'MemberListsPreferencesCtrl'
                            }
                        }
                    })

                    //shopforothers->memberlists->list
                    //shop/list/{{member.id
                    .state('tab.memberlists-list', {
                        cache: false,
                        url: '/members/:memberlistId/list/:listId/tab/:tab',
                        views: {
                            'tab-members': {
                                templateUrl: 'templates/shop/memberlists-list.html',
                                controller: 'MemberListsListCtrl'
                            }
                        }
                    })
                    .state('tab.shop-list-item', {
                        url: '/members/:memberlistId/list/:listId/item/:listitemId/tab/:tab',
                        views: {
                            'tab-members': {
                                templateUrl: 'templates/mylists/list-item.html',
                                controller: 'MemberListsListItemCtrl'
                            }
                        }
                    })
                    //shopforothers->memberlists->list
                    //members/list/item/{{listitem.id}
                    .state('tab.list-item', {
                        url: '/members/:memberlistId/list/:listId/item/:listitemId/tab/:tab',
                        views: {
                            'tab-members': {
                                templateUrl: 'templates/mylists/list-item.html',
                                controller: 'MemberListsListItemCtrl'
                            }
                        }
                    })

                    .state('tab.shop-memberlists-addlist', {
                        cache: false,
                        url: '/members/:memberlistId/name/:name/addlist/:tab',
                        views: {
                            'tab-members': {
                                templateUrl: 'templates/mylists/mylists-add.html',
                                controller: 'MyListsAddCtrl' //'MemberListsAddCtrl'
                            }
                        }
                    })

                    //if my own->mylists
                    .state('tab.shop-preferences', {
                        cache: false,
                        url: '/members/mylists/:tab',
                        views: {
                            'tab-members': {
                                templateUrl: 'templates/tab-mylists.html',
                                controller: 'PreferencesCtrl'
                            }
                        }
                    })
                    //if my own->mylists->list
                    .state('tab.shop-mylists-list', {
                        cache: false,
                        url: '/members/mylists/:mylistId/tab/:tab/type/:type',
                        views: {
                            'tab-members': {
                                templateUrl: 'templates/mylists/mylists-list.html',
                                controller: 'MyListsListCtrl'
                            }
                        }
                    })
                    //if my own->mylists->list  -> sendreminder
                    .state('tab.shop-mylists-preferences', {
                        cache: false,
                        url: '/members/mylists/preferences/:memberId/:name', //url: '/members/mylists/:mylistId/sendreminder/:tab',
                        views: {
                            'tab-members': {
                                templateUrl: 'templates/mylists/mylists-preferences.html',
                                controller: 'MyListsPreferencesCtrl'
                            }
                        }
                    })
                    //if my own->mylists->list  -> viewchildaccounts
                    .state('tab.shop-mylists-viewchildaccounts', {
                        cache: false,
                        url: '/members/mylists/viewchildaccounts/:tab',
                        views: {
                            'tab-members': {
                                templateUrl: 'templates/mylists/mylists-viewchildaccounts.html',
                                controller: 'MyListsViewChildAccountCtrl'
                            }
                        }
                    })
                    //if my own->mylists->list  -> childaccounts
                    .state('tab.shop-mylists-childaccounts', {
                        url: '/members/mylists/childaccounts/:tab',
                        views: {
                            'tab-members': {
                                templateUrl: 'templates/mylists/mylists-childaccounts.html',
                                controller: 'MyListsAddChildAccountCtrl'
                            }
                        }
                    })
                    //if my own->mylists->list  -> childaccounts -> create-edit
                    .state('tab.shop-mylists-childaccounts-create-edit', {
                        url: '/members/mylists/childaccounts/createedit/tab/:tab/:name/id/:idchild',
                        views: {
                            'tab-members': {
                                templateUrl: 'templates/mylists/mylists-childaccounts-create-edit.html',
                                controller: 'MyListsCreateEditChildAccountCtrl'
                            }
                        }
                    })
                    //if my own->mylists->list  -> childaccounts -> selectChildAccount
                    .state('tab.shop-mylists-memberlists', {
                        cache: false,
                        url: '/members/mylists/viewchildaccounts/:memberlistId/:name/:tab',
                        views: {
                            'tab-members': {
                                templateUrl: 'templates/shop/shop-memberlists.html',
                                controller: 'MemberListsCtrl'
                            }
                        }
                    })
                    //if my own->mylists->settings
                    .state('tab.shop-mylists-settings', {
                        cache: false,
                        url: '/members/mylists/:mylistId/settings/:tab',
                        views: {
                            'tab-members': {
                                templateUrl: 'templates/mylists/mylists-settings.html',
                                controller: 'MyListsSettingsCtrl'
                            }
                        }
                    })

                    // Add an item in shop for view (most likely suggested item)
                    .state('tab.shop-item-add', {
                        cache: false,
                        url: '/members/mylists/:mylistId/type/:type/suggested/:suggested/tab/:tab',
                        views: {
                            'tab-members': {
                                templateUrl: 'templates/item/item-update.html',
                                controller: 'MyListsListItemUpdateCtrl'
                            }
                        }
                    })

                    // Add an item in groups view (most likely suggested item)
                    .state('tab.groups-item-add', {
                        cache: false,
                        url: '/groups/wishlist/:mylistId/type/:type/suggested/:suggested/tab/:tab',
                        views: {
                            'tab-groups': {
                                templateUrl: 'templates/item/item-update.html',
                                controller: 'MyListsListItemUpdateCtrl'
                            }
                        }
                    })                    

                    // Add an item in more -> search view (most likely suggested item)
                    .state('tab.more-item-add', {
                        cache: false,
                        // url: '/more/search/result/:memberlistId/list/:mylistId/type/:type/suggested/:suggestedtab/:tab',
                        url: '/more/members/:memberID/list/:mylistId/type/:type/suggested/:suggested/tab/:tab',
                         views: {
                            'tab-more': {
                                templateUrl: 'templates/item/item-update.html',
                                controller: 'MyListsListItemUpdateCtrl'
                            }
                        }
                    })   

                    // Update a suggested item from the shop for tab
                    .state('tab.shop-item-update', {
                        cache: false,
                        url: '/members/:memberID/list/:mylistId/item/:itemId/type/:type/suggested/:suggested/tab/:tab',
                        views: {
                            'tab-members': {
                                templateUrl: 'templates/item/item-update.html',
                                controller: 'MyListsListItemUpdateCtrl'
                            }
                        }
                    })

                    // Update a suggested item from the groups tab
                    .state('tab.groups-item-update', {
                        cache: false,
                        url: '/groups/members/:memberID/list/:mylistId/item/:itemId/type/:type/suggested/:suggested/tab/:tab',
                        views: {
                            'tab-groups': {
                                templateUrl: 'templates/item/item-update.html',
                                controller: 'MyListsListItemUpdateCtrl'
                            }
                        }
                    })

                    // Update a suggested item from the more (my shopping list) tab
                    .state('tab.more-item-update', {
                        cache: false,
                        url: '/more/members/:memberID/list/:mylistId/item/:itemId/type/:type/suggested/:suggested/tab/:tab',
                        views: {
                            'tab-more': {
                                templateUrl: 'templates/item/item-update.html',
                                controller: 'MyListsListItemUpdateCtrl'
                            }
                        }
                    })



                    //
                    // Tab Lists (second)
                    // 
                    //Preferences
                    .state('tab.preferences', {
                        cache: false,
                        url: '/mylists',
                        views: {
                            'tab-preferences': {
                                templateUrl: 'templates/tab-mylists.html',
                                controller: 'PreferencesCtrl'
                            }
                        }
                    })

                    //shopforothers->memberlists->memberpreferences
                    .state('tab.mylists-preferences', {
                        url: '/mylists/preferences/:memberId/:name',
                        views: {
                            'tab-preferences': {
                                templateUrl: 'templates/mylists/mylists-preferences.html',
                                controller: 'MyListsPreferencesCtrl'
                            }
                        }
                    })
                    .state('tab.mylists-viewchildaccounts', {
                        cache: false,
                        url: '/mylists/viewchildaccounts/:tab',
                        views: {
                            'tab-preferences': {
                                templateUrl: 'templates/mylists/mylists-viewchildaccounts.html',
                                controller: 'MyListsViewChildAccountCtrl'
                            }
                        }
                    })
                    .state('tab.mylists-childaccounts', {
                        url: '/mylists/childaccounts/:tab',
                        views: {
                            'tab-preferences': {
                                templateUrl: 'templates/mylists/mylists-childaccounts.html',
                                controller: 'MyListsAddChildAccountCtrl'
                            }
                        }
                    })
                    .state('tab.mylists-memberlists', {
                        cache: false,
                        url: '/mylists/viewchildaccounts/:memberlistId/:name/:tab',
                        views: {
                            'tab-preferences': {
                                templateUrl: 'templates/shop/shop-memberlists.html',
                                controller: 'MemberListsCtrl'
                            }
                        }
                    })
                    .state('tab.mylists-suggested-items', {
                        cache: false,
                        url: '/mylists/mysuggesteditems/',
                        views: {
                            'tab-preferences': {
                                templateUrl: 'templates/mylists/mylists-suggested-items.html',
                                controller: 'MyListsSuggestedItemsCtrl'
                            }
                        }
                    })
                    .state('tab.mylists-suggested-items-help', {
                        cache: false,
                        url: '/mylists/mysuggesteditems/help/',
                        views: {
                            'tab-preferences': {
                                templateUrl: 'templates/mylists/suggested-items-help.html',
                                controller: 'SuggestedItemsHelpCtrl'
                            }
                        }
                    })

                    .state('tab.mylists-childaccounts-create-edit', {
                        url: '/mylists/childaccounts/createedit/tab/:tab/:name/id/:idchild',
                        views: {
                            'tab-preferences': {
                                templateUrl: 'templates/mylists/mylists-childaccounts-create-edit.html',
                                controller: 'MyListsCreateEditChildAccountCtrl'
                            }
                        }
                    })

                    //mylists->add list
                    .state('tab.mylists-add', {
                        cache: false,
                        url: '/mylists/addlist/:idchild/tab/:tab',
                        views: {
                            'tab-preferences': {
                                templateUrl: 'templates/mylists/mylists-add.html',
                                controller: 'MyListsAddCtrl'
                            }
                        }
                    })
                    //mylists->list
                    .state('tab.mylists-list', {
                        cache: false,
                        url: '/mylists/:mylistId/tab/:tab/type/:type',
                        views: {
                            'tab-preferences': {
                                templateUrl: 'templates/mylists/mylists-list.html',
                                controller: 'MyListsListCtrl'
                            }
                        }
                    })

                    //mylists->list->updateitem
                    //#/tab/mylists/498323/updateitem
                    .state('tab.item-update', {
                        cache: false,
                        url: '/mylists/:mylistId/updateitem/:itemId/type/:type/tab/:tab',
                        views: {
                            'tab-preferences': {
                                templateUrl: 'templates/item/item-update.html',
                                controller: 'MyListsListItemUpdateCtrl'
                            }
                        }
                    })

                    //mylists->suggested items -> update item
                    .state('tab.item-update-suggested', {
                        cache: false,
                        url: '/mylists/:mylistId/updateitem/:itemId/type/:type/:suggested/suggested/tab/:tab',
                        views: {
                            'tab-preferences': {
                                templateUrl: 'templates/item/item-update.html',
                                controller: 'MyListsListItemUpdateCtrl'
                            }
                        }
                    })

                    //mylists->list->additem
                    //#/tab/mylists/additem
                    .state('tab.item-add', {
                        cache: false,
                        url: '/mylists/:mylistId/type/:type/tab/:tab',
                        views: {
                            'tab-preferences': {
                                templateUrl: 'templates/item/item-update.html',
                                controller: 'MyListsListItemUpdateCtrl'
                            }
                        }
                    })
                    //mylists->settings
                    .state('tab.mylists-settings', {
                        cache: false,
                        url: '/mylists/:mylistId/settings/:tab',
                        views: {
                            'tab-preferences': {
                                templateUrl: 'templates/mylists/mylists-settings.html',
                                controller: 'MyListsSettingsCtrl'
                            }
                        }
                    })
                    //
                    //Tab News
                    //
                    .state('tab.news', {
                        cache: false,
                        url: '/news',
                        views: {
                            'tab-news': {
                                templateUrl: 'templates/tab-news.html',
                                controller: 'NewsCtrl'
                            }
                        }
                    })
                    //groups->add/edit group
                    .state('tab.news-add-edit', {
                        cache: false,
                        url: '/news/:name/tab/:tab', //addeditgroup
                        views: {
                            'tab-news': {
                                templateUrl: 'templates/groups/groups-add-edit.html',
                                controller: 'GroupsAddEditCtrl'
                            }
                        }
                    })
                    .state('tab.news-search', {
                        url: '/news/search/:tab',
                        views: {
                            'tab-news': {
                                templateUrl: 'templates/search/search.html',
                                controller: 'SearchCtrl'
                            }
                        }
                    })
                    .state('tab.news-search-results', {
                        url: '/news/search/:name/:tab',
                        views: {
                            'tab-news': {
                                templateUrl: 'templates/search/search-results.html',
                                controller: 'SearchResultsCtrl'
                            }
                        }
                    })
                    //tab-news->memberlists->memberpreferences
                    .state('tab.news-search-preferences', {
                        url: '/news/search/preferences/:memberId/:tab',
                        views: {
                            'tab-news': {
                                templateUrl: 'templates/search/search-preferences.html',
                                controller: 'SearchPreferencesCtrl'
                            }
                        }
                    })
                    //tab-news search -> search results-> select member
                    .state('tab.news-search-result-member', {
                        cache: false,
                        url: '/news/search/result/:memberId/:tab',
                        views: {
                            'tab-news': {
                                templateUrl: 'templates/search/search-memberlists.html',
                                controller: 'SearchResultMemberCtrl'
                            }
                        }
                    })
                    //tab-news search -> search results-> select member->public lists
                    .state('tab.news-search-mylists-list', {
                        cache: false,
                        url: '/news/search/result/mylists/:mylistId/:tab/type/:type',
                        views: {
                            'tab-news': {
                                templateUrl: 'templates/mylists/mylists-list.html',
                                controller: 'MyListsListCtrl'
                            }
                        }
                    })

                    //tab-news search -> search results-> select member->public lists -> sendreminder
                    .state('tab.news-search-mylists-list-sendreminder', {
                        cache: false,
                        url: '/news/search/result/mylists/:mylistId/sendreminder/:tab',
                        views: {
                            'tab-news': {
                                templateUrl: 'templates/search/search-sendreminder.html',
                                controller: 'SearchSendRemindertCtrl'
                            }
                        }
                    })

                    //
                    //Tab Groups
                    //
                    .state('tab.groups', {
                        cache: false,
                        url: '/groups',
                        views: {
                            'tab-groups': {
                                templateUrl: 'templates/tab-groups.html',
                                controller: 'GroupsCtrl'
                            }
                        }
                    })
                    .state('tab.groups-manage', {
                        cache: false,
                        url: '/groups/created/:groupId/type/:type',
                        views: {
                            'tab-groups': {
                                templateUrl: 'templates/groups/groups-manage.html',
                                controller: 'GroupsManageCtrl'
                            }
                        }
                    })
                    .state('tab.groups-invite', {
                        cache: false,
                        url: '/groups/invite/:groupId',
                        views: {
                            'tab-groups': {
                                templateUrl: 'templates/groups/groups-invite.html',
                                controller: 'GroupsInviteCtrl'
                            }
                        }
                    })
                    //groups->add/edit group
                    .state('tab.groups-add-edit', {
                        cache: false,
                        url: '/groups/:name/tab/:tab', //addeditgroup
                        views: {
                            'tab-groups': {
                                templateUrl: 'templates/groups/groups-add-edit.html',
                                controller: 'GroupsAddEditCtrl'
                            }
                        }
                    })
                    .state('tab.groups-search', {
                        url: '/groups/search/:tab',
                        views: {
                            'tab-groups': {
                                templateUrl: 'templates/search/search.html',
                                controller: 'SearchCtrl'
                            }
                        }
                    })
                    .state('tab.groups-search-results', {
                        url: '/groups/search/:name/:tab',
                        views: {
                            'tab-groups': {
                                templateUrl: 'templates/search/search-results.html',
                                controller: 'SearchResultsCtrl'
                            }
                        }
                    })
                    //shopforothers->memberlists->memberpreferences
                    .state('tab.groups-search-preferences', {
                        url: '/groups/search/preferences/:memberId/:tab',
                        views: {
                            'tab-groups': {
                                templateUrl: 'templates/search/search-preferences.html',
                                controller: 'SearchPreferencesCtrl'
                            }
                        }
                    })
                    //groups search -> search results-> select member
                    .state('tab.groups-search-result-member', {
                        cache: false,
                        url: '/groups/search/result/:memberId/:tab',
                        views: {
                            'tab-groups': {
                                templateUrl: 'templates/search/search-memberlists.html',
                                controller: 'SearchResultMemberCtrl'
                            }
                        }
                    })
                    //groups search -> search results-> select member->public lists
                    .state('tab.groups-search-mylists-list', {
                        cache: false,
                        url: '/groups/search/result/mylists/:mylistId/:tab/type/:type',
                        views: {
                            'tab-groups': {
                                templateUrl: 'templates/mylists/mylists-list.html',
                                controller: 'MyListsListCtrl'
                            }
                        }
                    })
                    //groups search -> search results-> select member->public lists -> sendreminder
                    .state('tab.groups-search-mylists-list-sendreminder', {
                        cache: false,
                        url: '/groups/search/result/mylists/:mylistId/sendreminder/:tab',
                        views: {
                            'tab-groups': {
                                templateUrl: 'templates/search/search-sendreminder.html',
                                controller: 'SearchSendRemindertCtrl'
                            }
                        }
                    })
                    .state('tab.groups-memberlists', {
                        cache: false,
                        url: '/groups/:memberlistId/:name/:tab',
                        views: {
                            'tab-groups': {
                                templateUrl: 'templates/shop/shop-memberlists.html',
                                controller: 'MemberListsCtrl'
                            }
                        }
                    })
                    .state('tab.groups-memberlists-list', {
                        cache: false,
                        url: '/groups/:memberlistId/list/:listId/tab/:tab',
                        views: {
                            'tab-groups': {
                                templateUrl: 'templates/shop/memberlists-list.html',
                                controller: 'MemberListsListCtrl'
                            }
                        }
                    })
                    .state('tab.groups-childaccounts-create-edit', {
                        cache: false,
                        url: '/groups/tab/:tab/:name/id/:idchild',
                        views: {
                            'tab-groups': {
                                templateUrl: 'templates/mylists/mylists-childaccounts-create-edit.html',
                                controller: 'MyListsCreateEditChildAccountCtrl'
                            }
                        }
                    })
                    // .state('tab.list-item', {
                    //  url: '/members/:memberlistId/list/:listId/item/:listitemId/tab/:tab',
                    .state('tab.groups-list-item', {
                        cache: false,
                        url: '/groups/:memberlistId/list/:listId/item/:listitemId/tab/:tab/:type',
                        views: {
                            'tab-groups': {
                                templateUrl: 'templates/mylists/list-item.html',
                                controller: 'MemberListsListItemCtrl'
                            }
                        }
                    })
                    .state('tab.groups-memberlists-preferences', {
                        url: '/groups/memberlists/preferences/:memberId',
                        views: {
                            'tab-groups': {
                                templateUrl: 'templates/search/search-preferences.html',
                                controller: 'MemberListsPreferencesCtrl'
                            }
                        }
                    })
                    //END SEARCH

                    //
                    //tab MORE
                    //
                    .state('tab.more', {
                        cache: false,
                        url: '/more',
                        views: {
                            'tab-more': {
                                templateUrl: 'templates/tab-more.html',
                                controller: 'MoreCtrl'
                            }
                        }
                    })
                    //tab more->quickstart
                    .state('tab.more-quickstart', {
                        url: '/more/quickstart/:tab',
                        views: {
                            'tab-more': {
                                templateUrl: 'templates/more/more-quickstart.html',
                                controller: 'QuickStartCtrl'
                            }
                        }
                    })
                    //tab more->quickstart->groups-add-edit
                    .state('tab.more-groups-add-edit', {
                        cache: false,
                        url: '/more/addgroup/:name/tab/:tab',
                        views: {
                            'tab-more': {
                                templateUrl: 'templates/groups/groups-add-edit.html',
                                controller: 'GroupsAddEditCtrl'
                            }
                        }
                    })
                    //tab more->quickstart->search
                    .state('tab.more-search', {
                        cache: false,
                        url: '/more/search/:tab',
                        views: {
                            'tab-more': {
                                templateUrl: 'templates/search/search.html',
                                controller: 'SearchCtrl'
                            }
                        }
                    })
                    //tab more->quickstart->search->results
                    .state('tab.more-search-results', {
                        url: '/more/search/:name/tab/:tab',
                        views: {
                            'tab-more': {
                                templateUrl: 'templates/search/search-results.html',
                                controller: 'SearchResultsCtrl'
                            }
                        }
                    })
                    .state('tab.more-search-result-member', {
                        cache: false,
                        url: '/more/search/result/:memberId/:tab',
                        views: {
                            'tab-more': {
                                templateUrl: 'templates/search/search-memberlists.html',
                                controller: 'SearchResultMemberCtrl'
                            }
                        }
                    })
                    .state('tab.more-search-preferences', {
                        url: '/more/search/preferences/:memberId/:tab',
                        views: {
                            'tab-more': {
                                templateUrl: 'templates/search/search-preferences.html',
                                controller: 'SearchPreferencesCtrl'
                            }
                        }
                    })
                    .state('tab.more-search-mylists-list', {
                        cache: false,
                        url: '/more/search/result/:memberlistId/list/:listId/tab/:tab',
                        views: {
                            'tab-more': {
                                templateUrl: 'templates/shop/memberlists-list.html',
                                controller: 'MemberListsListCtrl'
                            }
                        }
                    })
                    //more search -> search results-> select member->public lists -> sendreminder
                    .state('tab.more-search-mylists-list-sendreminder', {
                        cache: false,
                        url: '/more/search/result/mylists/:mylistId/sendreminder/:tab',
                        views: {
                            'tab-more': {
                                templateUrl: 'templates/search/search-sendreminder.html',
                                controller: 'SearchSendRemindertCtrl'
                            }
                        }
                    })
                    //more search -> settings
                    .state('tab.more-settings', {
                        cache: false,
                        url: '/more/settings',
                        views: {
                            'tab-more': {
                                templateUrl: 'templates/more/more-mysettings.html',
                                controller: 'MoreMySettingsCtrl'
                            }
                        }
                    })

                    //END SEARCH

                    //tab more->quickstart->mylists-add
                    .state('tab.more-mylists-add', {
                        cache: false,
                        url: '/addlist/:tab',
                        views: {
                            'tab-more': {
                                templateUrl: 'templates/mylists/mylists-add.html',
                                controller: 'MyListsAddCtrl'
                            }
                        }
                    })

                    .state('tab.more-shoppinglist', {
                        cache: false,
                        url: '/more/shoppinglist/:tab',
                        views: {
                            'tab-more': {
                                templateUrl: 'templates/shop/shop-shoppinglist.html',
                                controller: 'ShoppingListsCtrl'
                            }
                        }
                    })
                    .state('tab.more-shoppinglist-list-item', {
                        cache: false,
                        url: '/more/shoppinglist/:memberlistId/list/:listId/item/:listitemId/tab/:tab',
                        views: {
                            'tab-more': {
                                templateUrl: 'templates/mylists/list-item.html',
                                controller: 'MemberListsListItemCtrl'
                            }
                        }
                    })
                    .state('tab.more-events', {
                        cache: false,
                        url: '/more/events',
                        views: {
                            'tab-more': {
                                templateUrl: 'templates/more/more-events.html',
                                controller: 'EventsCtrl'
                            }
                        }
                    })
                    .state('tab.more-blog', {
                        //cache: false,
                        url: '/more/blog',
                        views: {
                            'tab-more': {
                                templateUrl: 'templates/more/more-blog.html',
                                controller: 'BlogCtrl'
                            }
                        }
                    })
                    .state('tab.more-about', {
                        cache: false,
                        url: '/more/about',
                        views: {
                            'tab-more': {
                                templateUrl: 'templates/more/more-about.html',
                                controller: 'AboutCtrl'
                            }
                        }
                    })
                    .state('timeoutHelper', {
                        cache: false,
                        url: '/timeout',
                        templateUrl: 'templates/timeout.html',
                        controller: 'TimeOutCtrl'
                    })
                    ;

            // if none of the above states are matched, use this as the fallback
            //$urlRouterProvider.otherwise('/tab/members');
            //$urlRouterProvider.otherwise('/login');
            $urlRouterProvider.otherwise('/index');
        });
