angular.module('starter.services', [])

        .factory(
                "transformRequestAsFormPost",
                function() {
                    // I prepare the request data for the form post.
                    function transformRequest(data, getHeaders) {
                        var headers = getHeaders();
                        //headers[ "Content-type" ] = "application/x-www-form-urlencoded; charset=utf-8";
                        headers[ "Content-type" ] = "application/x-www-form-urlencoded; charset=utf-8";
                        return(serializeData(data));
                    }
                    // Return the factory value.
                    return(transformRequest);

                    // ---0
                    // PRVIATE METHODS.
                    // I serialize the given Object into a key-value pair string. This method expects an object and will default to the toString() method.
                    // NOTE: This is an atered version of the jQuery.param() method which will serialize a data collection for Form posting.
                    // --
                    // https://github.com/jquery/jquery/blob/master/src/serialize.js#L45
                    function serializeData(data) {
                        // If this is not an object, defer to native stringification.
                        if (!angular.isObject(data)) {
                            return((data === null) ? "" : data.toString());
                        }
                        var buffer = [];
                        // Serialize each key in the object.
                        for (var name in data) {
                            if (!data.hasOwnProperty(name)) {
                                continue;
                            }
                            var value = data[ name ];
                            buffer.push(
                                    encodeURIComponent(name) +
                                    "=" +
                                    encodeURIComponent((value === null) ? "" : value)
                                    );
                        }
                        // Serialize the buffer and clean it up for transportation.
                        var source = buffer
                                .join("&")
                                .replace(/%20/g, "+");
                        return(source);
                    }
                }
        )

        .factory('$localstorage', ['$window', function($window) {
                return {
                    set: function(key, value) {
                        $window.localStorage[key] = value;
                    },
                    get: function(key, defaultValue) {
                        return $window.localStorage[key] || defaultValue;
                    },
                    setObject: function(key, value) {
                        $window.localStorage[key] = JSON.stringify(value);
                    },
                    getObject: function(key) {
                        return JSON.parse($window.localStorage[key] || '{}');
                    },
                    clear: function() {
                        $window.localStorage.clear();
                    },
                    destroy: function(key) {
                        $window.localStorage.removeItem(key);
                    }
                };
            }])
//requests
        .factory('RequestsAPI', function($http, apiUrl, $ionicLoading) {
            return {
                post: function(methodUrl, params) {
                    return $http({
                        method: "post",
                        url: apiUrl + methodUrl,
                        headers: {'Content-Type': 'application/x-www-form-urlencoded; charset=utf-8'},
                        data: $.param(params),
                        timeout: 60000
                    }).success(function(response) {
                        console.log('response: ', response);
                        return response;
                    });
                },
                get: function(methodUrl, login_token) {                    
                    
                    auth_string = '';

                    if (login_token) { 
                        auth_string = '?login_token=' + login_token;
                    }

                    return $http({
                        method: "GET",
                        url: apiUrl + methodUrl + auth_string
                    }).success(function(response) {
                        console.log('response: ', response);
                        return response;
                    });
                },                
                put: function(methodUrl, params) {
                    return $http({
                        method: "PUT",
                        url: apiUrl + methodUrl,
                        headers: {'Content-Type': 'application/x-www-form-urlencoded'},
                        data: $.param(params)
                    }).success(function(response) {
                        console.log('response: ', response);
                        return response;
                    });
                },
                delete: function(methodUrl, params) {
                    return $http({
                        method: "DELETE",
                        url: apiUrl + methodUrl,
                        headers: {'Content-Type': 'application/x-www-form-urlencoded'},
                        data: $.param(params)
                    }).success(function(response) {
                        console.log('response: ', response);
                        return response;
                    });
                }

            };
        })
        .factory('customElements', function($ionicPopup, $ionicHistory) {
            return {
                popup: function(title, template, text1, type1, text2, type2) {
                    return $ionicPopup.show({
                        template: template,
                        title: title,
                        buttons: [{
                                text: text1,
                                type: type1,
                                onTap: function() {
                                    return false;
                                }
                            }, {
                                text: text2,
                                type: type2,
                                onTap: function() {
                                    return true;
                                }
                            }
                        ]
                    });
                },
                alert: function(title, template, text, type, cssClass) {
                    cssClass = cssClass || '';

                    $ionicPopup.alert({
                        template: template,
                        title: title,
                        cssClass: cssClass,
                        buttons: [{
                                text: text,
                                type: type,
                                onTap: function() {
                                    return true;
                                }
                            }]
                    });
                },
                dateResult: function(newDate) {
                    // Set the unit values in milliseconds.
                    var msecPerMinute = 1000 * 60;
                    var msecPerHour = msecPerMinute * 60;
                    var msecPerDay = msecPerHour * 24;

                    // Set a date and get the milliseconds
                    var date = new Date(newDate);
                    var dateNow = new Date();
                    var dateMsec = dateNow.getTime();

                    // Get the difference in milliseconds.
                    var interval = dateMsec - date.getTime();

                    // Calculate how many days the interval contains. Subtract that
                    // many days from the interval to determine the remainder.
                    var days = Math.floor(interval / msecPerDay);
                    interval = interval - (days * msecPerDay);

                    // Calculate the hours, minutes, and seconds.
                    var hours = Math.floor(interval / msecPerHour);
                    interval = interval - (hours * msecPerHour);

                    var minutes = Math.floor(interval / msecPerMinute);
                    interval = interval - (minutes * msecPerMinute);

                    var seconds = Math.floor(interval / 1000);

                    //  console.log(days + " days, " + hours + " hours, " + minutes + " minutes, " + seconds + " seconds.");
                    if (days)
                        return days + " days, " + hours + " hours, " + minutes + " minutes ago";
                    else if (hours)
                        return  hours + " hours, " + minutes + " minutes ago";
                    else
                        return  minutes + " minutes ago";
                },
                dateDiffFormat: function(last_login) {
                    var memberdateDiff = this.dateDiff(last_login);

                    var years        = memberdateDiff.years ? ' ' +  memberdateDiff.years + (memberdateDiff.years > 1 ? ' years' : ' year') : '';
                    var months        = memberdateDiff.months ? ' ' +  memberdateDiff.months + (memberdateDiff.months > 1 ? ' months' : ' month') : '';
                    var days        = memberdateDiff.days ? ' ' +  memberdateDiff.days + (memberdateDiff.days > 1 ? ' days' : ' day') : '';
                    var hours        = memberdateDiff.hours ? ' ' +  memberdateDiff.hours + (memberdateDiff.hours > 1 ? ' hours' : ' hour') : '';

                    // Only Show minutes if at least one day has elapsed                    
                    if (years || months || days ) {
                        var minutes = ''
                    } else {
                        var minutes        = memberdateDiff.minutes ? ' ' +  memberdateDiff.minutes + (memberdateDiff.minutes > 1 ? ' minutes' : ' minute') : '';
                    }


                    if (!years && !months && !days && !hours && !minutes) {
                        var memberDate = 'less than a minute ago';
                    } else {
                        var memberDate = years + months + days + hours + minutes;
                        memberDate = memberDate.trim() + ' ago'
                    }

                    return memberDate;
                },
                dateDiff: function(newDate) {

                    // Parase passed date in such a way that works with both Safarai & Chrome
                    d = newDate.split(/\D/)
                    date1 = new Date(d[0], d[1]-1, d[2], d[3], d[4], d[5]);

                    now = new Date()
                    var date2 = new Date(now.getUTCFullYear(), now.getUTCMonth(), now.getUTCDate(),  now.getUTCHours(), now.getUTCMinutes(), now.getUTCSeconds());

                    var milliseconds = date2.getMilliseconds() - date1.getMilliseconds();
                    if (milliseconds < 0) {
                        milliseconds += 1000;
                        date2.setSeconds(date2.getSeconds() - 1);
                    }
                    var seconds = date2.getSeconds() - date1.getSeconds();
                    if (seconds < 0) {
                        seconds += 60;
                        date2.setMinutes(date2.getMinutes() - 1);
                    }
                    var minutes = date2.getMinutes() - date1.getMinutes();
                    if (minutes < 0) {
                        minutes += 60;
                        date2.setHours(date2.getHours() - 1);
                    }
                    var hours = date2.getHours() - date1.getHours();
                    if (hours < 0) {
                        hours += 24;
                        date2.setDate(date2.getDate() - 1);
                    }
                    var days = date2.getDate() - date1.getDate();

                    if (days < 0) {
                        days += new Date(date2.getFullYear(), date2.getMonth() - 1, 0).getDate() + 1;
                        date2.setMonth(date2.getMonth() - 1);
                    }
                    var months = date2.getMonth() - date1.getMonth();
                    if (months < 0) {
                        months += 12;
                        date2.setFullYear(date2.getFullYear() - 1);
                    }

                    var years = date2.getFullYear() - date1.getFullYear();
                    return {'years': years, 'months': months, 'days': days, 'hours': hours, 'minutes': minutes, 'seconds': seconds, 'milliseconds': milliseconds};
                    //  return [years, months, days, hours, minutes, seconds, milliseconds];
                },

                humanizeDateStamp: function(dateStamp) {
                    monthNames = ["Jan", "Feb", "Mar", "Apr", "May", "Jun","Jul", "Aug", "Sep", "Oct", "Nov", "Dec"];

                    d = dateStamp.split(/\D/)
                    parsedDate = new Date(d[0], d[1]-1, d[2], d[3], d[4], d[5]);
                    humanizedDate = monthNames[parsedDate.getMonth()] + ' ' + parsedDate.getDate() + ', ' + parsedDate.getFullYear();
                    return humanizedDate;        
                },                

            };
        })

        .factory('AuthService', function($http, $rootScope, $localstorage, RequestsAPI, transformRequestAsFormPost, Session, apiUrl, EVENTS, $ionicLoading, $ionicHistory, $state, $timeout, $filter) {
            var authService = {};
            authService.login = function(login_token) {
                // console.log(' login_token ---', login_token);
                return $http.get(apiUrl + '/api/user/?login_token=' + login_token).then(function(res) {
                    //  console.log(' - - - - - response.data =', res.data);
                    if (res.data.error)
                        return res.data
                    //Remember user data 
                    $localstorage.set('userid', res.data.id);
                    $localstorage.set('useremail', res.data.email);
                    $localstorage.set('userfullname', res.data.first_name + " " + res.data.last_name);
                    $localstorage.set('userfirstname', res.data.first_name);
                    //console.log('$localstorage.get(userid)---', $localstorage.get('userid'));

                    Session.create(res.data);
                    $localstorage.setObject('user', res.data);
                    return res.data;
                });
            };
            authService.facebookLogin = function(fb_access_token) {
                return $http.get(apiUrl + '/api/authenticate/facebook/?token=' + fb_access_token).then(function(result){
                    login_token = result.data.token;
                    $localstorage.set('login_token', login_token);
                    return login_token;
                })
            };            
            authService.getToken = function(signForm) {
                return $http({
                    method: "post",
                    url: apiUrl + '/api/authenticate/',
                    headers: {'Content-Type': 'application/x-www-form-urlencoded'},
                    data: $.param(signForm)
                }).success(function(response) {
                    //console.log('response: ', response);
                    if (response.token) {
                        $localstorage.set('login_token', response.token);
                        //var login_token = $localstorage.get('login_token');
                        // console.log(' login_token ---', login_token);
                    }
                    $rootScope.$broadcast(EVENTS.signupSuccess);
                    return response.data;
                });
            };
            authService.forgotPassword = function(userData) {
                return RequestsAPI.post('/api/forgotpassword/', {
                    email: userData.email
                });
            };
            authService.signup = function(signForm) {
                return $http({
                    method: "post",
                    url: apiUrl + '/api/user/new/',
                    headers: {'Content-Type': 'application/x-www-form-urlencoded'},
                    data: $.param(signForm)
                }).success(function(response) {
                    $rootScope.$broadcast(EVENTS.signupSuccess);
                    $localstorage.setObject('user', response.data);
                    return response.data;
                });
            };
            authService.logout = function() {

                return $http.get(apiUrl + '/api/authenticate/logout/').then(function(){
                    $localstorage.set('login_token', false);
                    $localstorage.clear();
                    $ionicLoading.show({template: 'Logging out....'});
                    Session.destroy();
                    $localstorage.clear('user');
                    $rootScope.$broadcast(EVENTS.logoutSuccess);
                    $localstorage.setObject('user', []);
                    //////////////////////
                    $timeout(function() {
                        $ionicLoading.hide();
                        $ionicHistory.clearCache();
                        $ionicHistory.clearHistory();
                        $ionicHistory.nextViewOptions({disableBack: true, historyRoot: true});
                        $state.go('index');
                    }, 50);
                }, function(){
                    $localstorage.set('login_token', false);
                    $localstorage.clear();
                    $ionicLoading.show({template: 'Logging out....'});
                    Session.destroy();
                    $localstorage.clear('user');
                    $rootScope.$broadcast(EVENTS.logoutSuccess);
                    $localstorage.setObject('user', []);
                    //////////////////////
                    $timeout(function() {
                        $ionicLoading.hide();
                        $ionicHistory.clearCache();
                        $ionicHistory.clearHistory();
                        $ionicHistory.nextViewOptions({disableBack: true, historyRoot: true});
                        $state.go('index');
                    }, 50);

                });
            };
            authService.isAuthenticated = function() {
                if (localStorage.userid) {
                    return true;
                }
                return false;
            };
            authService.createUser = function(userData) {
                console.log('createUser userData = ', userData);
                return $http({
                    method: "post",
                    url: apiUrl + '/api/user/new/',
                    headers: {'Content-Type': 'application/x-www-form-urlencoded; charset=UTF-8'},
                    data: $.param({
                        first_name: userData.first_name,
                        last_name: userData.last_name,
                        email: userData.email,
                        password: userData.password,
                        password2: userData.password,
                        birthday_day: userData.birthday_day, //dayBirthday,
                        birthday_month: userData.birthday_month, //monthBirthday,
                        birthday_year: userData.birthday_year, //yearBirthday
                        website:'',
                        group_locator: userData.group_locator,
                        token: userData.token
                    })
                }).success(function(response) {
                    console.log('response: ', response);
                    if (response.token) {
                        $localstorage.set('login_token', response.token);
                        return true;
                    } else
                        return false;
                });
            };
            authService.sendReminder = function(listID, message, userName) {
                return $http.get(apiUrl + '/api/reminder/' + listID,
                        {params: {"login_token": $localstorage.get('login_token'), "message": message, "sender": userName}})
                        .success(function(response) {
                            console.log('---sendReminder: response.data--- ', response.data);
                            return response.data;
                        })
                        .error(function(data) {
                            console.log("ERROR ", data);
                            return false;
                        });
            };
            authService.getUser = function() {
                return $http.get(apiUrl + '/api/user/?login_token=' + $localstorage.get('login_token')).then(function(response) {
                    console.log(' - - - - - response.data =', response.data);
                    if (response.data.error)
                        return data = {'message': response.data.error};
                    //Remember user data 
                    $localstorage.set('userid', response.data.id);
                    $localstorage.set('useremail', response.data.email);
                    $localstorage.set('userfullname', response.data.first_name + " " + response.data.last_name);
                    $localstorage.set('userfirstname', response.data.first_name);
                    $localstorage.setObject('user', response.data);
                    console.log('$localstorage.get(userid)---', $localstorage.get('userid'));
                    return response.data;
                });
            };
            return authService;
        })
        .factory('userSettings', function($http, apiUrl, $localstorage) {
            var userSettings = [];
            var first_time = false;
            return {
                getFirstTime: function() {
                    return first_time;
                },
                setFirstTime: function(firstTime) {
                    return first_time = firstTime;
                },
                getNewUser: function() {
                    userSettings = {
                        member_visible: 'hide',
                        member_started_visible: 'show',
                        btn_group: 'show',
                        btn_list: 'show',
                        footer_without_tabs: 'footer_without_tabs',
                        welcome_visible: '',
                        shop_visible: 'hide'
                    };
                    return userSettings;
                },
                getUser: function() {
                    return userSettings;
                },
                setParams: function(content, content_started, btn_group, list_btns, footer_without_tabs, welcome_visible, content_info) {
                    userSettings = {
                        member_visible: content,
                        member_started_visible: content_started,
                        btn_group: btn_group,
                        btn_list: list_btns,
                        footer_without_tabs: footer_without_tabs,
                        welcome_visible: welcome_visible,
                        shop_visible: content_info,
                    };
                    console.log('!!!!!!!!!!setParams= userSettings -', userSettings);
                    return userSettings;
                },
                getUserEmail: function() {
                    return $http.get(apiUrl + '/api/user/settings/?login_token=' + $localstorage.get('login_token')).then(function(response) {
                        console.log('---getUserEmail: response.data--- ', response.data);
                        if (response.data) {
                            email = response.data.email;

                            if (email == '') {
                                email = response.data.username;
                            }

                            return email;
                            
                        } else {
                            return false;
                        }
                    });
                }
            };
        })
        //Tab shop for others
        .factory('Member', function($http, apiUrl, $localstorage, RequestsAPI, customElements) {
            var userid = [];//$localstorage.get('userid');
            var groups = [];
            var joinedGR = [];
            var childAccounts = [];
            return {
                getGroupsExistence: function() {
                    return $http.get(apiUrl + '/api/groups/?login_token=' + $localstorage.get('login_token')).then(function(response) {
                        console.log('---getGroups: response.data--- ', response.data);
                        if (response.data.length)
                            return true;
                        else
                            return false;
                    });
                },
                getGroups: function() {
                    return $http.get(apiUrl + '/api/groups/?login_token=' + $localstorage.get('login_token')).then(function(response) {
                        console.log('---getGroups: response.data--- ', response.data);
                        groups = response.data;
                        console.log(' - - - groups!!!!!!!  - - ', groups);
                        return groups;
                    });
                },
                getGroupId: function(groupId) {
                    // Simple index lookup
                    return groups[groupId];
                },
                getChildAccounts: function() {
                    var login_token = $localstorage.get('login_token');
                    return $http.get(apiUrl + '/api/child/?login_token=' + login_token).then(function(response) {
                        console.log('---getChildAccounts: response.data--- ', response.data);
                        childAccounts = response.data;
                        console.log(' - - - ChildAccounts!!!!!!!  - - ', childAccounts);
                        return childAccounts;
                    });
                },
                getMembersInvited: function(groupId) {
                    return $http.get(apiUrl + '/api/v2/groups/' + groupId + '/members/?login_token=' + $localstorage.get('login_token')).then(function(response) {
                        //  return $http.get(apiUrl + '/api/groups/' + groupId + '/members/?login_token=' + $localstorage.get('login_token')).then(function(response) {
                        var allMembers = [];
                        $.each(response.data.members, function(key, member) {
                            // console.log('key -', key);
                            //  console.log('member -', member);
                            var newMembers = null;
                            if (member.last_login) {
                                var memberDate = '';

                                if (member.last_login) {
                                    memberdateDiff = customElements.dateDiff(member.last_login);
                                    if (memberdateDiff.years)
                                        memberDate = memberdateDiff.years + ' years ' + memberdateDiff.months + 'months ago';
                                    else if (!memberdateDiff.years && memberdateDiff.months && memberdateDiff.days)
                                        memberDate = memberdateDiff.months + ' months ' + memberdateDiff.days + ' days  ago';
                                    else if (!memberdateDiff.months && memberdateDiff.hours && memberdateDiff.minutes)
                                        memberDate = memberdateDiff.hours + ' hours ' + memberdateDiff.minutes + ' minutes  ago';
                                    else if (!memberdateDiff.hours && memberdateDiff.minutes)
                                        memberDate = memberdateDiff.minutes + ' minutes ago';
                                }

                                newMembers = {
                                    'id': member.id,
                                    'membership_id': member.membership_id,
                                    'name': member.first_name + ' ' + member.last_name,
                                    'email': member.email,
                                    'last_login': member.last_login,
                                    'date_joined': member.date_joined,
                                    'date_last_login': memberDate,
                                    'child_accounts': member.child_accounts,
                                    'is_active': member.is_active,
                                    'class_item': '',
                                    'class_icon': 'hide'
                                };
                                allMembers.push(newMembers);
                            }
                        });
                        var allInvited = [];
                        $.each(response.data.invited, function(key, invited) {
                            //console.log('invited.date =', invited.date);
                            newInvited = {
                                'membership_id': invited.membership_id,
                                'name': invited.name,
                                'email': invited.email,
                                'date': moment(invited.date).format("MM/DD/YY")
                            };
                            allInvited.push(newInvited);
                        });
                        //.format('MMM D, YYYY')
                        //return response.data;
                        // console.log(' return allMembers---', allMembers);
                        // console.log(' return allInvited---', allInvited);
                        return {'members': allMembers, 'invited': allInvited};//response.data.invited};
                    });
                },
                getSecretSanta: function(userID) {
                    // $localstorage.get('userid')
                    return $http.get(apiUrl + '/api/user/' + userID + '/drawpick/?login_token=' + $localstorage.get('login_token')).then(function(response) {
                        // return $http.get(apiUrl + '/api/user/138585/drawpick/?login_token=138584$o1tx+y+9p6r1c7dp3olFGEX3p3Y=').then(function(response) {
                        console.log('--- getSecretSanta --- ', response.data);
                        if (!response.data)
                            return false;
                        // console.log(response.data.length)
                        if (response.data && response.data.length != 0) {
                            console.log('$$$$ if getSecretSanta ---', response.data);
                            var membersSanta = null;
                            membersSanta = {
                                'id': response.data.id,
                                'name': response.data.owner,
                                'is_active': response.data.is_active,
                                'class_item': 'item-icon-left santa-left',
                                'class_icon': ' ',
                                'group_id': response.data.group_id,
                                'owner': response.data.group_owner,
                                'created': response.data.created,
                                'message': response.data.message,
                                'giver': response.data.giver,
                                'recipient': response.data.recipient
                            };
                            // console.log(' getSecretSanta return membersSanta---', membersSanta);
                            return membersSanta;
                        }
                        return false;
                    });
                },
                getJoin: function() {
                    //http://m.sandbox.giftster.com/api/groups/joined/?login_token=138588$Qh2FWan4MrLq+nRxnHXfvOjYvZg=
                    return $http.get(apiUrl + '/api/groups/joined/?login_token=' + $localstorage.get('login_token')).then(function(response) {

                        joinedGR = response.data;
                        console.log(' - - - joined!!!!!!!  - - ', joinedGR);
                        return joinedGR;
                    });
                },
                getAllGroups: function() {
                    return $http.get(apiUrl + '/api/v2/groups/all/members/?login_token=' + $localstorage.get('login_token')).then(function(response) {
                        console.log('--- v2 getAllGroups --- ', response.data);
                        if (response.data.length == 0)
                            return false;

                        var allMembers = [];
                        $.each(response.data, function(key, member) {
                            var newMembers = null;
                            newMembers = {
                                'id': member.id,
                                'name': member.first_name + ' ' + member.last_name,
                                'email': member.email,
                                'group_owner': member.group_owner,
                                'class_item': (member.is_draw_pick) ? 'item-icon-left santa-left' : '',
                                'class_icon': (member.is_draw_pick) ? 'show' : 'hide',
                                'is_current_user': member.is_current_user
                            };
                            allMembers.push(newMembers);
                            // console.log(' - - - - -allMembers---', allMembers);
                            if (member.child_accounts) {
                                //my childs
                                $.each(member.child_accounts, function(key, child) {
                                    var membersChilds = null;
                                    membersChilds = {
                                        'id': child.id,
                                        'parent_id': member.id,
                                        'name': child.first_name + ' ' + child.last_name,
                                        'parent': member.first_name + ' ' + member.last_name,
                                        'class_item': (child.is_draw_pick) ? 'item-icon-left santa-child-left' : 'item-icon-left child-left',
                                        'class_icon': (member.is_draw_pick) ? 'show' : ' ',
                                    };
                                    allMembers.push(membersChilds);
                                });
                            }
                        });
                        console.log(' return allMembers---', allMembers);
                        return allMembers;
                    });
                },
                getJoinGroups: function(groupsID) {
                    return $http.get(apiUrl + '/api/v2/groups/' + groupsID + '/members/?login_token=' + $localstorage.get('login_token')).then(function(response) {
                        console.log('--- v2 getJoinGroups --- ', response.data);
                        var allMembers = [];
                        $.each(response.data.members, function(key, member) {
                            var newMembers = null;
                            // if ((member.id == userid && member.child_accounts) || member.id != userid) {
                            newMembers = {
                                'id': member.id,
                                'name': member.first_name + ' ' + member.last_name,
                                'email': member.email,
                                'group_owner': member.group_owner,
                                'class_item': (member.is_draw_pick) ? 'item-icon-left santa-left' : '',
                                'class_icon': (member.is_draw_pick) ? 'show' : 'hide',
                            };
                            allMembers.push(newMembers);
                            // console.log(' - - - - -allMembers---', allMembers);
                            if (member.child_accounts) {
                                //my childs
                                $.each(member.child_accounts, function(key, child) {
                                    var membersChilds = null;
                                    membersChilds = {
                                        'id': child.id,
                                        'parent_id': member.id,
                                        'name': child.first_name + ' ' + child.last_name,
                                        'parent': member.first_name + ' ' + member.last_name,
                                        'class_item': (child.is_draw_pick) ? 'item-icon-left santa-child-left' : 'item-icon-left child-left',
                                        'class_icon': (member.is_draw_pick) ? 'show' : ' ',
                                    };
                                    allMembers.push(membersChilds);
                                });
                            }
                            //  }
                        });
                        console.log(' return allMembers---', allMembers);
                        return allMembers;
                    });
                },
                getWishList: function() {
                    var login_token = $localstorage.get('login_token');
                    return $http.get(apiUrl + '/api/mywishlist/?login_token=' + login_token).then(function(response) {
                        return response.data;
                    });
                },
                
                // This actually gets all lists for a member, not a single list
                getList: function(memberId, parent_or_child) {
                    var login_token = $localstorage.get('login_token');
                    parent_or_child = parent_or_child || null // Optional argument

                    return $http.get(apiUrl + '/api/user/' + memberId + '/wishlist/?login_token=' + login_token).then(function(response) {
                        if (response.data.length) {
                            if ( response.data[response.data.length - 1].title == "I Got This list"  &&
                                  parent_or_child != 'child'
                                ) {  
                                response.data.pop()
                            }
                        }
                        return response.data;
                    });
                },

                // Return list data for a single list (title, description, privacy, etc)
                getListInfo: function(listLocator) {
                  var login_token = $localstorage.get('login_token');
                  var url = apiUrl + '/api/v2/wishlist/' + listLocator + '?login_token=' + login_token
                  
                  return $http.get(url).then(function(response){
                        return response.data
                  })
                },

                getListItems: function(listId) {
                    return $http.get(apiUrl + '/api/items/' + listId + '/?login_token=' + $localstorage.get('login_token')).then(function(response) {
                        var allLists = [];
                        var newLists = null;
                        var userSettings = [];
                        var info_message = '';
                        var list_activeButton = '';
                        var iconLeft = 'item item-thumbnail-left';
                        console.log('getListItems data: ', response.data);
                        if (response.data.length === 0)
                            return data = {'new_lists': allLists, 'userSettings': {
                                    'info_message': 'error',
                                    'list_activeButton': ''
                                }};

                        //if (response.data[0].list)
                        if (response.data.list || response.data.error)
                            info_message = 'This list is empty. Touch the plus icon to add an item.';
                        else if (!response.data.error && response.data[0].list) {
                            list_activeButton = response.data[0].list.is_private;
                        }
                        console.log('response= ', response);
                        $.each(response.data, function(val, list) {
                            var status = '';
                            var statusclass = '';

                            if (list.available) {
                                status = list.qty_remaining + ' of ' + list.quantity + ' available';
                                statusclass = 'available';
                            } else {
                                status = 0 + ' of ' + list.quantity + ' available';
                                statusclass = 'held';                                
                            }
                            // if (list.held) {
                            //     status = 'reserved';
                            //     statusclass = 'held';
                            // }
                            // if (list.purchased) {
                            //     status = 'purchased';
                            //     statusclass = 'purchased';
                            // }
                            if (list.held_by_me) {
                                status = 'reserved by me';
                                statusclass = 'heldbyme';
                            }
                            if (list.purchased_by_me) {
                                status = 'purchased by me';
                                statusclass = 'purchasedbyme';
                            }
                            newLists = {
                                'id': list.id,
                                'list_id': list.list_id,
                                'title': list.title,
                                'price': (/[^$]/g.exec(list.price) == 0) ? '$' + list.price : list.price, // (/[^$]/g.exec(list.price).index == 0) ? '$' + list.price : list.price,
                                'rank': list.rank,
                                'image': (list.image != '' && list.image != null) ? 'https://s3-us-west-2.amazonaws.com/giftster.uploads/' + list.image : '', //'http://giftster.uploads.s3-us-west-2.amazonaws.com/' + list.image,
                                'class_item': (list.image != '' && list.image != null) ? iconLeft : '',
                                'class_icon': (list.image != '' && list.image != null) ? '' : 'hide',
                                'class_list_col': (list.image != '' && list.image != null) ? 'list-col-image' : 'list-col',
                                'status': status,
                                'statusclass': statusclass,
                                'link': list.link
                            };
                            allLists.push(newLists);
                        });

                        // console.log('allLists - - -', allLists);
                        //console.log('userSettings = ', userSettings);
                        userSettings = {
                            'info_message': info_message,
                            'list_activeButton': list_activeButton
                        };
                        return data = {'new_lists': allLists, 'userSettings': userSettings};

                    });
                },
                getListItems2: function(listId) {
                    return $http.get(apiUrl + '/api/items/' + listId + '/?login_token=' + $localstorage.get('login_token')).then(function(response) {
                        var allInfolists = [];
                        console.log('getListItems data: ', response.data);
                        angular.forEach(response.data, function(val, key) {
                            var status = (val.available) ? 'Available' :
                                    (val.purchased) ? 'Purchased' :
                                    (val.held_by_me) ? 'Reserved by me.' :
                                    (val.purchased_by_me) ? 'Reserved by me.' :
                                    (val.held) ? 'Reserved' :
                                    ' ';
                            var statusclass = (val.available) ? 'available' :
                                    (val.purchased) ? 'purchased' :
                                    (val.held_by_me) ? 'heldbyme' :
                                    (val.purchased_by_me) ? 'purchasedbyme' :
                                    (val.held) ? 'held' :
                                    ' ';
                            var resInfolists = {
                                'id': val.id,
                                'title': val.title,
                                'rank': val.rank,
                                'price': val.price,
                                'status': status,
                                'statusclass': statusclass
                            };
                            //console.log('push resInfolists = ', resInfolists);
                            allInfolists.push(resInfolists);
                        });
                        console.log('resInfolists = ', allInfolists);
                        return allInfolists;
                    });
                },
                getListItemsInfo: function(listId, listitemId, milliseconds) {
                    var urlMethod = '';
                    if ($localstorage.get('login_token'))
                        urlMethod = apiUrl + '/api/lists/' + listId + '/items/' + listitemId + '/platform/' + linkPlatform + '/?login_token=' + $localstorage.get('login_token') + "&time=" + milliseconds;
                    else
                        urlMethod = apiUrl + '/api/lists/' + listId + '/items/' + listitemId + '/platform/' + linkPlatform + '/';
                    console.log('urlMethod ---', urlMethod);
                    return  $http.get(urlMethod).then(function(response) {
                        // return  $http.get(apiUrl + '/api/lists/' + listId + '/items/' + listitemId + '/platform/ios/?login_token=' + $localstorage.get('login_token') + "&time=" + milliseconds).then(function(response) {
                        var allListItem = [];
                        console.log('response = ', response.data);

                        var status = '';
                        var statusclass = '';

                        if (response.data.available) {
                            status = '1 of ' + response.data.quantity + ' available';
                            statusclass = 'available';
                        }
                        if (response.data.held) {
                            status = 'reserved';
                            statusclass = 'held';
                        }
                        if (response.data.purchased) {
                            status = 'purchased';
                            statusclass = 'purchased';
                        }
                        if (response.data.held_by_me) {
                            status = 'reserved by me';
                            statusclass = 'heldbyme';
                        }
                        if (response.data.purchased_by_me) {
                            status = 'purchased by me';
                            statusclass = 'purchasedbyme';
                        }
                        var nobuttons = (response.data.available) ? 'false' :
                                (response.data.purchased) ? 'true' :
                                (response.data.held_by_me) ? 'false' :
                                (response.data.purchased_by_me) ? 'false' :
                                (response.data.held) ? 'true' :
                                ' ';

                        var resListItem = {
                            'id': response.data.id,
                            'title': response.data.title,
                            'created': response.data.created,
                            'modified': response.data.modified,
                            'rank': response.data.rank,
                            'store': response.data.store,
                            // 'price': (/[^$]/g.exec(response.data.price).index == 0) ? '$' + response.data.price : response.data.price,
                            'price': (/[^$]/g.exec(response.data.price) === 0) ? '$' + response.data.price : response.data.price,
                            'image': (response.data.image != '' && response.data.image != null) ? 'https://s3-us-west-2.amazonaws.com/giftster.uploads/' + response.data.image : '',
                            'link': response.data.link,
                            'skimlink': response.data.skimlink,
                            'description': response.data.description,
                            'quantity': response.data.quantity,
                            'status': status,
                            'statusclass': statusclass,
                            'purchased': response.data.purchased,
                            'purchased_by_me': response.data.purchased_by_me,
                            'available': response.data.available,
                            'held': response.data.held,
                            'held_by_me': response.data.held_by_me,
                            'holds': (response.data.holders) ? response.data.holders.length : 0,
                            'holds_by_me': response.data.holds_by_me,
                            'qty': response.data.qty,
                            'qty_remaining': response.data.qty_remaining,
                            'nobuttons': nobuttons,
                            'purchases': (response.data.purchasers) ? response.data.purchasers.length : 0,
                            'purchases_by_me': response.data.purchases_by_me,
                            'store_matches': response.data.store_matches,
                            'is_suggested_item': response.data.is_suggested_item,
                            'is_suggested_item_owner': response.data.is_suggested_item_owner
                        };

                        console.log('resListItem = ', resListItem);
                        allListItem.push(resListItem);
                        return allListItem;
                    });
                },

                // Return all suggested items for a list, grouped on user who owns items
                getSuggestedItems: function(listId) {
                    return $http.get(
                        apiUrl + '/api/v2/lists/' + listId +
                        '/items/suggested' + 
                        '/?login_token=' + $localstorage.get('login_token')).then(function(response) {

                        var iconLeft = 'item item-thumbnail-left';

                        // Annotate each item with data need by template
                        $.each(response.data, function(userIdx, user) {
                            $.each(user.suggested_items, function(itemIdx, item){ 

                                // Add a leading $ if price is zero
                                item.price = (/[^$]/g.exec(item.price) == 0) ? '$' + item.price : item.price
                                
                                // Add base URL to image
                                item.image = (item.image != '' && item.image != null) ? 'https://s3-us-west-2.amazonaws.com/giftster.uploads/' + item.image : ''


                                // Classes used to display item differ based on presence of image
                                item.class_item = (item.image != '' && item.image != null) ? iconLeft : ''
                                item.class_icon = (item.image != '' && item.image != null) ? '' : 'hide'
                                item.class_list_col = (item.image != '' && item.image != null) ? 'list-col-image' : 'list-col'
                                
                                // Display different status text depending on item availability
                                if (item.available) {
                                    item.status = '1 of ' + item.quantity + ' available';
                                    item.statusclass = 'available';
                                }
                                if (item.held) {
                                    item.status = 'reserved';
                                    item.statusclass = 'held';
                                }
                                if (item.purchased) {
                                    item.status = 'purchased';
                                    item.statusclass = 'purchased';
                                }
                                if (item.held_by_me) {
                                    item.status = 'reserved by me';
                                    item.statusclass = 'heldbyme';
                                }
                                if (item.purchased_by_me) {
                                    item.status = 'purchased by me';
                                    item.statusclass = 'purchasedbyme';
                                }
                            })
                        })

                        // Return annotated data
                        return response.data
                    });                
                },

                // Return all lists user has added suggested items to, including suggested items
                // created only by user
                getMySuggestedItems: function() {
                    return $http.get(
                        apiUrl + '/api/v2/mysuggesteditems' +
                        '/?login_token=' + $localstorage.get('login_token')).then(function(response) {

                        var list_activeButton = '';
                        var iconLeft = 'item item-thumbnail-left';

                        $.each(response.data, function(key, list) {
                        
                            $.each(list.user_suggested_items, function(key, item){
                                item.price = (/[^$]/g.exec(list.price) == 0) ? '$' + item.price : item.price
                                item.image = (item.image != '' && item.image != null) ? 'https://s3-us-west-2.amazonaws.com/giftster.uploads/' + item.image : ''
                                item.class_item = (item.image != '' && item.image != null) ? iconLeft : 'textOnly'
                                item.class_icon = (item.image != '' && item.image != null) ? '' : 'hide'
                                item.class_list_col = (item.image != '' && item.image != null) ? 'list-col-image' : 'list-col'
                            })

                        })
                        
                        return response.data
                    });                
                },

                getMySuggestedItemCount: function() {
                    return $http.get(
                        apiUrl + '/api/v2/mysuggesteditems/count' +
                        '/?login_token=' + $localstorage.get('login_token')).then(function(response) {
                            return response.data.count;
                    });                
                },

                // Return list data for a single list (title, description, privacy, etc)
                getSuggestedItemsPermission: function(listId) {
                    loginToken = $localstorage.get('login_token');
                    url =  apiUrl + '/api/v2/lists/' + listId + '/items/suggested/permission';
                    
                    if (loginToken) {

                        url += '?login_token=' + loginToken;
                    }

                    return $http.get(url).then(function(response) {

                        return response.data
                    });
                },

                // Return user data for a single user (first name, last name) if authorized
                getUserInfo: function(userID) {
                  var login_token = $localstorage.get('login_token');
                  var url = apiUrl + '/api/v2/user/' + userID + '?login_token=' + login_token
                  
                  return $http.get(url).then(function(response){
                        return response.data
                  })
                },

                store_matches: function(listId, listitemId, provider, platform) {
                    return RequestsAPI.get(
                                '/api/lists/' + listId + '/items/' + listitemId + '/matches/provider/' + provider + '/platform/' + platform + '/', 
                                $localstorage.get('login_token')                                
                            );
                },

                tabPurchase: function(listId, listitemId, milliseconds) {
                    return RequestsAPI.post('/api/lists/' + listId + '/items/' + listitemId + '/purchase/', {
                        'login_token': $localstorage.get('login_token'),
                        'time': milliseconds
                    });
                },
                tabReserve: function(listId, listitemId, milliseconds) {
                    return RequestsAPI.post('/api/lists/' + listId + '/items/' + listitemId + '/reserve/', {
                        'login_token': $localstorage.get('login_token'),
                        'time': milliseconds
                    });

                },
                tabRelease: function(listId, listitemId, milliseconds) {
                    return RequestsAPI.post('/api/lists/' + listId + '/items/' + listitemId + '/release/', {
                        'login_token': $localstorage.get('login_token'),
                        'time': milliseconds
                    });
                }
            };
        })
        //
        // Tab Lists (second)
        // 
        .factory('Lists', function($http, apiUrl, $localstorage, RequestsAPI, $ionicLoading) {
            console.log('factory Lists');
            $ionicLoading.hide();
            var lists = [];
            var listChildAccounts = [];
            var childAccount = false;
            var listsSettings = [];
            var addChildAccounts = [{
                    id: 0,
                    name: 'Add a Child Account',
                    note: 'Manage lists for your kids, pets or parents',
                    url: 'childaccounts' //'#/tab/mylists/childaccounts'
                }
            ];
            var viewChildAccounts = [{
                    id: 0,
                    name: 'View Child Accounts',
                    note: '',
                    url: 'viewchildaccounts' //'#/tab/mylists/viewchildaccounts'
                }
            ];
            return {
                addChildGiftPreferences: function(gift_preferences, extrasize, childID) {
                    return RequestsAPI.post('/api/giftpreferences/' + childID + '/', {
                        'login_token': $localstorage.get('login_token'),
                        'child': ((childID) ? (childID) : 'shared'),
                        'shoe_size': gift_preferences.shoe_size,
                        'casual_shirt_size': gift_preferences.casual_shirt_size,
                        'dress_shirt_size': gift_preferences.dress_shirt_size,
                        'pants_size': gift_preferences.pants_size,
                        'jacket_size': gift_preferences.jacket_size,
                        'dress_size': gift_preferences.dress_size,
                        'hat_size': gift_preferences.hat_size,
                        'extrasize_set-0-name': extrasize.extrasize_name0,
                        'extrasize_set-0-size': extrasize.extrasize_size0,
                        'extrasize_set-1-name': extrasize.extrasize_name1,
                        'extrasize_set-1-size': extrasize.extrasize_size1,
                        'culture': gift_preferences.culture,
                        'hobbies': gift_preferences.hobbies,
                        'other': gift_preferences.other,
                        'favorites': gift_preferences.favorites,
                        'full_name': gift_preferences.full_name,
                        'street1': gift_preferences.street1,
                        'street2': gift_preferences.street2,
                        'city': gift_preferences.city,
                        'state': gift_preferences.state,
                        'postal_code': gift_preferences.postal_code,
                        'country': gift_preferences.country,
                        'phone_number': gift_preferences.phone_number,
                        'public': gift_preferences.public                        
                    });
                },
                addGiftPreferences: function(gift_preferences, extrasize) {
                    return RequestsAPI.post('/api/giftpreferences/', {
                        'login_token': $localstorage.get('login_token'),
                        'casual_shirt_size': gift_preferences.casual_shirt_size,
                        'city': gift_preferences.city,
                        'country': gift_preferences.country,
                        'culture': gift_preferences.culture,
                        'dress_shirt_size': gift_preferences.dress_shirt_size,
                        'dress_size': gift_preferences.dress_size,
                        'extrasize_set-0-name': extrasize.extrasize_name0,
                        'extrasize_set-0-size': extrasize.extrasize_size0,
                        'extrasize_set-1-name': extrasize.extrasize_name1,
                        'extrasize_set-1-size': extrasize.extrasize_size1,
                        'favorites': gift_preferences.favorites,
                        'full_name': gift_preferences.full_name,
                        'hat_size': gift_preferences.hat_size,
                        'hobbies': gift_preferences.hobbies,
                        'jacket_size': gift_preferences.jacket_size,
                        'other': gift_preferences.other,
                        'pants_size': gift_preferences.pants_size,
                        'phone_number': gift_preferences.phone_number,
                        'postal_code': gift_preferences.postal_code,
                        'shoe_size': gift_preferences.shoe_size,
                        'state': gift_preferences.state,
                        'street1': gift_preferences.street1,
                        'street2': gift_preferences.street2,
                        'public': gift_preferences.public
                    });
                    //
                    //if(childID)
                    //'childID':childID,;
                },
                getListsItems: function(mylistId, itemId) {
                    return $http.get(apiUrl + '/api/lists/' + mylistId + '/items/' + itemId + '/platform/' + linkPlatform + '/?login_token=' + $localstorage.get('login_token')).then(function(response) {
                        console.log('getListsItems ---- ', response.data);
                        return response.data;
                    });
                },
                giftPreferences: function(memberId, type) {
                    var methodURL = '';
                    if ($localstorage.get('login_token'))
                        methodURL = apiUrl + '/api/giftpreferences/' + memberId + '/?login_token=' + $localstorage.get('login_token');
                    else
                        methodURL = apiUrl + '/api/giftpreferences/' + memberId + '/';

                    return $http.get(methodURL).then(function(response) {
                        var name = '';
                        var note = '';
                        var class_type = 'elem_gray';
                        console.log('giftPreferences response.data--- ', response.data);
                        if (type) {
                            if (response.data.empty == true) {
                                name = 'Add Gift Preferences';
                                note = 'Add sizes, colors, interests & more';
                                class_type = 'elem_gray';
                            } else {
                                name = 'My Gift Preferences';
                                note = (response.data.gift_preferences.public == true) ? 'public' : 'shared';
                                class_type = 'elem_dark';
                            }
                            return giftPreferences = [{
                                    id: 0,
                                    name: name,
                                    note: note,
                                    class: class_type
                                }];
                        } else {
                            console.log('--- else--- ', response.data.gift_preferences);
                            return {'gift_preferences': response.data.gift_preferences, 'extra_sizes': response.data.extra_sizes, 'empty': response.data.empty};
                        }
                    });
                },
                giftPreferencesPublic: function(memberId) {
                    return  $http.get(apiUrl + '/api/giftpreferences/' + memberId + '/?login_token=' + $localstorage.get('login_token')).then(function(response) {
                        //console.log('---giftPreferencesPublic: response.data--- ', response.data.gift_preferences);
                        //console.log('---response.data.gift_preferences.public--- ', response.data.gift_preferences.public);
                        return response.data.gift_preferences.public;
                    });

                },
                childAccounts: function() {
                    return  $http.get(apiUrl + '/api/child/?login_token=' + $localstorage.get('login_token')).then(function(response) {
                        console.log('--- remove --- ', response);
                        console.log(' - - - - childAccount - ', childAccount);
                        listChildAccounts = response.data;
                        console.log(' - - - - childAccount - ', listChildAccounts);
                        if (response.data.length != 0)
                            return {'btn': viewChildAccounts, 'accounts': response.data};
                        else
                            return {'btn': addChildAccounts, 'accounts': response.data};
                    });
                },
                addChildAccounts: function(account) {
                    return RequestsAPI.post('/api/child/', {
                        'login_token': $localstorage.get('login_token'),
                        'first_name': account.first_name,
                        'last_name': account.last_name,
                        'birthday_month': account.birthday_month,
                        'birthday_day': account.birthday_day,
                        'birthday_year': account.birthday_year
                    });
                },
                editChildAccounts: function(account) {
                    return RequestsAPI.put('/api/child/' + account.id + '/', {
                        "login_token": $localstorage.get('login_token'),
                        "first_name": account.first_name,
                        "birthday_month": account.birthday_month,
                        "birthday_day": account.birthday_day,
                        "birthday_year": account.birthday_year,
                        "last_name": account.last_name,
                        "is_active": account.is_active,
                        "id": account.id
                    });
                },
                delChildAccounts: function(account, listChildAccounts) {
                    return  $http.delete(apiUrl + '/api/child/' + account.id + '/?login_token=' + $localstorage.get('login_token')).then(function(response) {
                        console.log('--- remove --- ', response);
                        if (response.data.error)
                            return false;

                        if (listChildAccounts.length === 1) {
                            var wLists = [];
                            wLists [0] = {
                                'id': 0,
                                'title': 'You have no child accounts.'
                            };
                            var userSettings = {
                                list_text_visible: 'show',
                                list_visible: 'hide',
                                class_right: 'hide',
                                icon_right: ''
                            };
                            return data = {'wish_lists': wLists, 'userSettings': userSettings};
                        } else {
                            console.log('--- listChildAccounts --- ', listChildAccounts);
                            console.log('--- one_list --- ', account);
                            listChildAccounts.splice(listChildAccounts.indexOf(account), 1);
                            return true;
                        }
                    });
                },
                viewChildAccounts: function() {
                    return  $http.get(apiUrl + '/api/child/?login_token=' + $localstorage.get('login_token')).then(function(response) {
                        return response.data;
                    });
                },
                getChildAccount: function(childId) {
                    return  $http.get(apiUrl + '/api/child/' + childId + '/?login_token=' + $localstorage.get('login_token')).then(function(response) {
                        return response.data;
                    });
                },
                remove: function(one_list) {
                    return  $http.get(apiUrl + '/api/lists/' + one_list.id + '/del/?login_token=' + $localstorage.get('login_token')).then(function(response) {
                        console.log('--- remove --- ', response);
                        console.log('lists.length - ', lists.length);

                        if (response.data.error)
                            return false;

                        if (response.data.length == 0) {
                            var wLists = [];
                            wLists [0] = {
                                'id': 0,
                                'title': 'You have no lists.'
                            };
                            var userSettings = {
                                list_text_visible: 'show',
                                list_visible: 'hide',
                                class_right: 'hide',
                                icon_right: ''
                            };
                            return data = {'wish_lists': wLists, 'userSettings': userSettings};
                            //return data = {'wish_lists': wLists, 'class_right': 'hide', 'icon_right': ''};
                        } else {
                            //  lists = response.data;
                            var userSettings = {
                                list_text_visible: 'hide',
                                list_visible: 'show',
                                class_right: '',
                                icon_right: 'item-icon-right'
                            };
                            return data = {'wish_lists': lists, 'userSettings': userSettings};
                        }
                    });
                },
                removeItems: function(one_list) {
                    return  $http.get(apiUrl + '/api/items/' + one_list.id + '/del/?login_token=' + $localstorage.get('login_token')).then(function(response) {
                        console.log('--- remove --- ', response);
                        if (response.data.error)
                            return false;

                        if (response.data.success == "deleted")
                            return true;
                    });
                },
                setListStatus: function(listId, status) {
                    return RequestsAPI.post('/api/lists/' + listId + '/status/', {
                        'login_token': $localstorage.get('login_token'),
                        'status': status
                    });
                },
                createList: function(userData, groupsID, userType) {
                    console.log('userData=', userData);
                    groupsID_string = '[' + groupsID.toString() + ']'

                    if (userType == 'child' && groupsID != 0) {

                        return RequestsAPI.post('/api/lists/new/', {
                            'login_token': $localstorage.get('login_token'),
                            'description': userData.description,
                            'is_private': userData.is_private,
                            'search_visibility': userData.search_visibility,
                            'title': userData.title,
                            'user': groupsID,
                            'type': 1,
                        });
                    } else {
                        if (userData.is_private == 0 || userData.is_private == 3 || userData.is_private == 1)
                            return RequestsAPI.post('/api/lists/new/', {
                                'login_token': $localstorage.get('login_token'),
                                'description': userData.description,
                                'is_private': userData.is_private,
                                'search_visibility': userData.search_visibility,
                                'title': userData.title,
                                'type': 1,
                                'user': $localstorage.get('userid')
                            });
                        else
                        if (groupsID != 0)
                            return RequestsAPI.post('/api/lists/new/', {
                                'login_token': $localstorage.get('login_token'),
                                'description': userData.description,
                                'is_private': userData.is_private,
                                'search_visibility': userData.search_visibility,
                                'title': userData.title,
                                'type': 1,
                                'user': $localstorage.get('userid'),
                                'perms-group': groupsID_string
                            });
                        else
                            return RequestsAPI.post('/api/lists/new/', {
                                'login_token': $localstorage.get('login_token'),
                                'description': userData.description,
                                'is_private': userData.is_private,
                                'search_visibility': userData.search_visibility,
                                'title': userData.title,
                                'type': 1,
                                'user': $localstorage.get('userid')
                            });
                    }
                },
                setListSetings: function(listId, userData, groupsID) {
                    // Coerce perms-groups into string before submitting
                    groupsID_string = '[' + groupsID.toString() + ']'

                    if (userData.is_private == 0 || userData.is_private == 3 || userData.is_private == 1)
                        return RequestsAPI.post('/api/lists/' + listId + '/edit/', {
                            'login_token': $localstorage.get('login_token'),
                            'description': userData.description,
                            'is_private': userData.is_private,
                            'search_visibility': userData.search_visibility,
                            'title': userData.title
                        });
                    else
                    if (groupsID != 0)
                        return RequestsAPI.post('/api/lists/' + listId + '/edit/', {
                            'login_token': $localstorage.get('login_token'),
                            'description': userData.description,
                            'is_private': userData.is_private,
                            'search_visibility': userData.search_visibility,
                            'title': userData.title,
                            'perms-group': groupsID_string //groupsID_string 
                        });
                    else
                        return RequestsAPI.post('/api/lists/' + listId + '/edit/', {
                            'login_token': $localstorage.get('login_token'),
                            'description': userData.description,
                            'is_private': userData.is_private,
                            'search_visibility': userData.search_visibility,
                            'title': userData.title
                        });
                },
                fixListSearchVisibility: function(listData) {
                    // If a list is not public, don't set it's search type to public
                    if (listData.is_private != 0 ) {
                        listData.search_visibility = 1;
                    }
                    return listData;
                },
                getListStatus: function(listId) {
                    return  $http.get(apiUrl + '/api/lists/' + listId + '/status/?login_token=' + $localstorage.get('login_token')).then(function(response) {
                        console.log('---getListStatus: response.data--- ', response);
                        return response.data;
                    });
                },
                editGetItemsList: function(mylistId) {
                    //https://m.sandbox.giftster.com/api/lists/178118/edit/?login_token=138588$Qh2FWan4MrLq+nRxnHXfvOjYvZg=
                    return  $http.get(apiUrl + '/api/lists/' + mylistId + '/edit/?login_token=' + $localstorage.get('login_token')).then(function(response) {
                        if (response.data)
                            return response.data;
                        else
                            return false;
                    });
                },
                getItemsList: function(mylistId) {
                    var urlMethod = apiUrl;
                    if ($localstorage.get('login_token'))
                        urlMethod = apiUrl + '/api/lists/' + mylistId + '/items/new/?login_token=' + $localstorage.get('login_token');
                    else
                        urlMethod = apiUrl + '/api/items/' + mylistId;

                    // return  $http.get(apiUrl + '/api/lists/' + mylistId + '/items/new/?login_token=' + $localstorage.get('login_token')).then(function(response) {
                    return  $http.get(urlMethod).then(function(response) {
                        var allLists = [];
                        var newLists = null;
                        var userSettings = [];
                        var info_message = '';
                        var list_activeButton = '';
                        var iconLeft = 'item item-thumbnail-left';
                        console.log('!!!!!!!!!!!!!!getItemsList response.data', response);

                        if (response.data.length == 0 || response.data.error)
                            return data = {'new_lists': allLists, 'userSettings': {
                                    'info_message': response.data.error ? 'error: ' + response.data.error : 'error',
                                    'list_activeButton': ''
                                }};
                        if (response.data.list)
                            info_message = 'This list is empty. Touch the plus icon to add an item.';
                        else if (!response.data[0].id)
                            info_message = 'This list is empty. Touch the plus icon to add an item.';
                        else {
                            if (response.data[0].list)
                                list_activeButton = response.data[0].list.is_private;
                            $.each(response.data, function(key, list) {
                                // console.log('list= ', /[^$]/g.exec(list.price));
                                var status = '';
                                var statusclass = '';

                                if (list.available) {
                                    status = '1 of ' + list.quantity + ' available';
                                    statusclass = 'available';
                                }
                                if (list.held) {
                                    status = 'reserved';
                                    statusclass = 'held';
                                }
                                if (list.purchased) {
                                    status = 'purchased';
                                    statusclass = 'purchased';
                                }
                                if (list.held_by_me) {
                                    status = 'reserved by me';
                                    statusclass = 'heldbyme';
                                }
                                if (list.purchased_by_me) {
                                    status = 'purchased by me';
                                    statusclass = 'purchasedbyme';
                                }

                                newLists = {
                                    'id': list.id,
                                    'list_id': list.list_id,
                                    'title': list.title,
                                    'price': (/[^$]/g.exec(list.price) == 0) ? '$' + list.price : list.price, //(/[^$]/g.exec(list.price).index == 0) ? '$' + list.price : list.price,
                                    'link': list.link,
                                    'rank': list.rank,
                                    'image': (list.image != '' && list.image != null) ? 'https://s3-us-west-2.amazonaws.com/giftster.uploads/' + list.image : '', //'http://giftster.uploads.s3-us-west-2.amazonaws.com/' + list.image,
                                    'class_item': (list.image != '' && list.image != null) ? iconLeft : 'textOnly',
                                    'class_icon': (list.image != '' && list.image != null) ? '' : 'hide',
                                    'class_list_col': (list.image != '' && list.image != null) ? 'list-col-image' : 'list-col',
                                    'status': status,
                                    'statusclass': statusclass
                                };
                                allLists.push(newLists);
                                if (response.data.length == (key + 1))
                                    return {'new_lists': allLists, 'userSettings': {
                                            'info_message': info_message,
                                            'list_activeButton': list_activeButton
                                        }};

                            });
                        }
                        if (response.data[0])
                            if (response.data[0].quantity)
                                list_activeButton = response.data[0].quantity;
                        console.log('allLists = ', allLists);
                        console.log('userSettings = ', userSettings);
                        userSettings = {
                            'info_message': info_message,
                            'list_activeButton': list_activeButton
                        };
                        if (!allLists)
                            allLists = response.data.list;
                        console.log('2 allLists ---', allLists);
                        return data = {'new_lists': allLists, 'userSettings': userSettings};
                    });
                },
                setListsParams: function() {
                    listsSettings = {
                        list_text_visible: 'hide',
                        list_visible: 'hide',
                        class_right: 'hide',
                        icon_right: ''
                    };
                    return listsSettings;
                },
                addListsItem: function(mylistId, setrank, additem) {
                    //http://m.giftster.com/api/lists/165750/items/new/?login_token=779$/Mp2s9WrySDXIzMva+EeGqZRAPw=
                    //  
                    return RequestsAPI.post('/api/lists/' + mylistId + '/items/new/', {
                        'login_token': $localstorage.get('login_token'),
                        'description': additem.description,
                        'link': additem.link,
                        'price': additem.price,
                        'quantity': (additem.quantity >= 1) ? additem.quantity : 1,
                        'rank': setrank,
                        'store': additem.store,
                        'title': additem.title,
                        'image': additem.image
                    });
                },
                addListsItemPermsGroup: function(mylistId, setrank, permsGroups) {
                    //http://m.giftster.com/api/lists/165750/items/new/?login_token=779$/Mp2s9WrySDXIzMva+EeGqZRAPw=
                    //   return RequestsAPI.post('/api/lists/' + mylistId + '/items/new/', {
                    return RequestsAPI.post('/api/lists/' + mylistId + '/edit/', {
                        'login_token': $localstorage.get('login_token'),
                        'perms-group': permsGroups
                    });
                },
                fetch: function(link) {
                    $ionicLoading.hide();
                    //link=http://www.amazon.com/Harry-Potter-Sorcerers-Stone-Rowling/dp/059035342X
                    return RequestsAPI.post('/api/fetch/', {
                        'login_token': $localstorage.get('login_token'),
                        'link': link
                    });
                },
                editListsItem: function(mylistId, is_private, additem) {
                    return RequestsAPI.post('/api/lists/' + mylistId + '/edit/', {
                        'login_token': $localstorage.get('login_token'),
                        'title': additem.title,
                        'description': additem.description,
                        'is_private': is_private
                    });
                },
                delListsItem: function(itemId) {
                    return  $http.get(apiUrl + '/api/items/' + itemId + '/del/?login_token=' + $localstorage.get('login_token')).then(function(response) {
                        console.log('---delItem: response.data--- ', response);
                        return response.data;
                    });
                },
                updListsItem: function(mylistId, itemId, upditem) {
                    return  RequestsAPI.post('/api/lists/' + mylistId + '/items/' + itemId + '/', {
                        'login_token': $localstorage.get('login_token'),
                        'description': upditem.description,
                        'link': upditem.link,
                        'price': upditem.price,
                        'quantity': (upditem.quantity >= 1) ? upditem.quantity : 1,
                        'rank': upditem.rank,
                        'store': upditem.store,
                        'title': upditem.title,
                        'image': upditem.image
                    });
                },
                userGotList: function(mylistId, itemId) {
                    return  RequestsAPI.post('/api/lists/' + mylistId + '/items/' + itemId + '/', {
                        'login_token': $localstorage.get('login_token'),
                        'archive': 1
                    });
                },
                getUserGotList: function() {
                    return $http.get(apiUrl + '/api/mywishlist/?login_token=' + $localstorage.get('login_token')).then(function(response) {
                        console.log('mywishlist data ', response.data);
                        return response.data;
                    });
                },
                getAllLists: function() {
                    var login_token = $localstorage.get('login_token');
                    return   $http.get(apiUrl + '/api/mywishlist/?login_token=' + login_token).then(function(response) {
                        console.log('mywishlist data ', response.data);
                        console.log('response.data.length ', response.data.length);
                        if (response.data.error)
                            if (response.data.error === 'Invalid Token')
                                return response.data;

                        if (response.data.length == 0) {
                            var wLists = [];
                            wLists [0] = {
                                'id': 0,
                                'title': 'You have no lists.'
                            };
                            var userSettings = {
                                list_text_visible: 'show',
                                list_visible: 'hide',
                                class_right: 'hide',
                                icon_right: ''
                            };
                            return data = {'wish_lists': wLists, 'userSettings': userSettings};
                            //return data = {'wish_lists': wLists, 'class_right': 'hide', 'icon_right': ''};
                        } else {
                            var allLists = [];
                            var gotLists = null;
                            $.each(response.data, function(key, list) {
                                if (list.archivelist)
                                    gotLists = list;
                                else
                                    allLists.push(list);

                                if ((response.data.length == key + 1) && gotLists)
                                    allLists.push(gotLists);
                            });
                            // lists = response.data;
                            var userSettings = {
                                list_text_visible: 'hide',
                                list_visible: 'show',
                                class_right: '',
                                icon_right: 'item-icon-right'
                            };
                            return data = {'wish_lists': allLists, 'userSettings': userSettings};
                            // return data = {'wish_lists': response.data, 'userSettings': userSettings};
                            /*   lists = response.data;
                             var userSettings = {
                             list_text_visible: 'hide',
                             list_visible: 'show',
                             class_right: '',
                             icon_right: 'item-icon-right'
                             };
                             return data = {'wish_lists': response.data, 'userSettings': userSettings};
                             // return data = {'wish_lists': response.data, 'class_right': '', 'icon_right': 'item-icon-right'};
                             */
                        }
                    });
                }
            };
        }
        )

        //
        // Tab Groups ()
        // 
        .factory('Groups', function($http, apiUrl, $localstorage, RequestsAPI, transformRequestAsFormPost, customElements) {
            console.log('factory Groups');
            var groups = [];

            return {
                getGroups: function(method, groupTitle) {
                    return $http.get(apiUrl + '/api/' + method + '?login_token=' + $localstorage.get('login_token')).then(function(response) {
                        //console.log('getGroups - ', response);
                        var iconRight = 'item-icon-right';
                        var groupsResponse = [];
                        var groupsClasses = [];

                        if (response.data != null && response.data != undefined && response.data != '') {
                            if (method === 'groups/requested/') {
                                var allRequested = [];
                                $.each(response.data, function(key, group) {
                                    var newRequested = null;
                                    newRequested = {
                                        'id': group.id,
                                        'description': group.description,
                                        'title': group.title,
                                        'url_locator': group.url_locator,
                                        'date': moment(group.modified).format("MM/DD/YY"),
                                        'membership_id': group.membership_id,
                                        'membership_modified': moment(group.membership_modified).format("MM/DD/YY"),
                                    };
                                    allRequested.push(newRequested);

                                    console.log('allRequested - ', allRequested);
                                });
                                groupsResponse = allRequested;

                            } else
                                groupsResponse = response.data;

                            groupsClasses [0] = {
                                'icon_right': iconRight,
                                'view_class': ' ',
                                'class_value': ' '
                            };
                        } else {
                            groupsClasses [0] = {
                                'icon_right': ' ',
                                'view_class': 'hide',
                                'class_value': 'none_value'
                            };
                            groupsResponse [0] = {
                                'title': groupTitle,
                                'id': ''
                            };
                        }
                        return groups = {
                            'data': groupsResponse,
                            'class': groupsClasses
                        };
                    });
                },
                getMemberGroups: function(groupID) {
                    return $http.get(apiUrl + '/api/v2/groups/' + groupID + '/members/?login_token=' + $localstorage.get('login_token')).then(function(response) {
                        console.log('--- v2 getMemberGroups --- ', response.data);
                        var allMembers = [];
                        var allRequested = [];
                        //if (response.data.members[0].id != $localstorage.get('userid'))
                        //members = response.data.members;

                        if (response.data.requested.length != 0) {
                            $.each(response.data.requested, function(keyRequested, requested) {
                                var requestedDate = customElements.dateDiffFormat(requested.date);
                                var newRequested = null;
                                newRequested = {
                                    'id': requested.id,
                                    'name': requested.first_name + ' ' + requested.last_name,
                                    'email': requested.email,
                                    'date_last_login': 'Requested ' + requestedDate
                                };
                                allRequested.push(newRequested);

                            });
                        }
                        if (response.data.members.length != 0) {
                            $.each(response.data.members, function(key, member) {
                                var newMembers = null;
                                var memberDate = '';
                                if (member.last_login)
                                    memberDate = customElements.dateDiffFormat(member.last_login);

                                newMembers = {
                                    'id': member.id,
                                    'membership_id': member.membership_id,
                                    'child_account_ids': member.child_account_ids,
                                    'name': member.first_name + ' ' + member.last_name,
                                    'email': member.email,
                                    'date_last_login': memberDate,
                                    'class_item': (member.is_draw_pick) ? 'item-icon-left santa-left' : '',
                                    'class_icon': (member.is_draw_pick) ? 'show' : 'hide',
                                    'class_icon_right': ' ',
                                    'group_owner': member.group_owner,
                                    'is_draw_pick': member.is_draw_pick
                                };
                                allMembers.push(newMembers);

                                if (member.child_accounts) {
                                    //my childs
                                    $.each(member.child_accounts, function(key, child) {
                                        // console.log('is_draw_pick  = ', child.is_draw_pick);
                                        var membersChilds = null;
                                        membersChilds = {
                                            'id': child.id,
                                            'parent_id': member.id,
                                            'name': child.first_name + ' ' + child.last_name,
                                            'parent': member.first_name + ' ' + member.last_name,
                                            'class_item': (child.is_draw_pick) ? 'item-icon-left santa-child-left' : 'item-icon-left child-left', //(child.id=='138587')? 'item-icon-left santa-child-left' : 'item-icon-left child-left',
                                            'class_icon_right': ' ',
                                            'class_icon': ' ',
                                            'is_draw_pick': child.is_draw_pick
                                        };
                                        allMembers.push(membersChilds);
                                    });
                                }
                            });
                        }

                        return {'members': allMembers, 'requested': allRequested};
                    });
                },
                allowGroup: function(groupID, requesteID) {
                    // /api/groups/31406/decline/138588/?login_token=138584$o1tx+y+9p6r1c7dp3olFGEX3p3Y=           
                    return RequestsAPI.post('/api/groups/' + groupID + '/decline/' + requesteID + '/', {
                        'login_token': $localstorage.get('login_token')
                    });
                },
                denyGroup: function(groupID, requesteID) {
                    ///api/groups/31406/approve/138588/?login_token=138584$o1tx+y+9p6r1c7dp3olFGEX3p3Y= 
                    return RequestsAPI.post('/api/groups/' + groupID + '/approve/' + requesteID + '/', {
                        'login_token': $localstorage.get('login_token')
                    });
                },
                createGroup: function(userData) {
                    return RequestsAPI.post('/api/groups/new/', {
                        'login_token': $localstorage.get('login_token'),
                        'title': userData.name,
                        'description': ' '
                    });
                },
                editGroup: function(groupID, title) {
                    ///api/groups/31406/?login_token=138584$o1tx+y+9p6r1c7dp3olFGEX3p3Y=
                    return RequestsAPI.put('/api/groups/' + groupID + '/', {
                        'login_token': $localstorage.get('login_token'),
                        'title': title
                    });
                },
                deleteGroup: function(groupID) {
                    return $http.get(apiUrl + '/api/groups/' + groupID + '/del/?login_token=' + $localstorage.get('login_token')).then(function(response) {
                        console.log('deleteGroup response - ', response);
                        if (response.data.success === "deleted")
                            return true;
                        else
                            return false;
                    });
                },
                deleteInvitedGroup: function(groupID, membersID) {
                    return RequestsAPI.post('/api/groups/' + groupID + '/cancel/' + $localstorage.get('userid') + '/', {
                        'login_token': $localstorage.get('login_token')
                    });
                },
                deleteMembership: function(groupID, membersID) {
                    return $http.delete(apiUrl + '/api/groups/' + groupID + '/members/' + membersID + '/?login_token=' + $localstorage.get('login_token')).then(function(response) {
                        console.log('response =', response);
                        return response.data;
                    });
                },
                accept: function(groupID) {
                    return $http.get(apiUrl + '/api/groups/' + groupID + '/accept/?login_token=' + $localstorage.get('login_token')).then(function(response) {
                        console.log('accept response - ', response);
                        if (response.data.success == "True")
                            return true;
                        else
                            return false;
                    });
                },
                decline: function(groupID) {
                    return RequestsAPI.post('/api/groups/' + groupID + '/decline/' + $localstorage.get('userid') + '/', {
                        'login_token': $localstorage.get('login_token')
                    });
                },
                cancel: function(groupID) {
                    return RequestsAPI.post('/api/groups/' + groupID + '/cancel/' + $localstorage.get('userid') + '/', {
                        'login_token': $localstorage.get('login_token')
                    });
                },
                joinGroup: function(groupID) {
                    return RequestsAPI.post('/api/groups/' + groupID + '/request/', {
                        'login_token': $localstorage.get('login_token')
                    });
                },
                reSendInvitet: function(groupID, memberID) {
                    return $http.get(apiUrl + '/api/groups/' + groupID + '/members/' + memberID + '/reinvite/?login_token=' + $localstorage.get('login_token')).then(function(response) {
                        console.log('decline response - ', response);
                        return response;
                    });
                },
                inviteMember: function(groupID, thenameemail) {
                    //http://m.giftster.com/api/groups/246/invite/?login_token=779$/Mp2s9WrySDXIzMva+EeGqZRAPw=
                    return RequestsAPI.post('/api/groups/' + groupID + '/invite/', {
                        'login_token': $localstorage.get('login_token'),
                        'invites': thenameemail
                    });
                }
            };
        })

        .factory('News', function($http, apiUrl, $localstorage, customElements) {
            var news = [];

            return {
                all: function() {
                    return  $http.get(apiUrl + '/api/notifications/?page=1&login_token=' + $localstorage.get('login_token')).then(function(response) {
                        //return  $http.get('http://m.sandbox.giftster.com/api/notifications/?page=1&login_token=' + $localstorage.get('login_token')).then(function(response) {
                        news = response.data;
                        //console.log('news---', news.length);
                        var items = [];
                        if (news.length > 0) {
                            $.each(response.data, function(key, val) {
                                var myitem = null;
                                var memberDate = '';
                                if (val.updated_on)
                                    memberDate = customElements.dateDiffFormat(val.updated_on);
                                myitem = {
                                    'title': val.requester.first_name + ' ' + val.requester.last_name + ' ' + val.content.text + ' ' + val.content.content_object.title,
                                    'info': val.content.additional_info,
                                    'date': memberDate,
                                    'class': ''
                                };
                                items.push(myitem);
                            });
                        } else {
                            var myitem = null;
                            myitem = {
                                'title': 'No items in your news feed.',
                                'info': '',
                                'class': 'standardlist'
                            };
                            items.push(myitem);
                        }
                        return items;
                    });
                },
                remove: function(one_news) {
                    news.splice(news.indexOf(one_news), 1);
                },
                get: function(one_newsId) {
                    for (var i = 0; i < news.length; i++) {
                        if (news[i].id === parseInt(one_newsId)) {
                            return news[i];
                        }
                    }
                    return null;
                }
            };
        })
        .factory('ShoppingList', function($http, apiUrl, $localstorage) {
            return {
                all: function() {
                    return  $http.get(apiUrl + '/api/my-shopping-list/?login_token=' + $localstorage.get('login_token')).then(function(response) {
                        var shoppingLists = [];
                        var allListsPurchased = [];
                        var allListsReserved = [];
                        var shoppinglist_visible = '';
                        shoppingLists = response.data;
                        console.log('shoppingLists---', shoppingLists);
                        //console.log('shoppingLists.length---', shoppingLists.length);
                        if (shoppingLists.length > 0) {
                            $.each(shoppingLists, function(key, val) {
                                var newLists = null;
                                var status = '';
                                var statusclass = '';

                                if (val.available) {
                                    status = '1 of ' + val.quantity + ' available';
                                    statusclass = 'available';
                                }
                                if (val.held) {
                                    status = 'reserved';
                                    statusclass = 'held';
                                }
                                if (val.purchased) {
                                    status = 'purchased';
                                    statusclass = 'purchased';
                                }
                                if (val.held_by_me) {
                                    status = 'reserved by me';
                                    statusclass = 'heldbyme';
                                }
                                if (val.purchased_by_me) {
                                    status = 'purchased by me';
                                    statusclass = 'purchasedbyme';
                                }
                                newLists = {
                                    'id': val.id,
                                    "list_id": val.list_id,
                                    'title': val.title,
                                    'price': (val.price >= 0 && val.price != null && val.price != '') ? '$' + val.price : val.price,
                                    'rank': val.rank,
                                    'image': '', //list.image,
                                    'class_item': '', //(list.image != '') ? iconLeft : '',
                                    'class_icon': 'hide', //(list.image != '') ? '' : 'hide',
                                    'class_list_col': 'list-col', //(list.image != '') ? 'list-col-image' : 'list-col',
                                    'view_class': '',
                                    'status': status,
                                    'statusclass': statusclass
                                };

                                if (val.global_purchased === true) {
                                    allListsPurchased.push(newLists);

                                } else {
                                    allListsReserved.push(newLists);
                                }
                                // items.push(newLists);
                            });
                        } else {
                            var newLists = null;
                            newLists = {
                                'id': '',
                                'list_id': '',
                                'title': 'No Items marked purchased',
                                'price': '',
                                'rank': '',
                                'image': '',
                                'class_item': '',
                                'class_icon': 'hide',
                                'class_list_col': 'list-col',
                                'view_class': 'hide'
                            };
                            if (allListsPurchased === '') {
                                allListsPurchased.push(newLists);

                            } else if (allListsReserved === '') {
                                allListsReserved.push(newLists);
                            }
                            if (shoppingLists.length === 0)
                                shoppinglist_visible = 'hide';

                        }
                        var items = {
                            'purchased': allListsPurchased,
                            'reserved': allListsReserved,
                            'shoppinglist_visible': shoppinglist_visible
                        };

                        console.log('---items---', items);
                        return items;
                    });

                }
            };
        })

        .factory('AllEvents', function($http, apiUrl, $localstorage) {
            var events = [];
            return {
                all: function() {
                    return  $http.get(apiUrl + '/api/events/90days/?login_token=' + $localstorage.get('login_token')).then(function(response) {
                        events = response.data.events;
                        console.log('events---', events);
                        console.log('events.length---', events.length);
                        var items = [];
                        if (events.length > 0) {
                            $.each(events, function(key, val) {
                                var myitem = null;
                                var lm = val.date;
                                var dadate = lm.substring(0, 10);
                                myitem = {
                                    'title': val.title,
                                    'date': dadate,
                                    'class_events': '',
                                    'class_info': 'hide'
                                };
                                items.push(myitem);
                            });
                        } else {
                            var myitem = null;
                            myitem = {
                                'info1': "You have no events.",
                                'info2': "The events displayed here are upcoming event dates added by you or others in your groups.",
                                'info3': "Add or edit events for your account at",
                                'url': "www.giftster.com",
                                'class_events': 'hide',
                                'class_info': ''
                            };
                            items.push(myitem);
                        }
                        console.log('---events---', events);
                        return items;
                    });

                }
            };
        })

        .factory('RedirectToService', function($http, $localstorage, $state, $timeout, apiUrl, webUrl) {
            // Convenience functions for redirecting a user from a logged out item detail
            // page, back to this same page after they log in or sign up.

            redirect = {}

            redirect.set = function(redirectType, data) {
                $localstorage.setObject('redirectTo', { 
                    'type': redirectType,
                    'data': data
                })
            }

            redirect.remove = function() {
                $localstorage.destroy('redirectTo');
            }

            redirect.active = function(){

                stored_redirect = $localstorage.getObject('redirectTo')                    

                if ( stored_redirect.data) {
                    return true;
                }

                return false;
            }

            redirect.execute = function(){

                stored_redirect = $localstorage.getObject('redirectTo')

                // Redirect user to a specific item simulating the result of a search
                if (stored_redirect.type =='gift-list-item') {
                    $state.go('tab.more', {'tab': 'more'}, {reload: true}).then(function(){
                        $timeout(function (){
                            $state.go('tab.more-search', {'tab': 'more'}, {reload: true}).then(function (){
                                $timeout(function (){
                                    $state.go('tab.more-search-result-member', {'memberId': stored_redirect.data.member.id,'tab': 'more'}, {reload: true}).then(function (){
                                        $timeout(function (){
                                            $state.go('tab.more-search-mylists-list', {"memberlistId": stored_redirect.data.member.id, "listId": stored_redirect.data.wishlist.id, 'tab': 'more'}, {reload: true}).then(function (){
                                                $timeout(function (){
                                                    $state.go('tab.more-shoppinglist-list-item', {'memberlistId': stored_redirect.data.member.id, 'listId': stored_redirect.data.wishlist.id, 'listitemId': stored_redirect.data.item.id, 'tab': 'more'}, {reload: true}).then(function (){
                                                        redirect.remove() // Clean up local storage as to not re-re-direct in the future
                                                    })
                                                })
                                            })
                                        })
                                    })
                                })
                            })
                        }) 
                    })

                // Redirect user to a specific list in shop for view
                } else if (stored_redirect.type == 'gift-list') {

                    /// First determine if we have permission to redirect to this gift list
                    var permission_url = apiUrl +
                              '/api/v2/wishlist/' + stored_redirect.data.wishlist.locator +
                              '/permission/?login_token=' +$localstorage.get('login_token')                

                    $http.get(permission_url).then(function(response) {
                        var permission = response.data.permission

                        // Redirect to shop for tab if user is in shared group with list owner
                        if (permission === 'group') {

                            // Shop For tab
                            $state.go('tab.members', {}, {reload: true}).then(function(){
                                $timeout(function () {

                                    // Shop For -> Member Lists
                                     $state.go(
                                         'tab.shop-memberlists',
                                         {
                                             'memberlistId': stored_redirect.data.member.id,
                                             'name': 'parent',
                                             'tab': 'shop'
                                         }
                                     ).then(function() {
                                         $timeout(function () {

                                            // Member Lists -> List Detail
                                            $state.go(
                                                'tab.memberlists-list',
                                                {
                                                    'memberlistId': stored_redirect.data.member.id,
                                                    'listId': stored_redirect.data.wishlist.id,
                                                    'tab': 'shop'
                                                }
                                            ).then(function() {
                                                $timeout(function () {
                                                    redirect.remove()
                                                })
                                            })
                                         })
                                        
                                     })
                                 })
                            })                
                    
                        // Requesting user does not have permission to view this list
                        } else if (permission === null) {
                            var list_locator = stored_redirect.data.wishlist.locator;
                            window.location.replace(
                                webUrl + '/account/circumvent_mobile/?next=' + webUrl + '/gift/' +list_locator + '/'
                            )
                        }                        
                });

                
                // Simply redirect user to 'group' tab
                } else if (stored_redirect.type == 'groups') {
                    // Shop For tab
                    $state.go('tab.members', {}, {reload: true}).then(function(){
                        $timeout(function () {

                            $state.go('tab.groups', {}, {reload: true, inherit: false}).then(function() {
                                redirect.remove()
                            });   
                        }, 1000)
                    })

                // Simply redirect user to 'my lists' tab
                } else if (stored_redirect.type == 'lists') {
                    // Shop For tab
                    $state.go('tab.members', {}, {reload: true}).then(function(){
                        $timeout(function () {

                            // Even though this looks like gift prefs, it's actually my lists, bad naming
                            $state.go('tab.preferences', {}, {reload: true, inherit: false}).then(function() {
                                redirect.remove()
                            });   
                        }, 1000)
                    })
                }

            }

            return redirect;
        })



        .factory('Blog', function($http, apiUrl, $localstorage) {
            var blogNews = [];
            return {
                all: function() {
                    return  $.ajax({
                        type: "GET",
                        url: 'https://www.giftster.com/news/feed/', //  url: apiUrl + '/news/feed/rss/',
                        dataType: "xml",
                        success: function parseMe(xml) {
                            return xml;
                        }
                    });
                }
            };
        })
        .factory('ModificationOfData', function() {
            var find = [/&#8217;/, /&#8230;/, /&#8220;/, /&#8221;/, /&#38;/];
            var replace = ["’", "…", '“', '”', '&'];
            return {
                decodeText: function(element) {
                    return str_replace(find, replace, element);
                }
            };
        })
        /**
         * A simple example service that returns some data.
         */
        .factory('Friends', function() {
            // Might use a resource here that returns a JSON array

            // Some fake testing data
            var friends = [{
                    id: 0,
                    name: 'Ben Sparrow',
                    notes: 'Enjoys drawing things',
                    face: 'https://pbs.twimg.com/profile_images/514549811765211136/9SgAuHeY.png'
                }, {
                    id: 1,
                    name: 'Max Lynx',
                    notes: 'Odd obsession with everything',
                    face: 'https://avatars3.githubusercontent.com/u/11214?v=3&s=460'
                }, {
                    id: 2,
                    name: 'Andrew Jostlen',
                    notes: 'Wears a sweet leather Jacket. I\'m a bit jealous',
                    face: 'https://pbs.twimg.com/profile_images/491274378181488640/Tti0fFVJ.jpeg'
                }, {
                    id: 3,
                    name: 'Adam Bradleyson',
                    notes: 'I think he needs to buy a boat',
                    face: 'https://pbs.twimg.com/profile_images/479090794058379264/84TKj_qa.jpeg'
                }, {
                    id: 4,
                    name: 'Perry Governor',
                    notes: 'Just the nicest guy',
                    face: 'https://pbs.twimg.com/profile_images/491995398135767040/ie2Z_V6e.jpeg'
                }];


            return {
                all: function() {
                    return friends;
                },
                get: function(friendId) {
                    // Simple index lookup
                    return friends[friendId];
                }
            };
        })
        .factory('Search', function($http, apiUrl, $localstorage) {
            var searchResult = [];
            return {
                memberSearch: function(val) {

                    auth_string = ''

                    if ( $localstorage.get('login_token') ) {
                        auth_string = '&login_token=' + $localstorage.get('login_token');
                    }

                    return $http.get(apiUrl + '/api/user/search/?q=' + encodeURIComponent(val) + auth_string, {timeout: 30000}).then(function(response) {
                        //console.log('response.data - ', response.data);
                        if (response.data) {
                            searchResult = response.data;
                            return response.data;
                        } else
                            return false;
                    }).finally(function() {
                        return false;
                    });
                },
                getMemberResult: function(id) {
                    var groupsInfo = '';
                    var listsInfo = '';
                    var userPreferences = [];
                    var preferences = [];
                    if ($localstorage.get('login_token')) {
                        for (var i = 0; i < searchResult.length; i++) {
                            console.log('searchResult = ', searchResult);
                            if (searchResult[i].id == id) {
                                var grLength = searchResult[i].groups;
                                var lsLength = searchResult[i].lists;

                                groupsInfo = (grLength.length > 0) ? 'hide' : 'show';
                                listsInfo = (lsLength.length > 0) ? 'hide' : 'show';
                                preferences = {'id': searchResult[i].id, 'name': searchResult[i].first_name + ' ' + searchResult[i].last_name, 'preferences': searchResult[i].preferences},
                                userPreferences.push(preferences);
                                return  {
                                    'preferences': userPreferences,
                                    'data': searchResult[i],
                                    'settings': {'groups_info': groupsInfo, 'lists_info': listsInfo}
                                };
                            }
                        }
                    } else {
                        for (var i = 0; i < searchResult.length; i++) {
                            if (searchResult[i].id == id) {
                                var grLength = searchResult[i].groups;
                                var lsLength = [];
                                var publicLists = [];
                                var newSearchResult = [];
                                newSearchResult = searchResult[i];
                                $.each(newSearchResult.lists, function(key, val) {

                                    if (val.is_private == 0)
                                        publicLists.push(val);

                                    if (newSearchResult.lists.length == (key + 1)) {
                                        lsLength = publicLists;
                                        groupsInfo = (grLength.length > 0) ? 'hide' : 'show';
                                        listsInfo = (lsLength.length > 0) ? 'hide' : 'show';
                                        preferences = {
                                            'id': searchResult[i].id,
                                            'first_Name': searchResult[i].first_name,
                                            'last_name': searchResult[i].last_name,
                                            'name': searchResult[i].first_name + ' ' + searchResult[i].last_name,
                                            'preferences': searchResult[i].preferences
                                        },
                                        userPreferences.push(preferences);
                                        newSearchResult.lists = publicLists;

                                        return {
                                            'preferences': userPreferences,
                                            'data': newSearchResult,
                                            'settings': {'groups_info': groupsInfo, 'lists_info': listsInfo}
                                        };
                                    }
                                });

                                return {
                                    'preferences': userPreferences,
                                    'data': newSearchResult,
                                    'settings': {'groups_info': groupsInfo, 'lists_info': listsInfo}
                                };

                            }
                        }
                    }

                    return null;
                }
            };
        })
        .factory('Mores', function($http, apiUrl, $localstorage, RequestsAPI) {

            return {
                all: function() {
                    var user = $localstorage.getObject('user');
                    console.log('user=', user);
                    var mores = [{
                            id: 0,
                            name: 'Quickstart',
                            description: '',
                            url: '#/tab/more/quick_start',
                            click: "quickStart()",
                            item_class: 'item-one'
                        }, {
                            id: 1,
                            name: 'Member Search',
                            description: 'Find members, join groups, view their lists',
                            url: '#/tab/more/membersearch',
                            click: "search()",
                            class: ' '
                        }, {
                            id: 2,
                            name: 'My Shopping List',
                            description: 'Items I’ve marked purchased or reserved',
                            url: '#/tab/more/members',
                            click: "shoppingList()",
                            item_class: ' '
                        }, {
                            id: 3,
                            name: 'Next 90 Days Events',
                            description: '',
                            url: '#/tab/more/events',
                            click: "events()",
                            item_class: 'item-one'
                        }, {
                            id: 4,
                            name: 'Recent Blog Posts',
                            description: '',
                            url: '#/tab/more/blog',
                            click: "blog()",
                            item_class: 'item-one'
                        }, {
                            id: 5,
                            name: 'About Giftster',
                            description: '',
                            url: '#/tab/more/about',
                            click: "about()",
                            item_class: 'item-one'
                        }, {
                            id: 6,
                            name: 'Logout',
                            description: user.first_name + ' ' + user.last_name + ' ' + user.email,
                            url: '#/tab/logout',
                            click: "logout()",
                            item_class: ' '
                        }
                    ];
                    return mores;
                },
                remove: function(more) {
                    mores.splice(mores.indexOf(more), 1);
                },
                get: function(moreId) {
                    for (var i = 0; i < mores.length; i++) {
                        if (mores[i].id === parseInt(moreId)) {
                            return mores[i];
                        }
                    }
                    return null;
                },
                getUserSettings: function() {
                    return $http.get(apiUrl + '/api/user/settings/?login_token=' + $localstorage.get('login_token')).then(function(response) {
                        console.log('---getUserSettings: response.data--- ', response.data);
                        return response.data;
                    });
                },
                updateUserSettings: function(user, birthday) {
                    return RequestsAPI.post('/api/user/settings/?login_token=' + $localstorage.get('login_token'), {
                        // 'login_token': $localstorage.get('login_token'),
                        "birthday_month": birthday.birthday_month,
                        "birthday_day": birthday.birthday_day,
                        "birthday_year": birthday.birthday_year,
                        "last_name": user.last_name,
                        "email": user.email,
                        "first_name": user.first_name
                    });
                },
                closeUserAccount: function() {
                    return RequestsAPI.put('/api/user/settings/active/', {
                        "login_token": $localstorage.get('login_token'),
                        "is_active": 0
                    });
                    /*
                     return $http.get(apiUrl + '/api/user/settings/close/?login_token=' + $localstorage.get('login_token')).then(function(response) {
                     console.log('---closeUserAccount: response.data--- ', response.data);
                     return response.data;
                     });*/
                },
                reopenUserAccount: function() {
                    return RequestsAPI.put('/api/user/settings/active/', {
                        "login_token": $localstorage.get('login_token'),
                        "is_active": 1
                    });
                }
            };
        })

