angular.module('starter.controllers', ['ionic.rating'])
        .constant('apiUrl', 'https://m.giftster.com')
        .constant('webUrl', 'https://www.giftster.com')
        .constant('fbAuthUrl', 'https://www.giftster.com/facebook/authdialog/')

        // .constant('apiUrl', 'https://giftster.local:8000')
        // .constant('webUrl', 'https://giftster.local:8000')
        // .constant('fbAuthUrl', 'https://giftster.local:8000/facebook/authdialog/')

        // .constant('apiUrl', 'https://giftster.local')
        // .constant('webUrl', 'https://giftster.local')
        // .constant('fbAuthUrl', 'https://giftster.local/facebook/authdialog/')

        // .constant('apiUrl', 'https://m.staging.giftster.com')
        // .constant('webUrl', 'https://staging.giftster.com')
        // .constant('fbAuthUrl', 'https://staging.giftster.com/facebook/authdialog/')


        .constant("globalImages", {
            "icon_plus_green": "./img/pages/icon_plus_green.png",
            "icon_btn_search": "./img/pages/button/btn_search.png",
            "icon_help": "./img/pages/icon/icon_help.png",
            "icon_settings": "./img/pages/icon/icon_settings.png",
            "icon_save": "./img/pages/icon_save.png",
            "icon_arrow": "../img/pages/icon/icon_arrow.png", //icon join
            "icon_share_arrow": "../img/pages/icon/icon_share_arrow.png",
            "icon_checkmark": "./img/pages/icon/icon_checkmark.png",
            "tab_bar_reserve": "../img/tabs/tab_bar_reserve.png",
            "tab_bar_release": "../img/tabs/tab_bar_release.png",
            "tab_bar_btn_shop_active": "../img/tabs/tab_bar_btn_shop_active.png"

        })



        .controller('appCtrl', function($scope, $rootScope, $state, AuthService, EVENTS, $localstorage, Session) {
            $scope.currentUser = null;
            $scope.isAuthorized = AuthService.isAuthorized;
            $scope.setCurrentUser = function(user) {
                $scope.currentUser = user;
            };
            $scope.isMobileWebsite = isMobileWebsite;
            function logout() {
                AuthService.logout();
            }
            function redirectToLogin() {
                $state.go('tab2.login', {}, {reload: true, inherit: false});
            }
            if ($localstorage.isSet('user') && Session.user == null) {
                Session.create($localstorage.getObject('user'));
                $scope.setCurrentUser($localstorage.getObject('user'));
                $state.go('cobranzas.clientes.index');
            }
            // We listen to auth related broadcasts.
            $scope.$on(EVENTS.notAuthenticated, logout);
            $scope.$on(EVENTS.sessionTimeout, logout);
            $scope.$on(EVENTS.signupSuccess, logout);
            $scope.$on(EVENTS.logoutSuccess, redirectToLogin);
        })
        .controller('IndexCtrl', function($scope, $timeout, $window, $ionicScrollDelegate, $state, $localstorage, customElements, $ionicHistory, $ionicTabsDelegate, $ionicPopup, globalImages, webUrl) {
            //$('.bar .back-button').addClass('hide');
            console.log('getObject user =', $localstorage.getObject('user'));
            ga_send_pageview('Home Page');
            $scope.header_title = ' ';
            $scope.searchtext = {title: null};
            $scope.tabsSettings = [{login_page: 'show', search_page: 'hide', login_tab: '', search_tab: '', site_tab: ''}];
            $scope.globalImages = {
                footer_img_pages: globalImages.footer_img_pages
            };
            function headerHide() {
                $(".nav-bar-block").addClass("hide");
                $(".header_shadow").css("margin-top", "0px");
                $(".header_top").css("margin-top", "-7px");
                $(".page_index").css("top", "0px");
            }
            function headerShow() {
                $(".nav-bar-block").removeClass("hide");
                $(".header_shadow").css("margin-top", "44px");
                $(".header_top").css("margin-top", "36px");
                $(".page_index").css("top", "44px");
            }
            headerHide();

            if ($localstorage.get('login_token') && $localstorage.get('userid') && $localstorage.get('userfullname') && $localstorage.get('userfirstname')) {
                headerShow();
                $state.go('tab.members', {});
            } else if ($localstorage.get('login_token')) {
                $localstorage.set('login_token', false);
                $localstorage.clear();
                $ionicHistory.clearCache();
                $ionicHistory.clearHistory();
                if ($localstorage.getObject('user'))
                    $localstorage.setObject('user', []);
                console.log('getObject user =', $localstorage.getObject('user'));
            }

            $scope.selectTabWithIndex = function(index) {
                $ionicTabsDelegate.select(index);
                if (index == 0) {
                    $scope.tabsSettings = [{login_page: 'show', search_page: 'hide', login_tab: 'tab-item-active', search_tab: '', site_tab: ''}];
                    headerHide();
                } else if (index == 1) {
                    $scope.tabsSettings = [{login_page: 'hide', search_page: 'show', login_tab: '', search_tab: 'tab-item-active', site_tab: ''}];
                    $ionicScrollDelegate.scrollTop();
                    $scope.header_title = 'Member Search';
                    headerShow();
                }
            };
            $scope.signup = function() {
                headerShow();
                $state.go('signup', {}, {reload: true, inherit: false});
            };
            $scope.login = function() {
                headerShow();
                $state.go('login-tabs', {'tabId': 0}, {reload: true, inherit: false});
                // $state.go('tab2.login', {}, {reload: true, inherit: false});//not work good
            };
            $scope.search = function() {
                headerShow();
                console.log('$scope.searchtext.title - - - ', $scope.searchtext.title);
                if (!$scope.searchtext.title) {
                    return customElements.alert('Whoops!', "<style>.popup-buttons .button.button-positive {   margin-left: 25%; margin-right: 25%; }</style><p>Please enter a name or email address</p>", 'ok', 'button-positive');
                }
                $state.go('search-results', {"name": $scope.searchtext.title, "tab": 'search'}, {reload: true, inherit: false});
            };

            $scope.GoToLink = function(urlWebsite) {
                
                // mobile site and native apps open links slightly different
                if (isMobileWebsite) {
                    openMethod = '_self';
                } else {
                    openMethod = '_system';
                }

                $window.open(urlWebsite, openMethod, 'location=yes,enableViewportScale=yes');
            }

            $scope.GoToFullWebsite = function() {
                var url = webUrl + '/account/circumvent_mobile/?next=' + webUrl
                $scope.GoToLink(url)
            };

        })


        .controller('redirectToGiftListCtrl', function($ionicHistory, $state, $stateParams, AuthService, RedirectToService, customElements) {
            $ionicHistory.clearHistory();
            var memberID = $stateParams.memberID;
            var listID = $stateParams.listID;
            var locator = $stateParams.locator;
            var loggedIn = AuthService.isAuthenticated();
            var data = {
                member: { id: memberID },
                wishlist: { id: listID, locator: locator }
            }

            RedirectToService.set('gift-list', data)

            if (loggedIn) {
                RedirectToService.execute();
            
            } else {

                return customElements.popup(
                    'Wishlist access', 'Sign up or log in to see this wishlist',
                    'sign up', 'button-positive', '<b>login</b>', 'yellow-btn')

                    .then(function(response) {

                        if (response) {
                            $state.go('login-tabs', {tabId: 1})

                        } else {
                            $state.go('signup', {}, {reload: true, inherit: true});
                        }
                });
            }

        })

        .controller('redirectToGroupsTabCtrl', function($ionicHistory, $state, AuthService, RedirectToService, customElements) {

            var loggedIn = AuthService.isAuthenticated();

            RedirectToService.set('groups', {})

            if (loggedIn) {
                RedirectToService.execute();
            
            } else {

                return customElements.popup(
                    'Manage membership', 'Sign up or log in to complete this action',
                    'sign up', 'button-positive', '<b>login</b>', 'yellow-btn')

                    .then(function(response) {

                        if (response) {
                            $state.go('login-tabs', {tabId: 1}, {reload: true, inherit: true})

                        } else {
                            $state.go('signup', {}, {reload: true, inherit: true});
                        }
                });
            }
        })


        .controller('redirectToListsCtrl', function($ionicHistory, $state, AuthService, RedirectToService, customElements) {

            var loggedIn = AuthService.isAuthenticated();

            RedirectToService.set('lists', {})

            if (loggedIn) {
                RedirectToService.execute();
            
            } else {

                return customElements.popup(
                    'View my lists', 'Sign up or log in to complete this action',
                    'sign up', 'button-positive', '<b>login</b>', 'yellow-btn')

                    .then(function(response) {

                        if (response) {
                            $state.go('login-tabs', {tabId: 1}, {reload: true, inherit: true})

                        } else {
                            $state.go('signup', {}, {reload: true, inherit: true});
                        }
                });
            }
        })
        .controller('MainCtrl', function($state, $ionicHistory, $ionicPopup, $ionicLoading, $localstorage, RedirectToService) {

            this.onTabSelected = function(_scope) {

                console.log("onTabSelected - main ", _scope.title);
                // if we are selectng the home title then 
                // change the state back to the top state

                // Perform conncetion check
                if (window.Connection)
                    if (navigator.connection.type == Connection.NONE)
                        $ionicPopup.alert({
                            title: "Connection lost",
                            content: "You are not connected to the internet. Please turn off airport mode or restore your internet connection to proceed."
                        }).then(function(result) {
                            $ionicLoading.hide();
                        });




                // Clear tab history when tapping and "root" tab
                // Needs to be skipped in certain situations

                clear_history = true;

                // Redirection from shop for to previously selected list will create
                // redirect loop if this clear history and redirect is applied.

                if ( RedirectToService.active() ) {
                    clear_history = false;
                }

                // Don't enable this when debugging
                if (clear_history) {
                    $ionicHistory.clearHistory();

                    if (_scope.title === 'shop for') {
                        setTimeout(function() {
                            $state.go('tab.members', {});
                        }, 20);
                    } else if (_scope.title === 'my lists') {
                        setTimeout(function() {
                            $state.go('tab.preferences', {});
                        }, 1000);
                    } else if (_scope.title === 'groups') {
                        setTimeout(function() {
                            $state.go('tab.groups', {});
                        }, 20);
                    } else if (_scope.title === 'more') {
                        setTimeout(function() {
                            $state.go('tab.more', {}, {reload: true, inherit: false});
                        }, 20);
                    }
                }

            };
            this.onTabDeselected = function() {
                console.log("onTabDeselected -  main");
            };

        })
        .controller('SignupCtrl', function($scope, $state, $localstorage, $ionicHistory, $ionicModal, $ionicScrollDelegate, AuthService, $window, $filter, fbAuthUrl, customElements, RedirectToService, Groups) {
            ga_send_pageview('Signup Page');
            $scope.acceptInvite = Groups.accept;
            $scope.message = "";
            $scope.type_pass = 'password';
            $scope.user = {first_name: null, last_name: null, email: null, password: null, password2: null, birthday_date: null, birthday_day: '', birthday_month: '', birthday_year: '', group_locator: '', token:''};


            var url_ = location.hash.replace('#\/signup?','', '').split('&').reduce(function(s, c) {
                var t = c.split('=');
                s[t[0]] = t[1];
                return s;
            }, {});
            console.log('URL=', url_);
            if (url_.token && url_.grouplocator) {
                $scope.user.first_name = url_.fn;
                $scope.user.last_name = url_.ln;
                $scope.user.email = decodeURIComponent(url_.email);
                $scope.user.group_locator = url_.grouplocator;
                $scope.user.token = url_.token;
            }
            
            $scope.changeMonth = function(val) {
                $scope.user.birthday_month = val;
            };

            $scope.changeDay = function(val) {
                $scope.user.birthday_day = val;
            };

            $scope.changeYear = function(val) {
                $scope.user.birthday_year = val;
            };
            
            $scope.changeDate = function() {
             console.log($scope.user.birthday_date);
             $scope.user.birthday_month = $filter("date")($scope.user.birthday_date, 'MM');
             $scope.user.birthday_day = $filter("date")($scope.user.birthday_date, 'dd');
             $scope.user.birthday_year = $filter("date")($scope.user.birthday_date, 'yyyy');
             console.log('$scope.birthday_month - - ', $scope.birthday_month);
             console.log('$scope.birthday_day - - ', $scope.birthday_day);
             console.log('$scope.birthday_year - - ', $scope.birthday_year);
             };
             
            $scope.showPassword = function() {
                $scope.type_pass = ($scope.type_pass == 'password') ? 'text' : 'password';
                document.getElementById('input_pass').type = $scope.type_pass;
            };

            $ionicModal.fromTemplateUrl('rules-modal.html', {
                scope: $scope,
                animation: 'slide-in-up'
            }).then(function(modal) {
                $scope.modal = modal;
            });

            $scope.tos = function(wishList, memberID) {
                $scope.modal.show();
            };
            $scope.closeModal = function() {
                $scope.modal.hide();
            };
            $scope.$on('$destroy', function() {
                $scope.modal.remove();
            });

            $scope.changeBirthday = function() {
                $scope.addChildAccount.userprofile.birthday_month = $filter("date")($scope.user.birthday_date, 'MM');
                $scope.addChildAccount.userprofile.birthday_day = $filter("date")($scope.user.birthday_date, 'dd');
                $scope.addChildAccount.userprofile.birthday_year = $filter("date")($scope.user.birthday_date, 'yyyy');
            };

            $scope.signup = function() {
                console.log('$scope.user =', $scope.user);
                
                AuthService.createUser($scope.user).then(function(response) {
                    console.log('getToken then user--', response);
                    if (response.data.errors) {

                        customElements.alert('Oops', "<style>.popup-buttons .button.button-positive { margin-left: 25%; margin-right: 25%; }</style><p>Please ensure you filled in name, email and password. Choose Log In if an account with this email address already exists.</p>", 'ok', 'button-positive');

                        $ionicScrollDelegate.scrollTop();
                        return;
                    }

                    if (response) {
                        if (!RedirectToService.active() ) { // Don't show this popup on redirect to item
                            customElements.alert('Account Created', "<style>.popup-buttons .button.button-positive { margin-left: 25%; margin-right: 25%;} .popup { width: 75% !important;} </style><p>Let's get started.</p>", 'ok', 'button-positive');
                        }
                        var userData = {
                            username: $scope.user.email,
                            password: $scope.user.password
                        };


                        AuthService.getToken(userData).then(function(response) {
                            console.log('getToken then user--', response);
                            if (response.data.token) {
                                AuthService.getUser().then(function(user) {
                                    console.log('--- AuthService.getUser -----', user);
                                    if (user.message) {
                                        $scope.message = user.message.email[0];
                                        return;
                                    }

                                    // Send analytics events
                                    ga_send_event('User', 'Sign Up');
                                    
                                    if ( RedirectToService.active() ) {
                                        // Redirect to requested item if signup result of logged out
                                        // purchase / reserve action
                                        RedirectToService.execute()

                                    } else if (url_.token && url_.grouplocator) {
                                        $state.go('tab.groups', {}, {reload: true, inherit: false});
                                    } else {
                                        $state.go('tab.members', {}, {reload: true, inherit: false});
                                    }

                                });
                            } else {
                                $ionicScrollDelegate.scrollTop();
                                $scope.message = 'Please ensure this is a good email and password for an active Giftster account.'
                            }
                        });
                    } else {
                        $scope.message = 'Please ensure this is a good email and password for an active Giftster account.'
                        $ionicScrollDelegate.scrollTop();
                    }
                });
            };

            $scope.facebookLogin = function() {

                if (isMobileWebsite) {

                    $window.open(fbAuthUrl, '_self', 'location=yes,enableViewportScale=yes')

                } else {

                    facebookConnectPlugin.login(["email", "user_birthday"], function(success){
                            AuthService.facebookLogin(success.authResponse.accessToken).then(function(login_token){
                                AuthService.login(login_token).then(function(user) {
                                    if (login_token) {

                                        // If a group_locator was passed, attempt to accept any invites to this
                                        // group for requesting user, then re-direct to my groups tab
                                        if ($scope.user.group_locator) {
                                            $scope.acceptInvite($scope.user.group_locator).then(function(result) {
                                                $state.go('tab.groups', {}, {reload: true, inherit: false});
                                            })
                                        }

                                        // Redirect user to either shop for page, or item they reserved/purchased previously
                                        if ( RedirectToService.active() ) {
                                            RedirectToService.execute();
                                        } else if (url_.token && url_.grouplocator) {
                                            $state.go('tab.groups', {}, {reload: true, inherit: false});
                                        } else {
                                            $state.go('tab.members', {}, {reload: true, inherit: false});
                                        }
                                    } else {
                                        $scope.message = 'Please ensure this Facebook account is active and has an email associated with it.';
                                    }
                                });
                            });
                             }, function (error) {
                        // error
                    });                        
                };            
            }
        })
        //LoginTabsCtrl
        .controller('LoginTabsCtrl', function(customElements, apiUrl, webUrl, fbAuthUrl, $window, $scope, $state, $ionicTabsDelegate, $stateParams, $ionicPopup, $ionicLoading, globalImages, userSettings, $localstorage, $timeout, AuthService, EVENTS, $rootScope, RedirectToService) {
            ga_send_pageview('Login Page');

            $scope.tabsSettings = [{login_page: 'show', search_page: 'hide', login_tab: '', search_tab: '', site_tab: ''}];
            $scope.globalImages = {
                footer_img_pages: globalImages.footer_img_pages
            };
            $scope.header_title = 'Log in';
            $scope.selectTabWithIndex = function(index) {
                console.log("133 tabNum = ", index);
                $ionicTabsDelegate.select(index);
                if (index == 0) {
                    $scope.tabsSettings = [{login_page: 'show', search_page: 'hide', login_tab: 'tab-item-active', search_tab: '', site_tab: ''}];
                    $scope.header_title = 'Log in';
                } else if (index == 1) {
                    $scope.header_title = 'Member Search';
                    $scope.tabsSettings = [{login_page: 'hide', search_page: 'show', login_tab: '', search_tab: 'tab-item-active', site_tab: ''}];
                }
            };
            console.log('$scope.tabsSettings - ', $scope.tabsSettings);
            $scope.message = "";
            $scope.type_pass = 'password';
            $scope.user = {
                username: null,
                password: null
            };

            // Determine if we should redirect the user on sign in, as in when they have come here
            // from an invite for an existing account
            $scope.redirectto = null;

            var url_ = location.hash.replace('#\/login/?','', '').split('&').reduce(function(s, c) {
                var t = c.split('=');
                s[t[0]] = t[1];
                return s;
            }, {});

            if (url_.redirectto) {
                $scope.redirectto = url_.redirectto;
            }


            //////// Test ////////
            $scope.currentUser = null;
            $scope.isAuthorized = AuthService.isAuthorized;
            $scope.setCurrentUser = function(user) {
                $scope.currentUser = user;
            };
            function logout() {
                AuthService.logout();
            }
            function redirectToLogin() {
                // $state.go('login');
                $state.go('login-tabs', {'tabId': 0}, {reload: true, inherit: false});
            }
            $scope.credentials = {
                username: '',
                password: ''
            };
            $scope.GoToFullWebsite = function() {
                var url = webUrl + '/account/circumvent_mobile/?next=' + webUrl
                $scope.GoToLink(url)
            };

            $scope.facebookLogin = function() {

                if (isMobileWebsite) {

                    $window.open(fbAuthUrl, '_self', 'location=yes,enableViewportScale=yes')
                } else {

                    facebookConnectPlugin.login(["email", "user_birthday"], function(success){
                            AuthService.facebookLogin(success.authResponse.accessToken).then(function(login_token){
                                AuthService.login(login_token).then(function(user) {
                                    if (login_token) {
                                        $('.bar .back-button').addClass('hide');
                                        $rootScope.$broadcast(EVENTS.loginSuccess);
                                        $scope.setCurrentUser(user);
                                        ga_send_event('User', 'Log In', 'Facebook');
                                        
                                        // Redirect user to either shop for page, or item they reserved/purchased previously
                                        if ( RedirectToService.active() ) {
                                            RedirectToService.execute();
                                        } else if ( $scope.redirectto ){
                                            $state.go( $scope.redirectto, {},{reload: true, inherit: false});
                                        } else {
                                            $state.go('tab.members', {}, {reload: true, inherit: false});
                                        }

                                    } else {
                                        $scope.message = 'Please ensure this Facebook account is active and has an email associated with it.';
                                        $rootScope.$broadcast(EVENTS.loginFailed);
                                    }
                                });
                            });
                             }, function (error) {
                        // error
                    });                        
                }
            };



            $scope.login = function(userSettings) {

                // Perform connection check
                if (window.Connection) {
                    if (navigator.connection.type == Connection.NONE) {
                        $ionicLoading.hide();

                        $ionicPopup.alert({
                            title: "Connection lost",
                            content: "You are not connected to the internet. Please turn off airport mode or restore your internet connection to proceed."
                        })
                                .then(function(result) {
                                    $state.go('index', {}, {reload: true});
                                });
                    }
                }

                // console.log("LOGIN user: " + $scope.user.username + " - PW: " + $scope.user.password);
                var userData = {
                    username: $scope.user.username,
                    password: $scope.user.password
                };
                AuthService.getToken(userData).then(function(response) {
                    if (response.data.token) {
                        AuthService.login(response.data.token).then(function(user) {
                            $('.bar .back-button').addClass('hide');
                            $rootScope.$broadcast(EVENTS.loginSuccess);
                            $scope.setCurrentUser(user);

                        // Detect and handle redirect before executing login
                        if ( RedirectToService.active() ) {
                            RedirectToService.execute();
                        } else if ( $scope.redirectto ){
                            $state.go( $scope.redirectto, {},{reload: true, inherit: false});
                        } else {
                            $state.go('tab.members', {}, {reload: true, inherit: false});                    
                        }


                        });
                        ga_send_event('User', 'Log In');
                    } else {
                        $scope.message = 'Please ensure this is a good email and password for an active Giftster account.';
                        $rootScope.$broadcast(EVENTS.loginFailed);
                    }
                });
            };
            //////// END Test ////////

            $scope.showPassword = function() {
                $scope.type_pass = ($scope.type_pass == 'password') ? 'text' : 'password';
                document.getElementById('input_pass').type = $scope.type_pass;
            };
            $scope.forgotPassword = function() {
                $state.go('login-forgotpassword', {}, {reload: true, inherit: false});
            };
            ///
            /// Search tab
            ///
            $scope.footer_without_tabs = '';
            $scope.searchtext = {title: null};
            $scope.searchlist = null;
            $scope.search = function() {

                console.log('$scope.searchtext.title - - - ', $scope.searchtext.title);
                if (!$scope.searchtext.title) {
                    return customElements.alert("<style>.popup-buttons .button.button-positive {   margin-left: 25%; margin-right: 25%; }</style><p>Please enter a name or email address</p>", template, 'ok', 'button-positive');
                    /*return $ionicPopup.alert({
                     template: "<style>.popup-buttons .button.button-positive {   margin-left: 25%; margin-right: 25%; }</style><p>Please enter a name or email address</p>",
                     title: 'Whoops!',
                     buttons: [{
                     text: 'ok',
                     type: 'button-positive'
                     }]
                     });*/
                }
                $state.go('search-results', {"name": $scope.searchtext.title, "tab": ''}, {reload: true, inherit: false});
                return;
            };
        })

        //LoginTabsCtrl
        .controller('AutoLoginCtrl', function($window, $scope, $state, $stateParams, userSettings, $localstorage, AuthService, EVENTS, $rootScope, RedirectToService) {
            // ga_send_pageview('Login Page');
            var token = $stateParams.serverToken
            var tab = $stateParams.tab
            $localstorage.set('login_token', token);
            AuthService.login(token).then(function(user) {
                $('.bar .back-button').addClass('hide');
                $rootScope.$broadcast(EVENTS.loginSuccess);

                $scope.currentUser = user;
                if (tab == 'groups') {
                    $state.go('tab.groups', {}, {reload: true})    
                } else {
                    $state.go('tab.members', {}, {reload: true});    
                }
                
            })
        })

        //LoginForgotPasswordCtrl
        .controller('LoginForgotPasswordCtrl', function($scope, $timeout, customElements, userSettings, $state, $ionicHistory, $ionicPopup, AuthService) {
            console.log('-- LoginForgotPasswordCtrl - -');
            $scope.userSettings = userSettings.setParams('hide', 'hide', '', '', 'footer_without_tabs', '', 'hide'); // userSettings.setParams('hide', 'hide', ' ', '', '', 'hide');

            // $state.go('login-tabs', {'tabId': 1}, {reload: true, inherit: false});
            $scope.selectTabWithIndex = function(index) {
                console.log("tabNum = ", index);
                //$ionicTabsDelegate.select(index);
                $state.go('login-tabs', {'tabId': index}, {reload: true, inherit: false});
            };
            $scope.user = {useremail: null};
            $scope.resetPassword = function() {
                var useremail = '';
                useremail = $scope.user.useremail;
                console.log("$scope.user.useremail: " + $scope.user.useremail);
                if (useremail == '' || useremail == null)
                    useremail = 'noemail';
                var userData = {email: useremail};
                AuthService.forgotPassword(userData).then(function(response) {
                    console.log('forgotPassword - ', response);
                    if (response.data.success == false)
                        return customElements.alert('Whoops!', "<style>.popup-buttons .button.button-positive {   margin-left: 25%; margin-right: 25%; }</style><p>We could not complete your request. Please try again.</p>", 'ok', 'button-positive');
                    else
                        return customElements.alert('You’ve got mail!', "<style>.popup-buttons .button.button-positive {   margin-left: 25%; margin-right: 25%; }</style><p>We have e-mailed you instructions for re-setting your password. You should receive it shortly.</p>", 'ok', 'button-positive');
                });
            };
        })



        //
        //Shop For Tab
        //
        .controller('MembersCtrl', function($window, $timeout, $scope, $rootScope, $state, $stateParams, $ionicHistory, $localstorage, userSettings, Member, EVENTS, AuthService, RedirectToService, Session) {
            $ionicHistory.clearHistory();
            ga_send_pageview('Shop For - Home Tab');

            $('.bar .back-button').addClass('hide');

            // $('.back-button').css('display', 'block');
            // $('.back-button').first().css('display');
            var login_token = $localstorage.get('login_token');
            // console.log('login_token -', login_token);
            $scope.userfirstname = $localstorage.get('userfirstname');
            $scope.userSettings = userSettings.setParams('show', 'hide', '', '', 'footer_without_tabs', '', 'hide'); // userSettings.setParams('hide', 'hide', ' ', '', '', 'hide');
            $localstorage.set('footer_tabs', 'hide');
            $scope.groupId = null;
            $scope.members = null;
            $scope.member_visible = 'hide';
            $scope.member_started_visible = 'hide';
            $scope.btn_list = 'hide';
            $scope.footer_without_tabs = 'footer_without_tabs';
            $rootScope.hideTabs = false;
            $scope.welcome_visible = 'hide';
            $scope.shop_visible = 'hide';
            $scope.first_time = userSettings.getFirstTime();

            console.log('@@@ 1  $scope.first_time---', $scope.first_time);
            
            $scope.setSelectedMember = function(member) {
                $localstorage.setObject('select_member', member);
            };

            // Called to select the given member
            $scope.selectMember = function(member, index) {
                console.log('!!! member', member);

                if ((member.group_owner == true) || (member.is_current_user == true))
                    return  $state.go('tab.preferences', {}, {reload: true, inherit: false});

                $scope.activeMember = member;
                $scope.setSelectedMember(member);
                $state.go('tab.shop-memberlists', {"memberlistId": member.id, "name": "parent", "tab": "shop"}, {reload: true, inherit: false});
            };
            $scope.getAddGroup = function() {
                userSettings.setFirstTime(true);
                $rootScope.hideTabs = false;
                $state.go('tab.shop-groups-add-edit', {"name": "add", "tab": "shop"}, {reload: true, inherit: false});
            };
            $scope.memberSearch = function() {
                userSettings.setFirstTime(true);
                $rootScope.hideTabs = false;
                $state.go('tab.shop-search', {"tab": "shop"}, {reload: true, inherit: false});
            };
            $scope.getAddLists = function() {
                userSettings.setFirstTime(true);
                $rootScope.hideTabs = false;
                $state.go('tab.shop-mylists-add', {"tab": "shop"}, {reload: true, inherit: false});
            };
            $scope.shoppingList = function() {
                $state.go('tab.shop-shoppinglist', {'tab': 'shop'}, {reload: true, inherit: false});
            };
            $scope.getInfoWishList = function() {
                Member.getWishList().then(function(wishList) {
                    console.log(' wishList ---', wishList);
                });
            };
/////////////////////   /////////////////
            $scope.currentUser = null;
            $scope.isAuthorized = AuthService.isAuthorized;
            $scope.setCurrentUser = function(user) {
                $scope.currentUser = user;
            };
            function logout() {
                AuthService.logout();
            }
            function redirectToLogin() {
                $state.go('login');
            }
            //  console.log('localStorage - ', $window.localStorage);
            //  console.log('Session - ', login_token);
            //  console.log('Session - ', Session.user);
            if (login_token == false && Session.user == null) {
                Session.create($localstorage.getObject('user'));
                $scope.setCurrentUser($localstorage.getObject('user'));
                console.log('- -   $state.go INDEX - - ');
                // $state.go('index');
            }

            // We listen to auth related broadcasts.
            $scope.$on(EVENTS.notAuthenticated, logout);
            $scope.$on(EVENTS.sessionTimeout, logout);
            $scope.$on(EVENTS.signupSuccess, logout);
            $scope.$on(EVENTS.logoutSuccess, redirectToLogin);
/////////////////////////////////////
            // console.log('getGroupsExistence - ');
            // Member.getGroupsExistence().then(function(groups) {
            //      // $rootScope.hideTabs = true;
            //      console.log('getGroupsExistence groups---', groups);
            // });
            //  Member.getGroupsExistence(groups, joinGroups, wishList).then(function() {
            $scope.showStartPage = function(groups, joinGroups, wishList) {
                console.log('showStartPage groups---', groups);
                console.log('showStartPage joinGroups---', joinGroups);
                console.log('showStartPage wishList---', wishList);
                $timeout(function() {

                    if (joinGroups.length == 0) {
                        if (wishList.length == 0 && groups.length != 0) {
                            $rootScope.hideTabs = false;
                            $localstorage.set('footer_tabs', 'show');
                            $scope.userSettings = userSettings.setParams('hide', 'show', 'hide', 'hide', '', 'hide', '');
                        } else if (wishList.length == 0 && groups.length == 0) {
                            $rootScope.hideTabs = true;
                            $localstorage.set('footer_tabs', 'hide');
                            $scope.userSettings = userSettings.setParams('hide', 'show', 'show', 'show', 'footer_without_tabs', '', 'hide');
                            console.log(' $scope.userSettings ---', $scope.userSettings);
                        } else {
                            $rootScope.hideTabs = false;
                            $localstorage.set('footer_tabs', 'show');
                            $scope.userSettings = userSettings.setParams('hide', 'show', 'hide', 'hide', '', 'hide', '');
                        }
                    } else {
                        $rootScope.hideTabs = false;
                        $scope.userSettings = userSettings.setParams('show', 'hide', 'show', 'show', '', '', 'hide');
                    }
                }, 200);
            };


            //getChildAccounts
            /*Member.getChildAccounts().then(function(childAccounts) {
             console.log('!!!!childAccounts - - ', childAccounts);
             });*/
            Member.getAllGroups().then(function(getAllGroups) {
                if (!getAllGroups && !$scope.first_time) {
                    $rootScope.hideTabs = true;
                    $localstorage.set('footer_tabs', 'hide');
                    $scope.userSettings = userSettings.getNewUser();
                } else if (!getAllGroups && $scope.first_time) {
                    $rootScope.hideTabs = false;
                    $scope.userSettings = userSettings.setParams('hide', 'show', 'hide', '', '', '', 'hide');
                } else {
                    $rootScope.hideTabs = false;
                    $scope.userSettings = userSettings.setParams('show', 'hide', 'show', 'show', '', '', 'hide');
                }
                $scope.members = getAllGroups;

            });

            $scope.createdLists = false;
            Member.getWishList().then(function(wishlists) {
                if (wishlists.length){
                    $rootScope.hideTabs = false;
                    $scope.createdLists = true;
                }
            });
        })

        .controller('ShoppingListsCtrl', function($scope, $state, $localstorage, $ionicHistory, $stateParams, ShoppingList) {
            $('.bar .back-button').removeClass('hide');
            ga_send_pageview('Shop For - Shopping List');
            
            $scope.userData = null;
            $scope.userData = $localstorage.getObject('user');
            // set the rate and max variables
            $scope.rate = 0;
            $scope.max = 5;
            $scope.isReadonly = true;
            $scope.setrank = 0;
            $scope.setRate = function(value) {
                $scope.setrank = value;
            };
            $scope.hoveringOver = function(value) {
                $scope.overStar = value;
                $scope.percent = 100 * (value / $scope.max);
            };
            $scope.ratingStates = [
                {stateOn: 'glyphicon-ok-sign', stateOff: 'glyphicon-ok-circle'},
                {stateOn: 'glyphicon-star', stateOff: 'glyphicon-star-empty'},
                {stateOn: 'glyphicon-heart', stateOff: 'glyphicon-ban-circle'},
                {stateOn: 'glyphicon-heart'},
                {stateOff: 'glyphicon-off'}
            ];
            // get the values with API
            $scope.shoppingLists = null;
            ShoppingList.all().then(function(lists) {
                console.log('lists---', lists);
                $scope.shoppingLists = lists;
                $scope.shoppinglist = {
                    'purchased': lists.purchased,
                    'reserved': lists.reserved,
                    'shoppinglist_visible': lists.shoppinglist_visible
                };
            });
            $scope.myGoBack = function() {
                $ionicHistory.goBack();
            };
            $scope.selectItems = function(shoppingelem) {
                if (shoppingelem.title)
                    $localstorage.set('select_info_list', shoppingelem.title);
                if ($stateParams.tab == 'more')
                    $state.go('tab.more-shoppinglist-list-item', {"memberlistId": $scope.userData.id, "listId": shoppingelem.list_id, "listitemId": shoppingelem.id, "tab": 'shoppinglist'}, {reload: true});
                else
                    $state.go('tab.shop-list-item', {"memberlistId": $scope.userData.id, "listId": shoppingelem.list_id, "listitemId": shoppingelem.id, "tab": 'shoppinglist'}, {reload: true});

            };
        })
        //Shop Tab->MemberListsCtrl
        .controller('MemberListsCtrl', function($rootScope, $scope, $state, $timeout, $localstorage, $stateParams, $ionicModal, $ionicPopup, Member, Lists, RedirectToService) {
            console.log('--- MemberListsCtrl ---');
            ga_send_pageview('Shop For - Member Detail');
            console.log('$stateParams - ', $stateParams);
            $scope.globalImages = {
                icon_plus_green: ' ',
                icon_settings: ' '
            };
            var selectMember = $localstorage.getObject('select_member');
            $scope.userid = $localstorage.get('userid');
            console.log('!!!!! selectMember -', selectMember);
            $scope.userSettings = [{'item_right': '', 'icon_right': ''}];
            $scope.membertitle = null;
            $scope.members = null;
            $scope.membersid = null;
            $scope.membersList = false;
            $scope.memberName = 'child';
            $scope.memberName = $stateParams.name;
            $scope.secretSanta = null;
            $('.bar .back-button').removeClass('hide');


            $scope.setMemberTitle = function() {
                if ($localstorage.getObject('select_member').name) {
                    $scope.membertitle = selectMember.name
                
                } else {
                    Member.getUserInfo($stateParams.memberlistId).then(function(response){
                        $scope.membertitle = response.first_name + ' ' + response.last_name;
                    })

                }                
            }
            $scope.setMemberTitle()            

            //console.log('####  selectMember.id - ', selectMember.id);
            Member.getSecretSanta($stateParams.memberlistId).then(function(secretSanta) {
                console.log('### secretSanta -', secretSanta);
                $scope.secretSanta = secretSanta;
            });

            $ionicModal.fromTemplateUrl('rules-modal.html', {
                scope: $scope,
                animation: 'slide-in-up'
            }).then(function(modal) {
                $scope.modal = modal;
            });
            $scope.rules = function() {                
                $scope.modal.show();
            };
            $scope.closeModal = function() {
                $scope.modal.hide();
            };
            $scope.$on('$destroy', function() {
                $scope.modal.remove();
            });

            // Called to select the given Wish Lists
            $scope.selectWishLists = function(wishlist) {
                if (wishlist.id == 0)
                    return;
                $localstorage.setObject('select_wishlist', wishlist);
                $localstorage.set('select_mylist', wishlist.title);

                if (wishlist.title == "I Got This list") {
                    $state.go('tab.mylists-list', {"mylistId": wishlist.id, "tab": "", "type": 'got'}, {reload: true});
                }
                else if ($stateParams.name == 'child' && $stateParams.tab == 'mylists')
                    $state.go('tab.mylists-list', {"mylistId": wishlist.id, "tab": $stateParams.tab, "type": "child"}, {reload: true});
                else if ($stateParams.tab == 'groups')
                    $state.go('tab.groups-memberlists-list', {"memberlistId": selectMember['id'], "listId": wishlist.id, "tab": $stateParams.tab}, {reload: true});
                else
                    $state.go('tab.memberlists-list', {"memberlistId": selectMember['id'], "listId": wishlist.id, "tab": $stateParams.tab}, {reload: true});
            };
            $scope.removeWishList = function(one_list) {
                $ionicPopup.show({
                    title: 'Delete List',
                    template: 'Are you sure you want to remove this list?',
                    buttons: [{text: 'no, cancel'}, {
                            text: '<b>yes</b>',
                            type: 'button-positive',
                            onTap: function() {
                                Lists.remove(one_list).then(function(response) {
                                    console.log('remove response----', response);
                                    $scope.members.splice($scope.members.indexOf(one_list), 1);
                                    if (response.wish_lists.length == 0 && $scope.members.length == 0) {
                                        $scope.members = [{'title': 'No lists started yet', 'id': 0}];
                                        $scope.membersList = false;
                                    }
                                });
                            }
                        }
                    ]
                });
            };

            $scope.addList = function() {
                if ($stateParams.tab == 'shop')
                    $state.go('tab.shop-memberlists-addlist', {"memberlistId": selectMember['id'], "name": $stateParams.name, "tab": $stateParams.tab}, {reload: true});
                else if ($stateParams.tab == 'groups')
                    console.log('groups!!!'); //$state.go('tab.shop-memberlists-addlist', {"memberlistId": selectMember['id'], "name": $stateParams.name, "tab": $stateParams.tab}, {reload: true});
                else if ($stateParams.name == 'child')
                    $state.go('tab.mylists-add', {"idchild": $stateParams.memberlistId, "name": $stateParams.name, "tab": 'mylists'}, {reload: true});
                else
                    $state.go('tab.mylists-add', {"memberlistId": selectMember['id'], "name": $stateParams.name, "tab": 'mylists'}, {reload: true});
            };
            $scope.goToSettingsPage = function() {
                console.log(' id =', selectMember['id']);
                if ($stateParams.tab == 'shop')
                    $state.go('tab.shop-childaccounts-create-edit', {"idchild": selectMember['id'], "name": 'edit', "tab": 'shop'}, {reload: true});
                if ($stateParams.tab == 'groups')
                    $state.go('tab.groups-childaccounts-create-edit', {"idchild": selectMember['id'], "name": 'edit', "tab": 'groups'}, {reload: true});
                else
                    $state.go('tab.mylists-childaccounts-create-edit', {"idchild": selectMember['id'], "name": 'edit', "tab": 'mylists'}, {reload: true});
            };
            Lists.giftPreferences(($stateParams.name == 'child') ? $stateParams.memberlistId : $scope.userid, true).then(function(response) {
                console.log('giftPreferences -', response);
                $scope.preferences = response;
            });

            $scope.viewMyGiftPreferences = function() {
                console.log('--- $stateParams ---', $stateParams);
                if ($stateParams.name == 'child')
                    return $state.go('tab.mylists-preferences', {"memberId": $stateParams.memberlistId, "name": 'child'}, {reload: true}); //selectMember['id']

                console.log('--- memberlistId ---', $stateParams.memberlistId);
                if ($stateParams.tab == 'shop')
                    $state.go('tab.shop-memberlists-preferences', {"memberId": $stateParams.memberlistId}, {reload: true});
                else if ($stateParams.tab == 'groups')
                    $state.go('tab.groups-memberlists-preferences', {"memberId": $stateParams.memberlistId}, {reload: true});
                else
                    $state.go('tab.mylists-preferences', {"memberId": $stateParams.memberlistId, "name": 'parent'}, {reload: true}); //selectMember['id']

            };

            var memberId = null;
            if ($stateParams.memberId)
                memberId = $stateParams.memberId;
            else
                memberId = $stateParams.memberlistId
            // if ($stateParams.memberlistId)
            parent_or_child = $scope.memberName;

            Member.getList(memberId, parent_or_child).then(function(lists) {
                console.log('lists---', lists);
                if (lists.length == 0) {
                    $scope.members = [{'title': 'No lists started yet', 'id': 0}];
                    $scope.membersList = false;
                } else {
                    $scope.members = lists;
                    $scope.membersList = true;
                    $scope.membersid = $stateParams.memberlistId;
                    $scope.userSettings = [{'item_right': 'item-icon-right', 'icon_right': 'ion-chevron-right'}];
                }
            });

        })
        //Shop Tab->MemberListsCtrl -> MemberListsPreferencesCtrl
        .controller('MemberListsPreferencesCtrl', function($scope, $ionicHistory, $stateParams, customElements, $ionicModal, AuthService, userSettings, $localstorage, Lists) {
            console.log('--- MemberListsPreferencesCtrl ---');
            ga_send_pageview('Shop For - Member Gift Preferences');
            

            $scope.userSettings = userSettings.setParams('hide', 'hide', '', '', 'footer_without_tabs', '', 'hide');
            $scope.footer_tabs = $localstorage.get('footer_tabs');
            $scope.list_activeButton = null;
            $scope.send_visible = 'hide';
            $scope.preferences_class_size = 'hide';
            $scope.preferences_class_interests = 'hide';
            $scope.preferences_class_address = 'hide';
            $scope.pointer_class_size = 'ion-chevron-down';
            $scope.pointer_class_interests = 'ion-chevron-down';
            $scope.pointer_class_address = 'ion-chevron-down';
            $scope.gift_preferences = null;
            $scope.formData = {};
            $scope.interestsData = {};
            $scope.userName = ' ';
            $scope.last_updated = ' ';
            $scope.incident = {name: '', comment: ''};

            var selectMember = $localstorage.getObject('select_member');
            $scope.userName = selectMember.name;

            //console.log('selectMember ---', selectMember);

            if ($localstorage.get('login_token')) {
                $scope.send_visible = 'show';
                $scope.footer_tabs = 'show';
                $scope.userSettings = userSettings.setParams('hide', 'show', 'hide', 'hide', '', 'hide', '');
            } else {
                $scope.send_visible = 'hide';
                $scope.footer_tabs = 'hide';
                $scope.footer_without_tabs = 'footer_without_tabs';
            }
            Lists.getListStatus($stateParams.memberId).then(function(response) {
                console.log('getListStatus response=', response);
                var lastUpdated = customElements.dateDiffFormat(response.modified);
                console.log('lastUpdated=', lastUpdated);
                $scope.last_updated = lastUpdated;
            });

            Lists.giftPreferences($stateParams.memberId, false).then(function(response) {
                //console.log('response - ', response);
                $scope.formData.gift_preferences = response.gift_preferences;
                //fill interestsData data
                if (response.extra_sizes.length != 0)
                    $.each(response.extra_sizes, function(key, val) {
                        $scope.interestsData['extrasize_name' + key] = val.name;
                        $scope.interestsData['extrasize_size' + key] = val.size;
                    });
                if (response.gift_preferences.shoe_size || response.gift_preferences.casual_shirt_size || response.gift_preferences.dress_shirt_size || response.gift_preferences.pants_size || response.gift_preferences.jacket_size || response.gift_preferences.dress_size || response.gift_preferences.hat_size)
                    $scope.showHide('1');
                if ($scope.interestsData.extrasize_name0 || $scope.interestsData.extrasize_size0 || $scope.interestsData.extrasize_name1 || $scope.interestsData.extrasize_size1 || response.gift_preferences.hobbies || response.gift_preferences.other || response.gift_preferences.favorites)
                    $scope.showHide('2');
                if (response.gift_preferences.full_name || response.gift_preferences.street1 || response.gift_preferences.street2 || response.gift_preferences.city || response.gift_preferences.state || response.gift_preferences.postal_code || response.gift_preferences.country || response.gift_preferences.phone_number)
                    $scope.showHide('3');
            });

            $ionicModal.fromTemplateUrl('templates/shop/send-update-reminder-modal.html', {
                scope: $scope,
                animation: 'slide-in-up'
            }).then(function(modal) {
                $scope.modal = modal;
            });
            $scope.closeModal = function() {
                $scope.modal.hide();
            };
            $scope.$on('$destroy', function() {
                $scope.modal.remove();
            });
            $scope.sendUpdateReminder = function() {
                console.log(' - - sendUpdateReminder- - -');
                $scope.modal.show();
            };
            $scope.send = function() {
                console.log(' - - send!!!- - -');
                AuthService.sendReminder(selectMember['id'], $scope.incident.comment, $scope.incident.name).then(function(response) {
                    if (response.data.success) {
                        customElements.alert('Success!', "<style>.popup-buttons .button.button-positive {   margin-left: 25%; margin-right: 25%; }</style><p>Message sent from giftster.</p>", 'ok', 'button-positive');
                    } else
                        customElements.alert('ERROR', "<style>.popup-buttons .button.button-positive {   margin-left: 25%; margin-right: 25%; }</style><p>ERROR!</p>", 'ok', 'button-positive');

                    $scope.modal.remove();
                });
            };
            // $scope.select = function() {
            //     console.log(' - - sendUpdateReminder- - -');
            // $state.go('tab.preferences', {"mylistId": $stateParams.mylistId}, {reload: true});
            // };
            $scope.showHide = function(index) {
                if (index == '1') {
                    $scope.preferences_class_size = ($scope.preferences_class_size == 'hide') ? ' ' : 'hide';
                    $scope.pointer_class_size = ($scope.pointer_class_size == 'ion-chevron-down') ? 'ion-chevron-up' : 'ion-chevron-down';
                }
                if (index == '2') {
                    $scope.preferences_class_interests = ($scope.preferences_class_interests == 'hide') ? ' ' : 'hide';
                    $scope.pointer_class_interests = ($scope.pointer_class_interests == 'ion-chevron-down') ? 'ion-chevron-up' : 'ion-chevron-down';
                }
                if (index == '3') {
                    $scope.preferences_class_address = ($scope.preferences_class_address == 'hide') ? ' ' : 'hide';
                    $scope.pointer_class_address = ($scope.pointer_class_address == 'ion-chevron-down') ? 'ion-chevron-up' : 'ion-chevron-down';
                }
            };
            $scope.myGoBack = function() {
                $ionicHistory.goBack();
            };
        })
        //Shop Tab->MemberListsCtrl -> MemberListsListCtrl
        .controller('MemberListsListCtrl', function($rootScope, $scope, $state, $timeout, $ionicHistory, $ionicPopup, userSettings, Lists, $localstorage, $stateParams, Member, $ionicModal, AuthService, customElements, globalImages) {
            console.log('$stateParams -', $stateParams);
            ga_send_pageview('Shop For - Member List');

            $scope.globalImages = {
                icon_plus_green: globalImages.icon_plus_green
            };

            $scope.userSettings = userSettings.setParams('hide', 'hide', '', '', 'footer_without_tabs', '', 'hide');
            $scope.footer_tabs = $localstorage.get('footer_tabs');

            if ($localstorage.get('login_token')) {
                $scope.send_visible = 'show';
                $scope.footer_tabs = 'show';
                $scope.userSettings = userSettings.setParams('hide', 'show', 'hide', 'hide', '', 'hide', '');
            } else {
                $scope.send_visible = 'hide';
                $scope.footer_tabs = 'hide';
                $scope.footer_without_tabs = 'footer_without_tabs';
            }
            var selectMember = $localstorage.getObject('select_member');

            if ($localstorage.getObject('select_member').name) {
                $scope.suggestingForMember = $localstorage.getObject('select_member').name.split(' ')[0];    
            } else {
                $scope.suggestingForMember = '';    
            }

            $scope.selectWishlist = null
            
            $scope.infolists = null;
            $scope.reminders = null;
            $scope.infolistid = null;
            $scope.infolistid = $stateParams.listId;
            $scope.userName = '';
            $scope.suggestedItemUsers;
            $scope.canReadSuggestedItems = false;
            $scope.canCreateSuggestedItem = false;

            if (selectMember)
                $scope.userName = selectMember['name'];//.split(' ')[0];

            $scope.standardlist = 'Remind ' + $scope.userName + ' to update this';
            ////////////////////////////////////////////////
            $scope.element_visible = '';
            $scope.lists = null;
            $scope.listsId = null;
            $scope.itemNum = null;
            $scope.list_activeButton = null;
            $scope.mylists_title = null;
            // set the rate and max variables
            $scope.rate = 0;
            $scope.max = 5;
            $scope.isReadonly = true;
            $scope.setrank = 0;
            $scope.setRate = function(value) {
                $scope.setrank = value;
            };
            $scope.hoveringOver = function(value) {
                $scope.overStar = value;
                $scope.percent = 100 * (value / $scope.max);
            };
            $scope.ratingStates = [
                {stateOn: 'glyphicon-ok-sign', stateOff: 'glyphicon-ok-circle'},
                {stateOn: 'glyphicon-star', stateOff: 'glyphicon-star-empty'},
                {stateOn: 'glyphicon-heart', stateOff: 'glyphicon-ban-circle'},
                {stateOn: 'glyphicon-heart'},
                {stateOff: 'glyphicon-off'}
            ];
            $scope.element_visible = 'show';
            $scope.element_remind = 'hide';
            $scope.incident = {name: '', comment: ''};
            var milliseconds = new Date().getTime();
            $scope.nobuttons = null;
            $scope.tabReserve = 'hide';
            $scope.tabRelease = 'hide';
            $scope.tabPurchase = 'hide';
            $scope.barSubheader = 'bar-subheader';

            if (selectMember.id != $localstorage.get('userid'))
                $scope.element_visible = 'hide';

            $ionicModal.fromTemplateUrl('templates/shop/send-update-reminder-modal.html', {
                scope: $scope,
                animation: 'slide-in-up'
            }).then(function(modal) {
                $scope.modal = modal;
            });

            $scope.addSuggestedItem = function() {

                if (this.title == 'shop for') {
                    stateName = 'tab.shop-item-add';

                } else if (this.title == 'more') {
                    stateName = 'tab.more-item-add';

                } else if (this.title == 'groups') {
                    stateName = 'tab.groups-item-add';
                    tabName = 'groups'
                }


                $state.go(
                    stateName,
                    {
                            'mylistId': $scope.infolistid,
                            'type': 'add',
                            'suggested': 'suggested',
                            'tab': $stateParams.tab
                    }, {reload: true, inherit: false});
            };


            $scope.removeSuggestedItem = function(event, item) {
                event.stopPropagation();
                $ionicPopup.show({
                    title: 'Delete Suggested Item',
                    template: 'Are you sure you want to remove this suggested item?',
                    buttons: [{text: 'no, cancel'}, {
                            text: '<b>yes</b>',
                            type: 'button-positive',
                            onTap: function() {
                                Lists.removeItems(item).then(function(response) {

                                // Loop through suggestedItemUsers array to find current user ES5 style
                                for (i=0; i < $scope.suggestedItemUsers.length; i++) {

                                    // Found current user, now can remove item from list
                                    if ($scope.suggestedItemUsers[i].is_current_user === true) { 

                                        // Remove item from list of suggested items and break out of loop
                                        $scope.suggestedItemUsers[i].suggested_items.splice(
                                            $scope.suggestedItemUsers[i].suggested_items.indexOf(item), 1)
                                        break;
                                    }
                                } 

                                });
                            }
                        }
                    ]
                });
            };

            $scope.setSelectWishlist = function() {
                if ($localstorage.getObject('select_wishlist').id) {
                    $scope.selectWishlist = $localstorage.getObject('select_wishlist');
                
                } else {
                    // Only time selectWishlist is not avaiable should be during execution of a redirect,
                    // therefor can extract list data from redirectTo local storage object
                    var locator = $localstorage.getObject('redirectTo').data.wishlist.locator
                    
                    Member.getListInfo(locator).then(function(response){
                        $scope.selectWishlist = response
                    })

                }                
            }
            $scope.setSelectWishlist()            

            $scope.closeModal = function() {
                $scope.modal.hide();
            };
            $scope.$on('$destroy', function() {
                $scope.modal.remove();
            });
            $scope.sendUpdateReminder = function() {
                console.log(' - - sendUpdateReminder- - -');
                $scope.modal.show();
                // $state.go('tab.preferences', {"mylistId": $stateParams.mylistId}, {reload: true});
            };
            $scope.send = function() {
                console.log(' - - send!!!- - -');
                //console.log('id=', selectMember['id']);
                //console.log('comment=', $scope.incident.comment);
                //console.log('name=', $scope.incident.name);
                //AuthService.sendReminder(selectMember['id'], $scope.incident.comment, $scope.incident.name);
                AuthService.sendReminder(selectMember['id'], $scope.incident.comment, $scope.incident.name).then(function(response) {
                    if (response.data.success)
                        customElements.alert('Success!', "<style>.popup-buttons .button.button-positive {   margin-left: 25%; margin-right: 25%; }</style><p>Message sent from giftster.</p>", 'ok', 'button-positive');
                    else
                        customElements.alert('ERROR', "<style>.popup-buttons .button.button-positive {   margin-left: 25%; margin-right: 25%; }</style><p>ERROR!</p>", 'ok', 'button-positive');
                });
            };
            // Called to select the given Wish Lists
            $scope.selectMemberLists = function(list) { //infoList, listId) {
                //console.log('selectMemberLists infoList ---', infoList);
                console.log('selectMemberLists list  ---', list);
                ga_send_pageview('Shop For - Item');

                    //Remember selected item
                $localstorage.set('select_info_list', list.title);
                if ($stateParams.tab == 'groups')
                    $state.go('tab.groups-list-item', {"memberlistId": $stateParams.memberlistId, "listId": list.list_id, "listitemId": list.id, "tab": 'groups'}, {reload: true}); //$state.go('tab.groups-list-item', {"memberlistId": $stateParams.memberlistId, "listId": $stateParams.listId, "listitemId": list.id, "tab": 'groups'}, {reload: true});
                else if ($stateParams.tab == 'search') 
                    $state.go('search-mylists-list-item', {"memberlistId": $stateParams.memberlistId, "listId": list.list_id, "listitemId": list.id, "tab": $stateParams.tab}, {reload: true});
                else if ($stateParams.tab == 'more')
                    $state.go('tab.more-shoppinglist-list-item', {"memberlistId": $stateParams.memberlistId, "listId": list.list_id, "listitemId": list.id, "tab": 'more'}, {reload: true}); 
                else
                    $state.go('tab.list-item', {"memberlistId": $stateParams.memberlistId, "listId": $stateParams.listId, "listitemId": list.id, "tab": 'shop'}, {reload: true});
            };

            if ($stateParams.listId && $localstorage.get('login_token')) {
                Member.getListItems($stateParams.listId).then(function(lists) {
                    console.log('getListItems---', lists);
                    $scope.infolists = lists.new_lists;
                    $scope.itemNum = $stateParams.mylistId;
                    $scope.info_message = lists.userSettings.info_message;
                    $scope.list_activeButton = lists.userSettings.list_activeButton;
                });

                Member.getSuggestedItems($stateParams.listId).then(function(users) {
                    $scope.suggestedItemUsers = users;                    
                });

                Member.getSuggestedItemsPermission($stateParams.listId).then(function(data) {
                    $scope.canReadSuggestedItems = data.can_read;
                    $scope.canCreateSuggestedItem = data.can_create;
                });


            } else {
                console.log('$stateParams.mylistId ----', $stateParams.mylistId);
                console.log('$stateParams.listId ----', $stateParams.listId);
                Lists.getItemsList($stateParams.listId).then(function(response) {
                    console.log('response ---', response);
                    $scope.infolists = response.new_lists;
                    $scope.itemNum = $stateParams.mylistId;
                    //if (login_token)
                    //$scope.info_message = response.userSettings.info_message;
                    $scope.list_activeButton = response.userSettings.list_activeButton;

                    $timeout(function() {
                        console.log('response ---', $scope.lists);
                        if (response.new_lists.length == 0) {
                            $scope.list_info_visible = 'show';
                            $scope.updated_status = 'show';
                        } else
                            $scope.infolists = response.new_lists;
                    }, 300);
                });

                Member.getSuggestedItems($stateParams.listId).then(function(users) {
                    $scope.suggestedItemUsers = users;                    
                });

                Member.getSuggestedItemsPermission($stateParams.listId).then(function(data) {
                    $scope.canReadSuggestedItems = data.can_read;
                    $scope.canCreateSuggestedItem = data.can_create;
                });                
            }
            $scope.myGoBack = function() {
                $ionicHistory.goBack();
            };
        })
        //If a child account
        //Shop Tab->MemberListsCtrl -> MemberListsAddCtrl
        .controller('MemberListsAddCtrl', function($scope, $state, $localstorage, $stateParams, Member, $ionicModal, AuthService, customElements) {
            console.log('--- MemberListsAddCtrl ---');
        })

        //Shop Tab->MemberListsCtrl -> MemberListsListCtrl -> MemberListsListItemCtrl
        .controller('MemberListsListItemCtrl', function($scope, $state, $localstorage, $window, $ionicHistory, $ionicModal, $localstorage, customElements, $stateParams, globalImages, Member, RedirectToService) {
            console.log('- - MemberListsListItemCtrl - - ');
            $scope.globalImages = {
                tab_bar_reserve: globalImages.tab_bar_reserve,
                tab_bar_release: globalImages.tab_bar_release,
                tab_bar_btn_shop_active: globalImages.tab_bar_btn_shop_active
            };
            $scope.listitem = {
                id: null,
                title: null,
                rank: null,
                store: null,
                price: null,
                image: null,
                quantity: null,
                link: 'hide',
                skimlink: null,
                description: null,
                status: null,
                statusclass: null,
                purchasers_by_me: null,
                store_matches: null,
                is_suggested_item_owner: false
            };

            // set the rate and max variables
            $scope.rate = 0;
            $scope.max = 5;
            $scope.isReadonly = true;
            $scope.setrank = 0;
            $scope.hoveringOver = function(value) {
                $scope.overStar = value;
                $scope.percent = 100 * (value / $scope.max);
            };
            $scope.ratingStates = [
                {stateOn: 'glyphicon-ok-sign', stateOff: 'glyphicon-ok-circle'},
                {stateOn: 'glyphicon-star', stateOff: 'glyphicon-star-empty'},
                {stateOn: 'glyphicon-heart', stateOff: 'glyphicon-ban-circle'},
                {stateOn: 'glyphicon-heart'},
                {stateOff: 'glyphicon-off'}
            ];
            $scope.header_item_title = null;
            $scope.list_items = null;
            if ($localstorage.get('select_info_list'))
                $scope.header_item_title = $localstorage.get('select_info_list');
            else
                $scope.header_item_title = $localstorage.get('select_item');


            var milliseconds = new Date().getTime();
            $scope.nobuttons = null;
            $scope.tabReserve = 'hide';
            $scope.tabRelease = 'hide';
            $scope.tabPurchase = 'hide';
            $scope.barSubheader = 'bar-subheader';

            $scope.footer_tabs = $localstorage.get('footer_tabs');
            $scope.footer_without_tabs = '';
            if ($localstorage.get('login_token')) {
                $scope.footer_tabs = 'show';
            } else {
                $scope.footer_tabs = 'hide';
                $scope.footer_without_tabs = 'footer_without_tabs';
            }

            $scope.itemCreatedModified = '';
            
            $scope.setItemCreatedModified = function(item) {
                label = 'Added';
                itemDate = item.created;
                if (item.modified != item.created) {
                    label = 'Edited';
                    itemDate = item.modified;
                }
                $scope.itemCreatedModified = label + ' ' + customElements.humanizeDateStamp(itemDate);

            }

            //declare a function
            $scope.getListItem = function() {
                console.log('---------------- getListItem -----------');
                console.log('$stateParams ----', $stateParams);
                console.log('milliseconds ----', milliseconds);

                Member.getListItemsInfo($stateParams.listId, $stateParams.listitemId, milliseconds).then(function(lists) {
                    console.log('getListItemsInfo lists---', lists);
                    $scope.listitem = lists;
                    $scope.tabReserve = ($scope.listitem[0].available) || ($scope.listitem[0].available && $scope.listitem[0].held_by_me) || ($scope.listitem[0].available && $scope.listitem[0].purchased_by_me) ? 'show' : 'hide';
                    $scope.tabRelease = (($scope.listitem[0].purchased_by_me) || ($scope.listitem[0].held_by_me) || ($scope.listitem[0].available && $scope.listitem[0].held_by_me) || ($scope.listitem[0].available && $scope.listitem[0].purchased_by_me) || (!($scope.listitem[0].available) && $scope.listitem[0].held_by_me)) ? 'show' : 'hide';
                    $scope.tabPurchase = ($scope.listitem[0].available || $scope.listitem[0].held_by_me || ($scope.listitem[0].available && $scope.listitem[0].held_by_me) || ($scope.listitem[0].available && $scope.listitem[0].purchased_by_me) || (!($scope.listitem[0].available) && $scope.listitem[0].held_by_me)) ? 'show' : 'hide';

                    $scope.buttonBar = $scope.tabReserve == 'hide' && $scope.tabRelease == 'hide' && $scope.tabPurchase == 'hide' ? 'button-bar-short' : '';

                    // Convenience variables passed to RedirectToService as needed
                    member = $localstorage.getObject('select_member')
                    wishlist = $localstorage.getObject('select_wishlist')
                    item = $scope.listitem[0]
                    $scope.setItemCreatedModified($scope.listitem[0])
                
                });
            };

            //call the function
            $scope.getListItem();

            $scope.tabPurchaseClick = function() {

                // Send analytics event (varies on normal item vs suggested)
                if (item.is_suggested_item) {
                    ga_send_event('Item', 'Purchase', 'Suggested Item');    
                } else {
                    ga_send_event('Item', 'Purchase');
                }

                if (!$localstorage.get('login_token')) {

                    RedirectToService.set(
                        'gift-list-item',
                        { member: member, wishlist:wishlist, item: item }
                    )

                    return customElements.popup('Public list access', 'Sign up or log in to mark items reserved or purchased', 'sign up', 'button-positive', '<b>login</b>', 'yellow-btn').then(function(response) {

                        if (response)
                            if ($stateParams.tab == 'tab2')
                                $state.go('tab2.login', {}, {reload: true, inherit: true});
                            else
                                $state.go('login-tabs', {}, {reload: true, inherit: true});
                        else
                            $state.go('signup', {}, {reload: true, inherit: true});
                    });
                } else {
                Member.tabPurchase($stateParams.listId, $stateParams.listitemId, milliseconds).then(function(response) {
                    //console.log('tabPurchase response---', response);
                    $scope.getListItem();
                });
                }
            };
            $scope.tabReserveClick = function() {
                // Send analytics event (varies on normal item vs suggested)
                if (item.is_suggested_item) {
                    ga_send_event('Item', 'Reserve', 'Suggested Item');    
                } else {
                    ga_send_event('Item', 'Reserve');
                }
                
                if (!$localstorage.get('login_token')) {
                    RedirectToService.set(
                        'gift-list-item',
                        { member: member, wishlist:wishlist, item: item }
                    )
                    return customElements.popup('Public list access', 'Sign up or log in to mark items reserved or purchased', 'sign up', 'button-positive', '<b>login</b>', 'yellow-btn').then(function(response) {
                        console.log('response ---', response);
                        if (response)
                            if ($stateParams.tab == 'tab2')
                                $state.go('tab2.login', {}, {reload: true, inherit: true});
                            else
                                $state.go('login-tabs', {}, {reload: true, inherit: true});
                        else
                            $state.go('signup', {}, {reload: true, inherit: true});
                    });
    
                } else {
                    Member.tabReserve($stateParams.listId, $stateParams.listitemId, milliseconds).then(function(response) {
                        //console.log('tabReserveClick response---', response);
                        if (response.data == '')
                            return alert('We could not complete this request.');
                        $scope.getListItem();
                    });
                }
            };
            $scope.tabReleaseClick = function() {
                if (!$localstorage.get('login_token'))
                    return customElements.popup('To complete request', 'Sign up or login to send your group membership request to the group creator for approval', 'sign up', 'button-positive', '<b>login</b>', 'yellow-btn').then(function(response) {
                        console.log('response ---', response);
                        if (response)
                            if ($stateParams.tab == 'tab2')
                                $state.go('tab2.login', {}, {reload: true, inherit: true});
                            else
                                $state.go('login-tabs', {}, {reload: true, inherit: true});
                        else
                            $state.go('signup', {}, {reload: true, inherit: true});
                    });

                Member.tabRelease($stateParams.listId, $stateParams.listitemId, milliseconds).then(function(response) {
                    //console.log('tabRelease response---', response);
                    if (response.data == '')
                        return alert('We could not complete this request.');
                    $scope.getListItem();
                });
            };

            $scope.editSuggestedItem = function() {

                $localstorage.set('select_item', this.listitem[0].title) 

                if (this.title == 'shop for') {
                    stateName = 'tab.shop-item-update';
                    tabName = 'shop';
                
                } else if (this.title == 'more') {
                    stateName = 'tab.more-item-update';
                    tabName = 'more'
                
                } else if (this.title == 'groups') {
                    stateName = 'tab.groups-item-update';
                    tabName = 'groups'
                }

                $state.go(
                    stateName,
                    {
                        'memberID': $stateParams.memberlistId,
                        'mylistId': $stateParams.listId,
                        'itemId': $stateParams.listitemId,
                        'type': 'edit',
                        'suggested': true,
                        'tab':tabName
                    }, 
                    { reload: true, inherit: false }
                );
            };

            $scope.GoToWebsite = function(urlWebsite, is_search_link) {
                
                is_search_link = is_search_link ? is_search_link : null;

                // mobile site and native apps open links slightly different
                if (isMobileWebsite) {
                    openMethod = '_self';
                } else {
                    openMethod = '_system';
                }

                // Send analytics event (varies on normal item vs suggested)
                if (item.is_suggested_item) {
                    ga_send_event('Item', 'Web Link Click', 'Suggested Item');
                } else {
                    ga_send_event('Item', 'Web Link Click');
                }


                if (is_search_link) {
                    ga_send_event('Item', 'Store Match', 'Search Result Click');                    
                }

                $window.open(urlWebsite, openMethod, 'location=yes,enableViewportScale=yes');
            };
            $scope.myGoBack = function() {
                if ($stateParams.tab == 'search' && $stateParams.type == 'search')
                    $ionicHistory.goBack();
                else if ($stateParams.tab == 'groups' && $stateParams.type == 'search')
                    $state.go('tab.groups-search-mylists-list', {"mylistId": $stateParams.memberlistId, "tab": $stateParams.tab, "type": $stateParams.type}, {reload: true, inherit: false});
                else if ($stateParams.tab == 'groups')
                    $state.go('tab.groups-memberlists-list', {"memberlistId": $stateParams.memberlistId, "listId": $stateParams.listId, "tab": $stateParams.tab}, {reload: true, inherit: false});
                else if ($stateParams.tab == 'shoppinglist')
                    $state.go('tab.shop-shoppinglist', {'tab': 'shop'}, {reload: true, inherit: false});
                else
                    $state.go('tab.memberlists-list', {"memberlistId": $stateParams.memberlistId, "listId": $stateParams.listId, "tab": $stateParams.tab}, {reload: true, inherit: false});
            };


            $scope.openModal = function() {
                Member.store_matches($stateParams.listId, $stateParams.listitemId, $scope.listitem[0].store_matches.provider_name, linkPlatform).then(function(result) {
                    $scope.store_matches = result.data;
                });
                
                // Send analytics event
                ga_send_event('Item', 'Store Match', 'Search');

                $ionicModal.fromTemplateUrl('store-match-results-modal.html', {
                    scope: $scope,
                    animation: 'slide-in-up'
                  }).then(function(modal) {
                    $scope.modal = modal;
                    $scope.modal.show();                    
                  });            
            };              

            $scope.closeModal = function() {
                $scope.modal.hide();
              };            
        })

        //
        //Mylists Tab
        //
        .controller('PreferencesCtrl', function($scope, $state, $timeout, globalImages, $stateParams, $ionicPopup, $localstorage, Lists, Member) {
            console.log('************* Mylists Tab ***************');
            ga_send_pageview('My Lists - Home Tab');
            
            //console.log('$stateParams - ', $stateParams);
            $scope.globalImages = {
                icon_plus_green: globalImages.icon_plus_green
            };
            $scope.wish_lists = null;
            $scope.preferences = null;
            $scope.ionClassRight = 'hide';
            $scope.itemIconRight = '';
            $scope.userid = $localstorage.get('userid');
            $scope.userSettings;
            // $scope.userSettings = Lists.setListsParams(); // userSettings.setParams('hide', 'hide', ' ', '', '', 'hide');
            $scope.settingsElements = {
                content_class: ' ',
                header_class: ' ',
                button_bar_short: ' ',
                list_my_list_visible: ' ',
                list_preferences_visible: ' ',
                list_child_account_visible: ' ',
                start_list_preferences_visible: 'hide',
                start_list_child_account_visible: 'hide'
            };
            $scope.mySuggestedItemsCount = 0;

            Lists.giftPreferences($scope.userid, true).then(function(response) {
                console.log('$scope.preferences----', response);
                $scope.preferences = response;
                // console.log('$scope.preferences----', $scope.preferences);
            });
            Lists.childAccounts().then(function(response) {
                console.log('@@@@ $scope.childAccounts - ', response);
                $scope.childAccounts = response;
            });
            Lists.getAllLists().then(function(response) {
                if (response.error)
                    if (response.error == 'Invalid Token')
                        return console.log('Lists.getAllLists user--', response);
                console.log('Lists.getAllLists user--', response);
                $scope.userSettings = response.userSettings;
                $scope.wish_lists = response.wish_lists;
                $timeout(function() {
                    if ($scope.preferences[0].id == 0 && $scope.childAccounts.accounts.length == 0 && $scope.wish_lists[0].id == 0)
                        $scope.settingsElements = {
                            content_class: 'content-bar',
                            header_class: 'button-bar-short',
                            button_bar_short: 'button-bar-short',
                            list_my_list_visible: 'hide',
                            list_preferences_visible: 'hide',
                            list_child_account_visible: 'hide',
                            start_list_preferences_visible: ' ',
                            start_list_child_account_visible: ' '
                        };
                }, 0);
            });

            Member.getMySuggestedItemCount().then(function(count){ 
                $scope.mySuggestedItemsCount = count;
            });

            $scope.addList = function() {
                if ($stateParams.tab == 'shop')
                    $state.go('tab.shop-mylists-add', {"idchild": 0, "tab": 'shop'}, {reload: true});
                else
                    $state.go('tab.mylists-add', {"idchild": 0, "tab": 'mylists'}, {reload: true});
            };
            $scope.selectMyGiftPreferences = function(userID) {
                if ($stateParams.tab == 'shop')
                    $state.go('tab.shop-mylists-preferences', {"memberId": userID, "name": 'parent'}, {reload: true});
                else
                    $state.go('tab.mylists-preferences', {"memberId": userID, "name": 'parent'}, {reload: true});
            };

            $scope.selectChildAccount = function(childUrl) {
                if ($stateParams.tab == 'shop' && childUrl == 'childaccounts')
                    $state.go('tab.shop-mylists-childaccounts', {"tab": 'shop'}, {reload: true});
                else if ($stateParams.tab == 'shop' && childUrl == 'viewchildaccounts')
                    $state.go('tab.shop-mylists-viewchildaccounts', {"tab": 'shop'}, {reload: true});
                else if (!$stateParams.tab && childUrl == 'childaccounts')
                    $state.go('tab.mylists-childaccounts', {"tab": 'mylists'}, {reload: true});
                else if (!$stateParams.tab && childUrl == 'viewchildaccounts')
                    $state.go('tab.mylists-viewchildaccounts', {"tab": 'mylists'}, {reload: true});
            };

            $scope.selectMyList = function(myList, listId, wish_list) {
                if (listId == 0)
                    return;
                //Remember selected item
                console.log('wish_list ---', wish_list);

                $timeout(function() {

                    $localstorage.set('select_mylist', myList);
                    if (wish_list.archivelist)
                        $state.go('tab.mylists-list', {"mylistId": listId, "tab": "", "type": 'got'}, {reload: true});
                    else if ($stateParams.tab)
                        $state.go('tab.shop-mylists-list', {"mylistId": listId, "tab": $stateParams.tab}, {reload: true});
                    else
                        $state.go('tab.mylists-list', {"mylistId": listId}, {reload: true});

                        console.log('Hack to wait for all lists to load.');
                    }, 450);
            };

            
            $scope.remove = function(one_list) {
                $ionicPopup.show({
                    title: 'Delete List',
                    template: 'Are you sure you want to remove this list?',
                    buttons: [{text: 'no, cancel'}, {
                            text: '<b>yes</b>',
                            type: 'button-positive',
                            onTap: function() {
                                Lists.remove(one_list).then(function(response) {
                                    console.log('remove response----', response);
                                    $scope.wish_lists.splice($scope.wish_lists.indexOf(one_list), 1);
                                    if (response.wish_lists.length == 0 && $scope.wish_lists.length == 0)
                                        $scope.userSettings = {list_text_visible: "show", list_visible: "hide", class_right: "hide", icon_right: ""};

                                    if ($scope.preferences[0].id == 0 && $scope.childAccounts.accounts.length == 0 && $scope.wish_lists.length == 0)
                                        $scope.settingsElements = {
                                            content_class: 'content-bar',
                                            header_class: 'button-bar-short',
                                            button_bar_short: 'button-bar-short',
                                            list_my_list_visible: 'hide',
                                            list_preferences_visible: 'hide',
                                            list_child_account_visible: 'hide',
                                            start_list_preferences_visible: ' ',
                                            start_list_child_account_visible: ' '
                                        };
                                });
                            }
                        }
                    ]
                });
            };
        })
        //
        //Mylists Tab -> MyListsPreferencesCtrl
        //
        .controller('MyListsPreferencesCtrl', function($scope, globalImages, $localstorage, $ionicModal, $ionicHistory, customElements, $stateParams, Lists) {
            console.log('--- MyListsPreferencesCtrl ---');
            ga_send_pageview('My Lists - Gift Preferences');
            
            $scope.globalImages = {
                icon_save: globalImages.icon_save
            };
            $scope.public = null;
            $scope.list_activeButton = null;
            $scope.preferences_class_size = 'hide';
            $scope.preferences_class_interests = 'hide';
            $scope.preferences_class_address = 'hide';
            $scope.pointer_class_size = 'ion-chevron-down';
            $scope.pointer_class_interests = 'ion-chevron-down';
            $scope.pointer_class_address = 'ion-chevron-down';
            $scope.gift_preferences = null;
            $scope.formData = {};
            $scope.interestsData = {
                extrasize_name0: '',
                extrasize_size0: '',
                extrasize_name1: '',
                extrasize_size1: ''
            };
            $('.bar .back-button').removeClass('hide');
            $scope.change_value = false;
            $("input").on("input", function() {
                if (!$scope.change_value)
                    $scope.change_value = true;
            });
            $("textarea").on("input", function() {
                if (!$scope.change_value)
                    $scope.change_value = true;
            });
            console.log('$stateParams - ', $stateParams);
            var memberId = null;
            if ($stateParams.memberId)
                memberId = $stateParams.memberId;
            else
                memberId = $stateParams.memberlistId;
            console.log('memberId - ', memberId);
            if ($localstorage.get('login_token'))
                Lists.giftPreferences(memberId, false).then(function(response) {
                    console.log('response - ', response);
                    $scope.formData.gift_preferences = response.gift_preferences;
                    //fill interestsData data
                    if (response.extra_sizes.length != 0)
                        $.each(response.extra_sizes, function(key, val) {
                            $scope.interestsData['extrasize_name' + key] = val.name;
                            $scope.interestsData['extrasize_size' + key] = val.size;
                        });
                    if (response.gift_preferences.shoe_size || response.gift_preferences.casual_shirt_size || response.gift_preferences.dress_shirt_size || response.gift_preferences.pants_size || response.gift_preferences.jacket_size || response.gift_preferences.dress_size || response.gift_preferences.hat_size)
                        $scope.showHide('1');
                    if ($scope.interestsData.extrasize_name0 || $scope.interestsData.extrasize_size0 || $scope.interestsData.extrasize_name1 || $scope.interestsData.extrasize_size1 || response.gift_preferences.hobbies || response.gift_preferences.other || response.gift_preferences.favorites)
                        $scope.showHide('2');
                    if (response.gift_preferences.full_name || response.gift_preferences.street1 || response.gift_preferences.street2 || response.gift_preferences.city || response.gift_preferences.state || response.gift_preferences.postal_code || response.gift_preferences.country || response.gift_preferences.phone_number)
                        $scope.showHide('3');
                });


            $scope.clickStatus = function(statusId) {
                $scope.formData.gift_preferences.public = statusId;
                $scope.public = statusId;
            };
            $scope.savePreferences = function() {
                console.log('gift_preferences - - ', $scope.formData.gift_preferences);
                console.log('$scope.interestsData - - ', $scope.interestsData);
                console.log('$stateParams.name - - ', $stateParams);
                if ($stateParams.name == 'child') {
                    ga_send_event('Gift Preferences', 'Save', 'Child Account');
                    Lists.addChildGiftPreferences($scope.formData.gift_preferences, $scope.interestsData, $stateParams.memberId).then(function(response) {
                        console.log('addChildGiftPreferences  - - ', response);
                        $ionicHistory.goBack();
                        // $state.go('tab.preferences', {"mylistId": $stateParams.mylistId}, {reload: true});
                    });
                } else {
                    ga_send_event('Gift Preferences', 'Save');
                    Lists.addGiftPreferences($scope.formData.gift_preferences, $scope.interestsData).then(function(response) {
                        console.log('response - - ', response);
                        $ionicHistory.goBack();
                        // $state.go('tab.preferences', {"mylistId": $stateParams.mylistId}, {reload: true});
                    });
                }
            };
            $scope.showHide = function(index) {
                if (index == '1') {
                    $scope.preferences_class_size = ($scope.preferences_class_size == 'hide') ? ' ' : 'hide';
                    $scope.pointer_class_size = ($scope.pointer_class_size == 'ion-chevron-down') ? 'ion-chevron-up' : 'ion-chevron-down';
                }
                if (index == '2') {
                    $scope.preferences_class_interests = ($scope.preferences_class_interests == 'hide') ? ' ' : 'hide';
                    $scope.pointer_class_interests = ($scope.pointer_class_interests == 'ion-chevron-down') ? 'ion-chevron-up' : 'ion-chevron-down';
                }
                if (index == '3') {
                    $scope.preferences_class_address = ($scope.preferences_class_address == 'hide') ? ' ' : 'hide';
                    $scope.pointer_class_address = ($scope.pointer_class_address == 'ion-chevron-down') ? 'ion-chevron-up' : 'ion-chevron-down';
                }
            };
            $scope.myGoBack = function() {
                //console.log('0 gift_preferences- ', $scope.formData.gift_preferences);
                //console.log('0 interestsData- ', $scope.interestsData);
                //console.log('1 $scope.public - - ', $scope.public);
                if (!$scope.change_value)
                    return $ionicHistory.goBack();
                $.each($scope.formData.gift_preferences, function(key, val) {
                    //console.log('!!!' + key + ' - ' + $('.item_' + key).val());
                    if (key != 'public')
                        $scope.formData.gift_preferences[key] = $('.item_' + key).val();
                    else {
                        //console.log('$scope.public - - ', $scope.public);
                        if ($('.item_public_true.active').length != 0)
                            $scope.formData.gift_preferences[key] = 1;
                        else if ($('.item_public_false.active').length != 0)
                            $scope.formData.gift_preferences[key] = 0;
                        console.log('!!!!!!!! $scope.formData.gift_preferences- ', $scope.formData.gift_preferences[key]);
                        //  console.log('public - - ', $scope.formData.gift_preferences.public);
                    }
                });
                $.each($scope.interestsData, function(key, val) {
                    //console.log('------ ---- interestsData ' + key + ' - ' + $('.item_' + key).val());
                    $scope.interestsData[key] = $('.item_' + key).val();
                });
                customElements.popup('Don’t forget to save', 'Did you want to save your recent changes?', 'no thanks', '', '<b>save</b>', 'yellow-btn').then(function(response) {
                    if (response) {
                        if ($stateParams.name == 'child')
                            Lists.addChildGiftPreferences($scope.formData.gift_preferences, $scope.interestsData, $stateParams.memberId).then(function(response) {
                                console.log('addChildGiftPreferences  - - ', response);
                                $ionicHistory.goBack();
                                // $state.go('tab.preferences', {"mylistId": $stateParams.mylistId}, {reload: true});
                            });
                        else
                            Lists.addGiftPreferences($scope.formData.gift_preferences, $scope.interestsData).then(function(response) {
                                console.log('addGiftPreferences----', response);
                                $ionicHistory.goBack();
                            });
                    } else
                        $ionicHistory.goBack();
                });
            };

        })
        //
        //Mylists Tab -> MyListsViewChildAccountCtrl
        //
        .controller('MyListsViewChildAccountCtrl', function($scope, $stateParams, $ionicPopup, globalImages, $state, $localstorage, Lists) {
            $scope.globalImages = {
                icon_plus_green: globalImages.icon_plus_green
            };
            $scope.message = '';
            $scope.childAccounts = [];
            $scope.wish_lists = null;
            $scope.preferences = null;
            $scope.ionClassRight = 'hide';
            $scope.itemIconRight = '';

            console.log('$stateParams - ', $stateParams);

            $scope.createChildAccount = function() {
                console.log('- createChildAccount - ');
                ga_send_pageview('My Lists - Add Child Account');
                
                if ($stateParams.tab == 'shop')
                    $state.go('tab.shop-mylists-childaccounts-create-edit', {tab: 'shop', name: 'create'}, {reload: true});
                else
                    $state.go('tab.mylists-childaccounts-create-edit', {tab: 'mylists', name: 'create'}, {reload: true});
            };
            $scope.selectChildAccount = function(childAccount) {
                console.log('childAccount---', childAccount);
                console.log('tab---', 'mylists');
                ga_send_pageview('My Lists - Child Account Detail');
                
                if (childAccount) {
                    $localstorage.setObject('select_member', childAccount);
                    if ($stateParams.tab == 'shop')
                        $state.go('tab.shop-mylists-memberlists', {"memberlistId": childAccount.id, "name": "child", tab: 'shop'}, {reload: true});
                    else
                        $state.go('tab.mylists-memberlists', {"memberlistId": childAccount.id, "name": "child", tab: 'mylists'}, {reload: true, inherit: false});
                }
            };
            Lists.viewChildAccounts().then(function(response) {
                console.log('res----', response);
                $scope.childAccounts = response;
            });
            console.log('childAccounts----', $scope.childAccounts);
            ga_send_pageview('My Lists - Child Accounts');
            
            $scope.remove = function(account) {
                $ionicPopup.show({
                    title: 'Delete account',
                    template: 'Are you sure you want to delete this child account?',
                    buttons: [{text: 'no, cancel'}, {
                            text: '<b>yes</b>',
                            type: 'button-positive',
                            onTap: function() {
                                Lists.delChildAccounts(account, $scope.childAccounts).then(function(response) {
                                    console.log('remove response----', response);
                                    if (response == false)
                                        return;
                                    else if (response == true)
                                        return $scope.userSettings = response.userSettings;
                                    else if (response.wish_lists[0].id == 0) {
                                        if ($stateParams.tab == 'shop')
                                            $state.go('tab.shop-mylists-childaccounts', {tab: 'shop'}, {reload: true});
                                        else
                                            $state.go('tab.mylists-childaccounts', {}, {reload: true, inherit: false});
                                    }
                                    // $scope.ionClassRight = response.userSettings.class_right;
                                    // $scope.itemIconRight = response.userSettings.icon_right;
                                    // $scope.wish_lists = response.wish_lists;
                                });
                            }
                        }
                    ]
                });
            };
        })
        //
        //Mylists Tab -> MyListsAddChildAccountCtrl
        //
        .controller('MyListsAddChildAccountCtrl', function($scope, $state, $localstorage, globalImages) {
            console.log('MyListsAddChildAccountCtrl - ');
            $scope.globalImages = {
                icon_plus_green: globalImages.icon_plus_green
            };
            $scope.parent_email = $localstorage.get('useremail');
            $scope.createChildAccount = function() {
                $state.go('tab.mylists-childaccounts-create-edit', {name: 'create', tab: 'childaccounts'}, {reload: true});
            };
            $scope.selectChildAccount = function() {
                console.log(' - selectChildAccount - ');
                //$state.go('tab.mylists-childaccounts-create-edit', {name: 'create'}, {reload: true});
            };
        })
        //
        //Mylists Tab -> MyListsAddChildAccountCtrl -> MyListsCreateEditChildAccountCtrl
        //
        .controller('MyListsCreateEditChildAccountCtrl', function($scope, $state, $localstorage, $filter, $ionicHistory, $stateParams, customElements, globalImages, Lists, userSettings) {
            console.log('-- MyListsCreateChildAccountCtrl - - ');
            console.log('$stateParams - ', $stateParams.name);
            var selectMember = $localstorage.getObject('select_member');
            $scope.globalImages = {
                icon_plus_green: globalImages.icon_plus_green,
                icon_save: globalImages.icon_save
            };
            $scope.parentEmail = '';
            $scope.userBirthday = '';
            $scope.user = [];
            $scope.message = '';
            $scope.addChildAccount = {first_name: null, last_name: null, birthday_day: null, birthday_month: null, birthday_year: null, userprofile: {}};
            $scope.userParams = [];
            userSettings.getUserEmail().then(function(parentEmail) {
                if (parentEmail)
                    $scope.parentEmail = parentEmail;
                console.log('$scope.parentEmail -', $scope.parentEmail);
            });
            console.log('idchild =', $stateParams.idchild);
            if ($stateParams.name == 'edit') {

                $scope.userParams = {
                    title: 'Edit Child Account',
                    child_info: 'hide',
                    button_create: 'hide',
                    header_create: 'hide',
                    button_save: 'show',
                    header_button_save: 'show',
                    header_top_button_save: 'header_save',
                    child_content: 'child_content'
                };
                Lists.getChildAccount($stateParams.idchild).then(function(response) {
                    $scope.addChildAccount = response;
                    console.log('addChildAccount -', $scope.addChildAccount);
                    $scope.addChildAccount.birthday_month = $scope.addChildAccount.userprofile.birthday_month
                    $scope.addChildAccount.birthday_day = $scope.addChildAccount.userprofile.birthday_day
                    $scope.addChildAccount.birthday_year = $scope.addChildAccount.userprofile.birthday_year
                });
            } else {
                $scope.userParams = {
                    title: 'New Child Account',
                    child_info: 'show',
                    button_create: 'show',
                    header_create: 'show',
                    button_save: 'hide',
                    header_button_save: 'hide',
                    header_top_button_save: ' ',
                    child_content: ' '
                };
            }

            $scope.changeBirthday = function() {
                $scope.addChildAccount.userprofile.birthday_month = $filter("date")($scope.user.birthday_date, 'MM');
                $scope.addChildAccount.birthday_month = $filter("date")($scope.user.birthday_date, 'MM');

                $scope.addChildAccount.userprofile.birthday_day = $filter("date")($scope.user.birthday_date, 'dd');
                $scope.addChildAccount.birthday_day = $filter("date")($scope.user.birthday_date, 'dd');

                $scope.addChildAccount.userprofile.birthday_year = $filter("date")($scope.user.birthday_date, 'yyyy');
                $scope.addChildAccount.birthday_year = $filter("date")($scope.user.birthday_date, 'yyyy');
            };
            $scope.createChildAccount = function() {
                if ($('.first_name').val().length == 0)
                    return  customElements.alert('Missing Required Field', "<style>.popup-buttons .button.button-positive { margin-left: 25%; margin-right: 25%; }</style><p>Please fill out First name field to create your child account</p>", 'ok', 'button-positive');
                Lists.addChildAccounts($scope.addChildAccount).then(function(response) {
                    console.log('response----', response);
                    if (response.data)
                        if ($stateParams.tab == 'childaccounts')
                            $state.go('tab.mylists-viewchildaccounts', {}, {reload: true});
                        else
                            $ionicHistory.goBack(); //$state.go('tab.mylists-viewchildaccounts', {}, {reload: true});
                    else
                        $scope.message = 'Please fill in the fields';
                });
            };
            $scope.saveChildAccount = function() {
                Lists.editChildAccounts($scope.addChildAccount).then(function(response) {
                    console.log('response----', response);
                    if (response.data) {
                        selectMember.first_name = response.data.first_name;
                        selectMember.last_name = response.data.last_name;
                        $localstorage.setObject('select_member', selectMember);
                        console.log('$stateParams.idchild----', $stateParams.idchild);
                        if ($stateParams.idchild)
                            $state.go('tab.mylists-memberlists', {memberlistId: $stateParams.idchild, name: 'child', tab: $stateParams.tab}, {reload: true, inherit: false});
                        else
                            $ionicHistory.goBack();
                    } else
                        $scope.message = 'Please fill in the fields';
                });
            };
        })
        //
        //Mylists Tab -> MyListsAddCtrl
        //
        .controller('MyListsAddCtrl', function($scope, Groups, $timeout, globalImages, $ionicHistory, customElements, $rootScope, $state, $stateParams, Lists) {
            console.log('----- MyListsAddCtrl ------');
            console.log('$stateParams - ', $stateParams);
            $('.bar .back-button').removeClass('hide');
            ga_send_pageview('My Lists - Add List');
            
            $scope.footer_tabs = 'show';
            $scope.element_visible = '';
            $scope.list_activeButton = 2;
            $scope.updateitem = null;
            $scope.message = "";
            $scope.addlist = {
                title: null,
                description: null,
                is_private: 2,
                search_visibility: 2
            };
            $scope.globalImages = {
                icon_plus_green: globalImages.icon_plus_green,
                icon_checkmark: globalImages.icon_checkmark
            };
            // set the rate and max variables
            $scope.rate = 0;
            $scope.max = 5;
            $scope.isReadonly = false;
            $scope.setrank = 0;
            $scope.isChecked = true;
            $scope.tasks = [];
            $scope.leftButtons = [{
                    type: 'button-icon icon ion-navicon',
                    tap: function(e) {
                        console.log('Going back!');
                    }
                }];
            $scope.myGoBack = function() {
                customElements.popup('Don’t forget to save', 'You have not saved any information. Are you sure you want to go back?', 'close', 'button-positive', '<b>yes, discard</b>', 'yellow-btn').then(function(response) {
                    if (response)
                        $ionicHistory.goBack();
                });
            };
            $scope.createList = function() {

                if ($('.addlist_title').val().length != 0)
                    $scope.message = '';
                else if (!$scope.addlist.title)
                    return  $scope.message = 'Please enter a name for your list.';
                var groupsId = [];
                if (!$stateParams.idchild || $stateParams.idchild == 0)
                    $.each($scope.tasks, function(key, val) {
                        if (val.checked == true)
                            groupsId.push(val.id);
                    });

                // Fix up search_visibilty
                $scope.addlist = Lists.fixListSearchVisibility($scope.addlist);

                $timeout(function() {

                    var iD = 0;
                    var userType = 'parent';
                    if ($stateParams.idchild && $stateParams.idchild != 0) {
                        iD = $stateParams.idchild;
                        userType = 'child';
                    } else
                        iD = groupsId;

                    if ($scope.isChecked && !$stateParams.idchild)
                        iD = 0;
                    
                    Lists.createList($scope.addlist, iD, userType).then(function(response) {
                        console.log('response - ', response);
                        if (response.data) {
                            $rootScope.hideTabs = false;


                            if (userType == 'child' && $stateParams.tab == 'mylists') {
                                ga_send_event('List', 'Add', 'Child Account');
                                $state.go('tab.mylists-memberlists', {"memberlistId": $stateParams.idchild, "name": 'child', "tab": 'mylists'}, {reload: true});
                            } else if (userType == 'child' && $stateParams.tab == 'shop') {
                                ga_send_event('List', 'Add', 'Child Account');
                                $state.go('tab.shop-mylists-memberlists', {"memberlistId": $stateParams.idchild, "name": 'child', "tab": 'shop'}, {reload: true});
                            } else {
                                ga_send_event('List', 'Add');
                                $state.go('tab.preferences', {"mylistId": $stateParams.mylistId, "tab": $stateParams.tab}, {reload: true});
                            }
                        }
                    });
                }, 200);
            };
            $scope.clickStatus = function(statusId) {
                $scope.list_activeButton = statusId;
                $scope.addlist.is_private = statusId;
            };
            Groups.getGroups('groups/all/', '').then(function(response) {
                console.log('response ---', response);
                $.each(response.data, function(key, val) {
                    var newGroup = {
                        id: val.id, title: val.title, checked: true
                    };
                    if (val.title)
                        $scope.tasks.push(newGroup);
                    console.log('$scope.tasks ---', $scope.tasks);
                });
            });
            $scope.checkedAllNew = function() {
                console.log('checkedAll-', $scope.isChecked);
                if ($scope.isChecked == false) {
                    $scope.isChecked = true;
                    $.each($scope.tasks, function(key, val) {
                        val.checked = true;
                    });
                } else {
                    $scope.isChecked = false;
                    $.each($scope.tasks, function(key, val) {
                        val.checked = false;
                    });
                }
            };
            $scope.toggleItemDisplay = function(task) {
                var taskLength = $scope.tasks.length;
                var allTasks = true;
                console.log('taskLength - ', taskLength);
                if (task.checked == true) {
                    console.log(task.title);
                    console.log('$scope.tasks.length - ', $scope.tasks.length);
                    $.each($scope.tasks, function(key, val) {
                        if (val.checked == false)
                            allTasks = false;
                        if (key == (taskLength - 1) && allTasks == true)
                            $scope.isChecked = true;
                    });
                } else {
                    console.log('not checked!');
                    $scope.isChecked = false;
                }
                console.log('----$scope.isChecked  ', $scope.isChecked);
            };
            $scope.checkedAll = function(task) {
                console.log('checkedAll-', task);
                if (task == true) {
                    $.each($scope.tasks, function(key, val) {
                        val.checked = true;
                    });
                    $scope.isChecked = true;
                }
            };
        })
        //
        //Mylists Tab -> MemberListsCtrl
        //
        .controller('MyListsListCtrl', function($rootScope, $scope, $state, $ionicHistory, $cordovaClipboard, $timeout, $ionicModal, customElements, $ionicPopup, Member, $localstorage, $stateParams, globalImages, userSettings, Lists) {
            console.log(' - - - MyListsListCtrl - - -');
            ga_send_pageview('My Lists - List Detail');
            $scope.globalImages = {
                icon_plus_green: globalImages.icon_plus_green,
                icon_share_arrow: globalImages.icon_share_arrow,
                icon_settings: globalImages.icon_settings
            };
            $scope.userSettings = userSettings.setParams('hide', 'hide', '', '', 'footer_without_tabs', '', 'hide');
            $scope.footer_tabs = $localstorage.get('footer_tabs');
            var login_token = $localstorage.get('login_token');
            $scope.element_visible = '';
            $scope.search_member = '';
            var select_wishlist = $localstorage.getObject('select_wishlist');
            $scope.search_member = select_wishlist.title ? select_wishlist.title : $localstorage.get('search_member');
            console.log('$scope.search_member=', $scope.search_member);
            // var select_wishlist = $localstorage.getObject('select_wishlist');
            console.log('select_wishlist=', select_wishlist);
            console.log('$localstorage.get(select_mylist) =', $localstorage.get('select_mylist'));
            $scope.element_remind = 'hide';
            $scope.element_visible = 'hide';
            $scope.got_list = 'hide';
            $scope.got_list_edit = ' ';
            $scope.got_updated = ' ';
            $scope.updated_status = ' ';
            $scope.has_suggested_items = false;
            $scope.isMobileWebsite = isMobileWebsite;

            if (login_token) {
                $scope.footer_tabs = 'show';
                $scope.userSettings = userSettings.setParams('hide', 'show', 'hide', 'hide', '', 'hide', '');
                if ($stateParams.type == 'got') {
                    $scope.got_list = 'show';
                    $scope.got_list_edit = 'hide';
                    $scope.settingsElements = {
                        content_class: 'content-bar',
                        button_bar_short: 'button-bar-short'
                    };
                }

                if ($stateParams.tab == 'shop' || $stateParams.tab == 'more' || $stateParams.tab == 'groups' || $stateParams.tab == 'tab2' || !login_token || $stateParams.type == 'search') {
                    $scope.element_visible = 'hide';
                    $scope.element_remind = 'show';
                    $scope.settingsElements = {
                        content_class: 'content-bar',
                        button_bar_short: 'button-bar-short'
                    };
                } else {
                    $scope.element_visible = 'show';
                    $scope.element_remind = 'hide';
                }
            } else {
                $scope.footer_tabs = 'hide';
                $scope.footer_without_tabs = 'footer_without_tabs';
                $scope.settingsElements = {
                    content_class: 'content-bar',
                    button_bar_short: 'button-bar-short'
                };
            }

            $scope.lists = null;
            $scope.listsId = null;
            $scope.itemNum = null;
            $scope.list_activeButton = 2;
            $scope.mylists_title = null;

            // set the rate and max variables
            $scope.rate = 0;
            $scope.max = 5;
            $scope.isReadonly = true;
            $scope.setrank = 0;
            $scope.setRate = function(value) {
                $scope.setrank = value;
            };
            $scope.hoveringOver = function(value) {
                $scope.overStar = value;
                $scope.percent = 100 * (value / $scope.max);
            };
            $scope.ratingStates = [
                {stateOn: 'glyphicon-ok-sign', stateOff: 'glyphicon-ok-circle'},
                {stateOn: 'glyphicon-star', stateOff: 'glyphicon-star-empty'},
                {stateOn: 'glyphicon-heart', stateOff: 'glyphicon-ban-circle'},
                {stateOn: 'glyphicon-heart'},
                {stateOff: 'glyphicon-off'}
            ];
            $scope.listsId = $stateParams.mylistId;

            if (($stateParams.type == 'got'))
                $scope.mylists_title = 'I Got This List';
            else
                $scope.mylists_title = select_wishlist.title ? select_wishlist.title : $localstorage.get('select_mylist');
            // Called to select the given Wish Lists
            $scope.selectItems = function(selectItem, listId) {
                //Remember selected item
                $localstorage.set('select_item', selectItem);
                console.log('$stateParams= ', $stateParams);
                console.log('listId= ', listId);

                if ($stateParams.tab == 'groups' && $stateParams.type == 'search')
                    return $state.go('tab.groups-list-item', {"memberlistId": $stateParams.mylistId, "listId": listId, "listitemId": listId, "tab": 'groups', "type": "search"}, {reload: true});
                else if ($stateParams.tab == 'search' && $stateParams.type == 'search')
                    return $state.go('search-mylists-list-item', {"memberlistId": $stateParams.mylistId, "listId": listId, "listitemId": listId, "tab": 'search', "type": "search"}, {reload: true});
                else if ($stateParams.tab == 'shop' || $stateParams.tab == 'more' || $stateParams.tab == 'groups' || $stateParams.tab == 'tab2' || !login_token)
                    return $state.go('tab.groups-list-item', {"memberlistId": $stateParams.mylistId, "listId": listId, "listitemId": listId, "tab": $stateParams.tab, "type": $stateParams.type}, {reload: true});
                else
                    return $state.go('tab.item-update', {"mylistId": $stateParams.mylistId, "tab": $stateParams.tab, "itemId": listId, "type": "edit"}, {reload: true});
            };
            $scope.contact = {
                name: 'Mittens Cat',
                info: 'Tap anywhere on the card to open the modal'
            };
            $ionicModal.fromTemplateUrl('share-modal.html', {
                scope: $scope,
                animation: 'slide-in-up'
            }).then(function(modal) {
                $scope.modal = modal;
            });
            $scope.shareList = function() {
                $scope.modal.show();
            };
            $scope.closeModal = function() {
                $scope.modal.hide();
            };
            $scope.$on('$destroy', function() {
                $scope.modal.remove();
            });

            $scope.email = function() {
                /*$(location).attr('href', 'mailto:?subject='
                 + encodeURIComponent("Mom's Christmas Ideas")
                 + "&body="
                 + encodeURIComponent($scope.siteLink)
                 );*/
                ga_send_event('Item', 'Share', 'Email');
                document.location = 'mailto:?subject='
                        + encodeURIComponent(" ")
                        + "&body="
                        + encodeURIComponent($scope.siteLink);
            };
            $scope.remove = function(list) {
                $ionicPopup.show({
                    title: 'Delete Item',
                    template: 'Are you sure you want to remove this item?',
                    buttons: [{text: 'no, cancel'}, {
                            text: '<b>yes</b>',
                            type: 'button-positive',
                            onTap: function() {
                                Lists.removeItems(list).then(function(response) {
                                    $scope.userSettings = response.userSettings;
                                    $scope.lists.splice($scope.lists.indexOf(list), 1);
                                });
                            }
                        }
                    ]
                });
            };
            
            $scope.addList = function() {
                if ($stateParams.tab == 'shop')
                    $state.go('tab.shop-mylists-add', {"idchild": 0, "tab": 'shop'}, {reload: true, inherit: false});
                else
                    $state.go('tab.mylists-add', {"idchild": 0, "tab": 'mylists'}, {reload: true, inherit: false});
            };
            $scope.addItemPlus = function(itemNum) {
                if ($stateParams.tab == 'shop')
                    $state.go('tab.shop-item-add', {"mylistId": itemNum, "type": 'add', "tab": 'shop'}, {reload: true});
                else
                    $state.go('tab.item-add', {"mylistId": itemNum, "type": 'add', "tab": 'mylists'}, {reload: true});
            };
            $scope.goToSettingsPage = function() {
                if ($stateParams.tab == 'shop')
                    $state.go('tab.shop-mylists-settings', {"mylistId": $scope.listsId, "tab": 'shop'}, {reload: true, inherit: false});
                else
                    $state.go('tab.mylists-settings', {"mylistId": $scope.listsId, "tab": 'mylists'}, {reload: true, inherit: false});
            };
            $scope.pageItemAdd = function() {
                if ($stateParams.tab == 'shop')
                    $state.go('tab.shop-item-add', {"mylistId": $scope.listsId, "type": 'add', "tab": 'shop'}, {reload: true, inherit: false});
                else
                    $state.go('tab.item-add', {"mylistId": $scope.listsId, "type": 'add', "tab": 'mylists'}, {reload: true});
            };
            $scope.sendReminder = function() {
                if ($stateParams.tab == 'more')
                    $state.go('tab.more-search-mylists-list-sendreminder', {"mylistId": $scope.listsId, "tab": $stateParams.tab}, {reload: true, inherit: false});
                else if ($stateParams.tab == 'groups')
                    $state.go('tab.groups-search-mylists-list-sendreminder', {"mylistId": $scope.listsId, "tab": $stateParams.tab}, {reload: true, inherit: false});
                else if ($stateParams.tab == 'shop')
                    $state.go('tab.shop-search-mylists-list-sendreminder', {"mylistId": $scope.listsId, "tab": $stateParams.tab}, {reload: true, inherit: false});
                else {
                    $state.go('search-mylists-list-sendreminder', {"mylistId": $scope.listsId, "tab": 'search'}, {reload: true, inherit: false});
                }
            };
            $scope.clickStatus = function(statusId) {
                if (login_token)
                    Lists.setListStatus($scope.listsId, statusId).then(function(response) {
                        //console.log('clickStatus response - - -', response);
                        $scope.list_activeButton = statusId;
                    });
            };

            if (login_token) 
                Lists.getListStatus($scope.listsId).then(function(response) {
                    $scope.siteLink = 'https://www.giftster.com/gift/' + response.url_locator
                    //console.log('getListStatus response - - -', response);
                    $scope.list_activeButton = response.is_private;
                    $scope.has_suggested_items = response.has_suggested_items;
                    if (($stateParams.type == 'got'))
                        $scope.mylists_title = 'I Got This List';
                    else
                        $scope.mylists_title = response.title;
                });
            else
                Lists.getListStatus($scope.listsId).then(function(response) {
                    //console.log('getListStatus response - - -', response);
                    $scope.list_activeButton = response.is_private;
                    if (($stateParams.type == 'got'))
                        $scope.mylists_title = 'I Got This List';
                    else
                        $scope.mylists_title = response.title;
                });
            if (login_token && $stateParams.type == 'got') {
                 Member.getListItems($scope.listsId).then(function(responseListItems) {
                    $scope.lists = responseListItems.new_lists;
                });
                Lists.getListStatus($scope.listsId).then(function(response) {
                    $scope.got_updated = customElements.dateDiffFormat(response.modified);
                });

            } else {
                Lists.getItemsList($stateParams.mylistId).then(function(response) {
                    console.log('response ---', response);
                    $scope.lists = response.new_lists;
                    $scope.itemNum = $stateParams.mylistId;
                    //if (login_token)
                    //$scope.info_message = response.userSettings.info_message;
                    $scope.list_activeButton = response.userSettings.list_activeButton;

                    $timeout(function() {
                        console.log('response ---', $scope.lists);
                        if (response.new_lists.length == 0) {
                            $scope.list_info_visible = 'show';
                            $scope.updated_status = 'show';
                        } else
                            $scope.lists = response.new_lists;
                    }, 300);
                    Lists.getListStatus($stateParams.mylistId).then(function(response) {
                        $scope.got_updated = customElements.dateDiffFormat(response.modified);
                    });
                });
            }

            $scope.addItem = function() {
                if ($stateParams.tab == 'shop')
                    $state.go('tab.shop-item-add', {"mylistId": $scope.listsId, "type": 'add', "tab": $stateParams.tab}, {reload: true, inherit: false});
                else
                    $state.go('tab.item-add', {"mylistId": $scope.listsId, "type": 'add', "tab": $stateParams.tab}, {reload: true, inherit: false});
            };

            $scope.myGoBack = function() {

                if ($stateParams.tab == 'mylists' && $stateParams.type != 'child')
                    $state.go('tab.preferences', {}, {reload: true, inherit: false});
                else
                    $ionicHistory.goBack();
            };
            $scope.copyLink = function() {
                $cordovaClipboard
                    .copy($scope.siteLink)
                    .then(function () {
                      // success
                    }, function () {
                      // error
                    });
                console.log('copyLink!!!');
                ga_send_event('Item', 'Share', 'Copy Link');
            };            
        })
        .controller('MyListsSuggestedItemsCtrl', function($rootScope, $scope, $state, $ionicHistory, $ionicPopup, $localstorage, customElements, userSettings, Lists, Member) {
            ga_send_pageview('My Lists - Suggested Items');
            $scope.isMobileWebsite = isMobileWebsite;
            $scope.userSettings = userSettings.setParams('hide', 'hide', '', '', 'footer_without_tabs', '', 'hide');
            // set the rate and max variables
            $scope.rate = 0;
            $scope.max = 5;
            $scope.setrank = 0;
            $scope.lists = null;

            Member.getMySuggestedItems().then(function(response) {
                $scope.lists = response;
            })

            $scope.redirectToGiftList = function(wishlist) {
            
                if (wishlist.suggested_items_visible) {
                    $localstorage.set('select_mylist', wishlist.title);                
                    
                    $state.go('redirectgiftlist', 
                        { 
                            memberID: wishlist.user_id,
                            listID: wishlist.id,
                            locator: wishlist.url_locator
                        }
                    )

                } else {
                    return false;
                }
            };


            $scope.removeSuggestedItem = function(event, delItem) {
                event.stopPropagation();
                $ionicPopup.show({
                    title: 'Delete Suggested Item',
                    template: 'Are you sure you want to remove this suggested item?',
                    buttons: [{text: 'no, cancel'}, {
                            text: '<b>yes</b>',
                            type: 'button-positive',
                            onTap: function() {
                                Lists.removeItems(delItem).then(function(response) {

                                    // Loop through array of wishlists ES5 style
                                    for (i=0; i < $scope.lists.length; i++) {

                                        // Found item's wishlist, now need to find the item
                                        if ($scope.lists[i].id == delItem.list_id) { 

                                            for (j=0; j < $scope.lists[i].user_suggested_items.length; j++) {
                                                if ($scope.lists[i].user_suggested_items[j].id == delItem.id) {
                                                    $scope.lists[i].user_suggested_items.splice(j, 1);
                                                    break;
                                                }
                                            }
                                        }
                                    } 
                                })
                            }
                        }
                    ]
                });
            };

            $scope.setSelectedItem = function(item, list) {
                $localstorage.set('select_item', item.title);
                $localstorage.setObject('select_member',
                    {
                        id: list.user_id,
                        name: list.user_full_name,
                        email: "",
                        class_item: "",
                        class_icon: "hide",
                        is_current_user: false
                    }
                )
            };


            $scope.getFriendlyDate = function(date) {
                return customElements.dateDiffFormat(date);
            };

            $scope.setRate = function(value) {
                $scope.setrank = value;
            };

            $scope.hoveringOver = function(value) {
                $scope.overStar = value;
                $scope.percent = 100 * (value / $scope.max);
            };

            $scope.ratingStates = [
                {stateOn: 'glyphicon-ok-sign', stateOff: 'glyphicon-ok-circle'},
                {stateOn: 'glyphicon-star', stateOff: 'glyphicon-star-empty'},
                {stateOn: 'glyphicon-heart', stateOff: 'glyphicon-ban-circle'},
                {stateOn: 'glyphicon-heart'},
                {stateOff: 'glyphicon-off'}
            ];

          
        })

        .controller('SuggestedItemsHelpCtrl', function($scope, $window, $ionicLoading) {
            ga_send_pageview('More - About Giftster');
            

        })        
        //
        //Mylists Tab -> MemberListsCtrl ->MyListsSettingsCtrl
        //
        .controller('MyListsSettingsCtrl', function($scope, $state, $timeout, $rootScope, Lists, Groups, $localstorage, $stateParams) {
            ga_send_pageview('My Lists - List Settings');
            
            $scope.mylists_title = $localstorage.get('select_mylist');
            $scope.list_activeButton = 2;

            $scope.isChecked = true;
            var groupsId = [];
            $scope.tasks = [];
            $scope.addlist = {
                title: null,
                description: null,
                is_private: 2,
                search_visibility: 2
            };

            Groups.getGroups('groups/all/', '').then(function(response) {
                console.log('response ---', response);
                $.each(response.data, function(key, val) {
                    var newGroup = {
                        id: val.id, title: val.title, checked: true
                    };
                    if (val.title)
                        $scope.tasks.push(newGroup);
                    console.log('$scope.tasks ---', $scope.tasks);
                });
                $timeout(function() {

                    Lists.editGetItemsList($stateParams.mylistId).then(function(response) {
                        console.log('!!! editGetItemsList response =', response);
                        $scope.addlist.title = response.title;
                        $scope.list_activeButton = response.is_private;
                        $scope.addlist.is_private = response.is_private;
                        $scope.addlist.search_visibility = response.search_visibility;
                        if (response.permissions && response.permissions.groups_denied) {
                            $scope.isChecked = false;
                            $.each($scope.tasks, function(tKey, tVal) {
                                $.each(response.permissions.groups_denied, function(key, val) {
                                    if (tVal.id == val.id)
                                        $scope.tasks[tKey].checked = false;
                                });
                            });
                        }
                    });
                }, 200);
            });
            /*
             Lists.editGetItemsList($stateParams.mylistId).then(function(response) {
             console.log('!!! editGetItemsList response =', response);
             $scope.list_activeButton = response.is_private;
             console.log('!!! list_activeButton =', $scope.list_activeButton);
             //console.log('!!! $scope.list_activeButton =', $scope.list_activeButton);
             $scope.addlist.is_private = response.is_private;
             
             if (response.permissions.groups_denied) {
             $scope.isChecked = false;
             console.log('$scope.tasks =',$scope.tasks);
             }
             if (response.permissions) {
             if (response.permissions.groups_allowed)
             $.each(response.permissions.groups_allowed, function(key, val) {
             if (val.id)
             var newGroup = {
             id: val.id, title: val.title, checked: true
             };
             if (val.title)
             $scope.tasks.push(newGroup);
             });
             
             if (response.permissions.groups_denied) {
             $scope.isChecked = false;
             $.each(response.permissions.groups_denied, function(key, val) {
             if (val.id)
             var newGroup = {
             id: val.id, title: val.title, checked: false
             };
             if (val.title)
             $scope.tasks.push(newGroup);
             });
             }
             } else {
             Groups.getGroups('groups/', 'No Created Groups.').then(function(response) {
             $scope.isChecked = true;
             $.each(response.data, function(key, val) {
             var newGroup = {
             id: val.id, title: val.title, checked: true
             };
             if (val.title)
             $scope.tasks.push(newGroup);
             });
             });
             }
             });
             */
            $scope.clickStatus = function(statusId) {
                $scope.list_activeButton = statusId;
                $scope.addlist.is_private = statusId;
            };

            $scope.saveSettings = function(name) {
                if ($('.addlist_title').val().length != 0)
                    $scope.message = '';
                else if (!$scope.addlist.title)
                    return  $scope.message = 'Please enter a name for your list.';

                if (!$scope.addlist.title)
                    $scope.addlist.title = $('.addlist_title').val();

                var groupsId = [];
                $.each($scope.tasks, function(key, val) {
                    if (val.checked == true)
                        groupsId.push(val.id);
                });
                if ($scope.isChecked)
                    groupsId = 0;

                // Fix up search_visibilty
                $scope.addlist = Lists.fixListSearchVisibility($scope.addlist);
                
                $timeout(function() {
                    Lists.setListSetings($stateParams.mylistId, $scope.addlist, groupsId).then(function(response) {
                        if ($('.addlist_title').val())
                            $localstorage.set('select_mylist', $('.addlist_title').val());
                        else
                            $localstorage.set('select_mylist', $scope.addlist.title);

                        if ($stateParams.tab == '' || $stateParams.tab == 'mylists')
                            $state.go('tab.mylists-list', {"mylistId": $stateParams.mylistId, "tab": $stateParams.tab}, {reload: true});
                    });
                }, 200);
            };

            $scope.createList = function() {
                if ($('.addlist_title').val().length != 0)
                    $scope.message = '';
                else if (!$scope.addlist.title)
                    return  $scope.message = 'Please enter a name for your list.';
                var groupsId = [];
                if (!$stateParams.idchild || $stateParams.idchild == 0)
                    $.each($scope.tasks, function(key, val) {
                        if (val.checked == true)
                            groupsId.push(val.id);
                    });
                $timeout(function() {
                    var iD = 0;
                    var userType = 'parent';
                    if ($stateParams.idchild && $stateParams.idchild != 0) {
                        iD = $stateParams.idchild;
                        userType = 'child';
                    } else
                        iD = groupsId;

                    if ($scope.isChecked)
                        iD = 0;
                    Lists.createList($scope.addlist, iD, userType).then(function(response) {
                        console.log('response - ', response);
                        if (response.data) {
                            $rootScope.hideTabs = false;

                            if (userType == 'child' && $stateParams.tab == 'mylists')
                                $state.go('tab.mylists-memberlists', {"memberlistId": $stateParams.idchild, "name": 'child', "tab": 'mylists'}, {reload: true});
                            else if ($stateParams.tab == 'more')
                                $state.go('tab.mylists-list', {"mylistId": response.data.id, "tab": $stateParams.tab}, {reload: true});
                            else if (userType == 'child' && $stateParams.tab == 'shop')
                                $state.go('tab.shop-mylists-memberlists', {"memberlistId": $stateParams.idchild, "name": 'child', "tab": 'shop'}, {reload: true});
                            else if ($stateParams.tab == 'shop')
                                $state.go('tab.shop-preferences', {"tab": 'shop'}, {reload: true});
                            else
                                $state.go('tab.preferences', {"mylistId": $stateParams.mylistId, "tab": $stateParams.tab}, {reload: true});
                        }
                    });
                }, 200);
            };

            $scope.checkedAllNew = function() {
                console.log('checkedAll-', $scope.isChecked);
                if ($scope.isChecked == false) {
                    $scope.isChecked = true;
                    $.each($scope.tasks, function(key, val) {
                        val.checked = true;
                    });
                } else {
                    $scope.isChecked = false;
                    $.each($scope.tasks, function(key, val) {
                        val.checked = false;
                    });
                }
            };
            $scope.toggleItemDisplay = function(task) {
                var taskLength = $scope.tasks.length;
                var allTasks = true;
                console.log('taskLength - ', taskLength);
                if (task.checked == true) {
                    console.log(task.title);
                    console.log('$scope.tasks.length - ', $scope.tasks.length);
                    $.each($scope.tasks, function(key, val) {
                        if (val.checked == false)
                            allTasks = false;
                        if (key == (taskLength - 1) && allTasks == true)
                            $scope.isChecked = true;
                    });
                } else {
                    console.log('not checked!');
                    $scope.isChecked = false;
                }
                console.log('----$scope.isChecked  ', $scope.isChecked);
            };
            $scope.checkedAll = function(task) {
                console.log('checkedAll-', task);
                if (task == true) {
                    $.each($scope.tasks, function(key, val) {
                        val.checked = true;
                    });
                    $scope.isChecked = true;
                }
            };



        })

        //
        //Mylists Tab -> MemberListsCtrl ->updateitem
        //or
        //Mylists Tab -> MemberListsCtrl ->additem
        //
        .controller('MyListsListItemUpdateCtrl', function($scope, $timeout, $ionicHistory, $ionicModal, $ionicLoading, $state, $window, $ionicHistory, Lists, $localstorage, $stateParams, customElements) {
            console.log('MyListsListItemUpdateCtrl - - -');
            ga_send_pageview('My Lists - Add / Edit Item');
            
            $scope.header_updateitem_title = null;
            // $scope.updateitem = null;
            $scope.message = "";
            var select_item = $localstorage.get('select_item');
            if ($localstorage.get('select_item') && $stateParams.type == 'edit')
                $scope.header_updateitem_title = $localstorage.get('select_item');
            else
                $scope.header_updateitem_title = 'Add Item';
            $scope.upditem = {
                title: null,
                created: null,
                modified: null,
                price: null,
                quantity: 1,
                store: null,
                link: null,
                description: null,
                rank: null,
                image: null,
                fetch: 'show'
            };

            $scope.itemCreatedModified = '';
            
            $scope.setItemCreatedModified = function(item) {
                label = 'Added';
                itemDate = item.created;

                if (item.modified != item.created) {
                    label = 'Edited';
                    itemDate = item.modified;
                }
                $scope.itemCreatedModified = label + ' ' + customElements.humanizeDateStamp(itemDate);

            }

            $scope.isMobileWebsite = isMobileWebsite;
            // set the rate and max variables
            $scope.rate = 0;
            $scope.max = 5;
            $scope.isReadonly = false;
            $scope.setrank = 0;
            $scope.loadIMG = true;
            $scope.button = ' ';
            var change_ = false;
            var saved_url = '';
            function urlencode(str) {
                str = escape(str);
                str = str.replace('+', '%2B');
                str = str.replace('%20', '+');
                str = str.replace('*', '%2A');
                str = str.replace('/', '%2F');
                str = str.replace('@', '%40');
                return str;
            }

            $scope.isSuggestedItem = $stateParams.suggested;
            $scope.editingItem = $stateParams.type == 'edit';

            if ($localstorage.getObject('select_member').name) {
                $scope.suggestingForMember = $localstorage.getObject('select_member').name.split(' ')[0];    
            } else {
                $scope.suggestingForMember = '';    
            }

            $scope.getFilepickerAndroidPermissions = function(){
                // Android 6 requests permission in real time. Cordova plugins take care of this in most
                // cases, but since we are not using a native plugin for Filepicker, we must take care of this
                // ourselves.

                cordova.plugins.diagnostic.getPermissionsAuthorizationStatus(
                    function(result){
                        console.log(result)
                        // Are all the neede permissions granted?
                        if ( result.READ_EXTERNAL_STORAGE != 'GRANTED' ||
                             result.WRITE_EXTERNAL_STORAGE != 'GRANTED' ||
                             result.CAMERA != 'GRANTED'
                           ) {

                            // If not, request them from the user
                            cordova.plugins.diagnostic.requestRuntimePermissions(
                                function(result){ 
                                    console.log(result)
                                },
                                function(error){ 
                                    console.log(error)
                                },
                                [ cordova.plugins.diagnostic.permission.READ_EXTERNAL_STORAGE,
                                  cordova.plugins.diagnostic.permission.WRITE_EXTERNAL_STORAGE,
                                  cordova.plugins.diagnostic.permission.CAMERA
                                ]
                            )

                        }
                    }, 
                    function(error){ 
                        console.log(error)
                    },
                    [ cordova.plugins.diagnostic.permission.READ_EXTERNAL_STORAGE, 
                      cordova.plugins.diagnostic.permission.WRITE_EXTERNAL_STORAGE,
                      cordova.plugins.diagnostic.permission.CAMERA
                    ]
                )

            }

            if ( ionic.Platform.isAndroid() && typeof(cordova) != 'undefined' && parseInt(cordova.platformVersion) >= 6.0 ) {
                $scope.getFilepickerAndroidPermissions();
            }

            $scope.webLink = function(link, skimlink) {

                // mobile site and native apps open links slightly different
                if (isMobileWebsite) {
                    openMethod = '_blank';
                } else {
                    openMethod = '_system';
                }

                if (skimlink != undefined && skimlink != null && skimlink != "") {
                    ga_send_event('Item', 'Web Link Click', 'My List');
                    

                    $window.open(skimlink, openMethod, 'location=yes,enableViewportScale=yes');   
                } else {
    
                    ga_send_event('Item', 'Weblink Browser', 'Open');
                    if (!link)
                        urlWebsite = 'https://www.google.com';
                    else {
                        var pattern = /^((http|https|ftp):\/\/)/;

                        if (!pattern.test(link)) {
                            urlWebsite = urlencode(link);
                            urlWebsite = 'https://www.google.com/#q=' + urlWebsite;
                        } else {
                            urlWebsite = link;
                        }
                    }

                    // InAppBrowser only works on iOS / Android
                    if (!isMobileWebsite) {
                        var ref = cordova.ThemeableBrowser.open(urlWebsite, '_blank', {
                            statusbar: {
                                color: '#C91F27'
                            },
                            toolbar: {
                                height: 44,
                                color: '#F24B53'
                            },
                            title: {
                                color: '#FFFFFF',
                                showPageTitle: true
                            },
                            backButton: {
                                image: 'back',
                                imagePressed: 'back_pressed',
                                align: 'left',
                            },
                            forwardButton: {
                                image: 'forward',
                                imagePressed: 'forward_pressed',
                                align: 'left',
                            },
                            closeButton: {
                                image: 'close',
                                imagePressed: 'close_pressed',
                                align: 'left',
                                event: 'closePressed'
                            },
                            customButtons: [
                                {
                                    image: 'menu',
                                    imagePressed: 'menu',
                                    align: 'right',
                                    event: 'savePressed'
                                }
                            ],
                            backButtonCanClose: true
                        }).addEventListener('savePressed', function(e) {
                            saved_url = e.url;
                            $scope.upditem.link = saved_url;
                            $timeout(function() {
                                $scope.upditem.link = saved_url;
                            }, 200);
                            ga_send_event('Item', 'Weblink Browser', 'Save');
                            ref.close();
                        }).addEventListener(cordova.ThemeableBrowser.EVT_ERR, function(e) {
                            console.error(e.message);
                        }).addEventListener(cordova.ThemeableBrowser.EVT_WRN, function(e) {
                            console.log(e.message);
                        });
                    
                    // Open in browser uses native OS browser on moblie site version
                    } else {    
                        $window.open(urlWebsite, openMethod, 'location=yes,enableViewportScale=yes');      
                    }
                }
            };

            $ionicModal.fromTemplateUrl('fetch-modal.html', {
                scope: $scope,
                animation: 'slide-in-up'
            }).then(function(modal) {
                $scope.modal = modal;
            });

            $scope.$on('$destroy', function() {
                $scope.modal.remove();
            });

            $scope.fetch = function() {
                ga_send_event('Item', 'Fetch');
                $ionicLoading.hide();
                //$scope.upditem.fetch = 'hide';
                $scope.modal.show();
                if (!$scope.upditem.link)
                    $scope.upditem.link = saved_url;

                Lists.fetch($scope.upditem.link).then(function(response) {
                    $ionicLoading.hide();
                    //console.log('fetch response: ', response);
                    if (response.data.error) {
                        // $scope.message = response.data.error;
                        customElements.alert('How Fetch Works', "<style>.popup-buttons .button.button-positive { margin-left: 25%; margin-right: 25%; }</style><div><span>Error: Invalid web link or no product data found</span></div><p>&#9312; Touch red icon to search &amp; shop</p><p>&#9313; Add link you wish to Fetch</p><p>&#9314; Touch Fetch to auto fill</p>", 'ok, got it!', 'button-positive', 'fetchError');
                        //$scope.upditem.fetch = 'hide';
                        return $scope.modal.hide();
                    } else {
                        $scope.upditem.title = ($('.item_title').val()) ? $('.item_title').val() : response.data.title;
                        $scope.upditem.price = ($('.item_price').val()) ? $('.item_price').val() : response.data.price;
                        $scope.upditem.description = response.data.description;
                        $scope.upditem.store = ($('.item_store').val()) ? $('.item_store').val() : 'See website link';

                        if (!$('.item-image-content').attr('src') && !$('.pick-image-content').attr('src')) {
                            if (response.data.images) {
                                $scope.upditem.image = ($('.item-image-content').val()) ? $('.item-image-content').val() : response.data.images[0].url;
                            }
                        }
                        $scope.upditem.quantity = ($('.item_quantity').val()) ? $scope.upditem.quantity : 1;
                        change_ = true;
                        $timeout(function() {
                            $scope.modal.hide();
                        }, 1000);
                    }
                });
            };

            $("input").change(function() {
                if (!change_)
                    change_ = true;
            });

            $("textarea").change(function() {
                if (!change_)
                    change_ = true;
            });
            $(".giftster-form a.item-image-remove").on('click', function() {
                if (!change_)
                    change_ = true;
            });
            $(".giftster-form a.tab-item").on('click', function() {
                if (!change_)
                    change_ = true;
            });
            $(".giftster-form ul").on('click', function() {
                if (!change_)
                    change_ = true;
            });

            function backButton() {
                $timeout(function() {
                    console.log('myGoBack ', change_);
                    if (change_)
                        if (!change_ && $stateParams.type != 'edit')
                            customElements.popup('You got it!', 'Your item has been moved to your I Got This List', 'close', 'button-positive', '<b class="">view list</b>', 'yellow-btn').then(function(response) {
                                if (response)
                                    $ionicHistory.goBack();
                            });
                        else if ((change_ && $stateParams.type != 'edit') || (change_ && $stateParams.type == 'edit'))
                            customElements.popup('Don’t forget to save', 'Did you want to save your recent changes?', 'no thanks', '', '<b>save</b>', 'yellow-btn').then(function(response) {
                                console.log(response);
                                if (response) {
                                    if ($('.item_title').val().length != 0 && $('.item_quantity').val().length != 0) {
                                        $scope.message = '';
                                    } else {
                                        if (!$('.item_title').val())
                                            return customElements.alert('Oops', "<style>.popup-buttons .button.button-positive { margin-left: 25%; margin-right: 25%; }</style><p>Please enter a gift name.</p>", 'ok', 'button-positive');

                                        if (!$('.item_quantity').val())
                                            return customElements.alert('Oops', "<style>.popup-buttons .button.button-positive { margin-left: 25%; margin-right: 25%; }</style><p>For quantity, please enter a number.</p>", 'ok', 'button-positive');
                                    }

                                    $scope.upditem.title = $('.item_title').val();
                                    $scope.upditem.price = $('.item_price').val();
                                    $scope.upditem.quantity = $('.item_quantity').val();
                                    $scope.upditem.store = $('.item_store').val();
                                    $scope.upditem.link = $('.item_link').val();
                                    $scope.upditem.description = $('.item_description').val();

                                    $scope.upditem.image = ($('.item-image-content').attr('src')) ? $('.item-image-content').attr('src') : $('.pick-image-content').attr('src');
                                    console.log('$scope.upditem ---', $scope.upditem);
                                    Lists.addListsItem($stateParams.mylistId, $scope.setrank, $scope.upditem).then(function(response) {
                                        console.log('addListsItem response: ', response);
                                        $state.go('tab.mylists-list', {"mylistId": $stateParams.mylistId}, {reload: true, inherit: false});
                                    });
                                } else {
                                    $ionicHistory.goBack();
                                }
                            });
                        else
                            $ionicHistory.goBack();
                    else
                        $ionicHistory.goBack();
                }, 100);
            }
            $scope.myGoBack = function() {
                backButton();
            };
            $scope.removeImage = function(value) {
                $scope.loadIMG = false;
                $('.item-image-content').attr('src', '')
                $('.pick-image-content').attr('src', '')
                $scope.upditem.image = '';
            };
            $scope.quantityPlus = function(value) {
                $scope.upditem.quantity = $scope.upditem.quantity + 1;
            };
            $scope.quantityMinus = function(value) {
                if ($scope.upditem.quantity > 1)
                    $scope.upditem.quantity = $scope.upditem.quantity - 1;
            };
            $scope.setRate = function(value) {
                $scope.setrank = value;
                $scope.upditem.rank = value;
                //console.log('1 change_ = ', change_);
                // change_ = true;
                // console.log('2 change_ = ', change_);
            };
            $scope.hoveringOver = function(value) {
                $scope.overStar = value;
                $scope.percent = 100 * (value / $scope.max);
            };
            $scope.ratingStates = [
                {stateOn: 'glyphicon-ok-sign', stateOff: 'glyphicon-ok-circle'},
                {stateOn: 'glyphicon-star', stateOff: 'glyphicon-star-empty'},
                {stateOn: 'glyphicon-heart', stateOff: 'glyphicon-ban-circle'},
                {stateOn: 'glyphicon-heart'},
                {stateOff: 'glyphicon-off'}
            ];
            if ($stateParams.type == 'edit')
                Lists.getListsItems($stateParams.mylistId, $stateParams.itemId).then(function(response) {
                    console.log('!!!!!! getListsItems response - - -', response);
                    $scope.upditem.title = response.title;
                    $scope.upditem.created = response.created;
                    $scope.upditem.modified = response.modified;
                    $scope.upditem.price = response.price;
                    $scope.upditem.quantity = response.quantity;
                    $scope.upditem.store = response.store;
                    $scope.upditem.link = response.link;
                    $scope.upditem.skimlink = response.skimlink;
                    $scope.upditem.description = response.description;
                    $scope.upditem.rank = response.rank;
                    $scope.upditem.image = (response.image) ? 'https://s3-us-west-2.amazonaws.com/giftster.uploads/' + response.image : ''; //'./img/pages/test_image.png';
                    console.log('My $scope.upditem ---- ', $scope.upditem);
                    $('.fp__btn').text(' add an image');
                    $scope.setItemCreatedModified(response);
                });
            else
                $scope.button = 'hide';

            //delItem
            $scope.delItem = function() {
                Lists.delListsItem($stateParams.itemId).then(function(response) {
                    console.log('del response: ', response);
                    $state.go('tab.mylists-list', {"mylistId": $stateParams.mylistId}, {reload: true});
                });
            };
            //updItem
            $scope.updItem = function() {
                console.log('$scope.upditem =', $scope.upditem);
                console.log('$stateParams = ', $stateParams.mylistId);
                console.log('img ---', $('.item-image-content').attr('src'));
                if ($('.item_title').val().length != 0 && $('.item_quantity').val().length != 0) {

                    if ( isNaN($('.item_quantity').val()) )
                        return customElements.alert('Oops', "<style>.popup-buttons .button.button-positive { margin-left: 25%; margin-right: 25%; }</style><p>For quantity, please enter a number.</p>", 'ok', 'button-positive');

                    console.log('true value=', $scope.upditem.title);
                    $scope.message = '';

                } else {
                    if (!$scope.upditem.title)
                        return customElements.alert('Oops', "<style>.popup-buttons .button.button-positive { margin-left: 25%; margin-right: 25%; }</style><p>Please enter a gift name.</p>", 'ok', 'button-positive');

                    if (!$scope.upditem.quantity)
                        return customElements.alert('Oops', "<style>.popup-buttons .button.button-positive { margin-left: 25%; margin-right: 25%; }</style><p>For quantity, please enter a number.</p>", 'ok', 'button-positive');

                }
                $scope.upditem.title = $('.item_title').val();
                $scope.upditem.price = $('.item_price').val();
                $scope.upditem.quantity = $('.item_quantity').val();
                $scope.upditem.store = $('.item_store').val();
                $scope.upditem.link = $('.item_link').val();
                $scope.upditem.description = $('.item_description').val();
                $scope.upditem.image = ($('.item-image-content').attr('src')) ? $('.item-image-content').attr('src') : $('.pick-image-content').attr('src');
                console.log('$scope.upditem ---', $scope.upditem);
                if ($stateParams.type == 'edit') {
                    Lists.updListsItem($stateParams.mylistId, $stateParams.itemId, $scope.upditem).then(function(response) {
                        console.log('updListsItem response: ', response);
                        // If user ID present in response, this is a suggested item edit. Redirect accordingly.
                        if (response.data.user_id) {
                            // Go back to pages in most cases when editing suggested item unless editing from "my suggested items" page
                            if ($stateParams.suggested == 'mysuggesteditems') {
                                $ionicHistory.goBack(-1);    
                            } else {
                                $ionicHistory.goBack(-2);    
                            }
                            
                        } else {
                            $state.go('tab.mylists-list', {"mylistId": $stateParams.mylistId, "tab": "mylists"}, {reload: true});
                        }
                    });
                } else {

                    // Send analytics event (varies on normal item vs suggested)
                    if ($scope.isSuggestedItem) {
                        ga_send_event('Item', 'Add', 'Suggested Item')
                    } else {
                        ga_send_event('Item', 'Add');    
                    }
                    
                    Lists.addListsItem($stateParams.mylistId, $scope.setrank, $scope.upditem).then(function(response) {
                        // If user ID present in response, this is a suggested item add. Redirect accordingly.
                        if (response.data.user_id) {
                            $ionicHistory.goBack();

                        // Default redirect to this list under 'my lists' tab
                        } else {                            
                            $state.go('tab.mylists-list', {"mylistId": $stateParams.mylistId, "tab": "mylists"}, {reload: true});
                        }
                    });
                }
            };

            $scope.gotThis = function() {
                Lists.userGotList($stateParams.mylistId, $stateParams.itemId).then(function(response) {
                    console.log('userGotList response: ', response);
                    ga_send_event('Item', 'I Got This');
                    archive_list_id = response.data.archive_list_id
                    customElements.popup('You got it!', 'Your item has been moved to your I Got This List', 'close', 'button-positive', '<b class="">view list</b>', 'yellow-btn').then(function(response) {
                        if (response)
                            $state.go('tab.mylists-list', {"mylistId": archive_list_id, "tab": "mylists", type: "got"}, {reload: true, inherit: false});
                        else
                            backButton();
                    });
                });
            };

        })
        //
        //News Tab
        //
        .controller('NewsCtrl', function($scope, $state, News) {
            ga_send_pageview('Newsfeed - Home Tab');
            
            $scope.news = null;
            $scope.news_text = null;
            News.all().then(function(news) {

                if (news.length > 0) {
                    $scope.news = news;
                    $scope.news_text = 1;
                } else {
                    $scope.news_text = 0;
                }
            });
            $scope.getAddGroup = function() {
                $state.go('tab.news-add-edit', {"name": "add", "tab": "news"}, {reload: true, inherit: false});
            };
            $scope.memberSearch = function() {
                console.log('memberSearch---');
                // $state.go('tab.members-search', {}, {reload: true, inherit: false});
                $state.go('tab.news-search', {"tab": "news"}, {reload: true, inherit: false});
            };
        })

        //
        //Groups Tab
        //
        .controller('GroupsCtrl', function($scope, $state, customElements, globalImages, $localstorage, $ionicPopup, Groups, $ionicLoading) {
            ga_send_pageview('Groups - Home Tab');
            $scope.globalImages = {
                icon_plus_green: globalImages.icon_plus_green
            };
            $scope.my_groups_manage_visible = ' ';
            $scope.ionClassDeleted = 'hide';
            $scope.ionClassCreated = '';
            $scope.button_bar_visible = 'hide';
            $scope.my_groups_visible = 'hide';
            $scope.get_started_visible = 'hide';
            $scope.groupsInviting = [];
            $ionicLoading.show();
            $scope.groups = {created: null, joined: null, invited: null, requested: null};
    
            // console.log('$scope.groups---', $scope.groups);
            // console.log('$scope.groups---', $scope.groups.created);
            //console.log('.length $scope.groups.created---', $scope.groups.created.length);
            var iconRight = 'item-icon-right';
            // var login_token = $localstorage.get('login_token');
            $scope.getAddGroup = function() {
                $state.go('tab.groups-add-edit', {"name": "add", "tab": "groups"}, {reload: true, inherit: false});
            };
            $scope.manageGroup = function(group) {
                // console.log('groupId---', group);
                // console.log('groupId---', group.id);
                if (group.id) {
                    $localstorage.setObject('select_group', group);
                    $state.go('tab.groups-manage', {"groupId": group.id, "type": 'own'}, {reload: true, inherit: false});
                }
            };
            $scope.joinedGroup = function(group) {
                if (group.id) {
                    $localstorage.setObject('select_group', group);
                    $state.go('tab.groups-manage', {"groupId": group.id, "type": 'joined'}, {reload: true, inherit: false});
                }
            };
            $scope.memberSearch = function() {
                $state.go('tab.groups-search', {}, {reload: true, inherit: false});
            };
            $scope.viewGroups = function(groupName, method, groupTitle) {
                Groups.getGroups(method, groupTitle).then(function(response) {
                    $scope.groups [groupName] = {
                        'data': response.data,
                        'class': response.class
                    };
                    console.log('$scope.groups.requested---', $scope.groups.requested);
                    //console.log('$scope.groups.created---', $scope.groups.created);
                    //console.log('$scope.groups.joined---', $scope.groups.joined);
                    //console.log('$scope.groups.invited---', $scope.groups.invited);
                    //console.log('$scope.groups.requested---', $scope.groups.requested);
                    if ($scope.groups.created != null && $scope.groups.joined != null && $scope.groups.invited != null && $scope.groups.requested != null) {
                        $scope.viewAllGroups($scope.groups);
                        $scope.groupsInviting = $scope.groups.invited.data;
                        console.log('$scope.groups---', $scope.groups);
                    }
                });
            };
            $scope.viewGroups('created', 'groups/', 'No Created Groups.');
            $scope.viewGroups('joined', 'groups/joined/', 'You haven’t joined any groups');
            $scope.viewGroups('invited', 'groups/invited/', 'No group invitations');
            $scope.viewGroups('requested', 'groups/requested/', 'No Outstanding Requests.');
            $scope.onItemDelete = function(groupDel) {
                console.log('groupID ---', groupDel);
                //Are you sure you want to delete this group?
                var confirmPopup = $ionicPopup.confirm({
                    title: 'Message',
                    template: 'Are you sure you want to delete this group?'
                });
                confirmPopup.then(function(res) {
                    if (res) {
                        Groups.deleteGroup(groupDel.id).then(function(response) {
                            console.log('response - - -', response);
                            console.log('groupDel - - -', groupDel);
                            console.log('$scope.groups.created - - -', $scope.groups.created.data);
                            if (response) {
                                $scope.groups.created.data.splice($scope.groups.created.data.indexOf(groupDel), 1);
                                if ($scope.groups.created.data.length == 0) {
                                    console.log('created.data.length=', $scope.groups.created.data.length);
                                    $('.item-title-green-elem.item-groups').hide();
                                    $state.go('tab.groups', {}, {reload: true, inherit: false});
                                    // $scope.my_groups_manage_visible = 'hide';
                                    // groups.created.class[0].view_class == "hide"
                                    // $scope.viewAllGroups($scope.groups);
                                }
                            }
                            // $scope.groups.requested.data.splice($scope.groups.requested.data.indexOf(groupRequested), 1);
                        });
                    } else {
                        console.log('You are not sure');
                    }
                });
            };
            $scope.viewAllGroups = function(groups) {
                console.log('viewAllGroups - ', groups);
                if (groups.created.class[0].view_class == "hide" && groups.invited.class[0].view_class == "hide" && groups.joined.class[0].view_class == "hide" && groups.requested.class[0].view_class == "hide") {
                    $scope.get_started_visible = ' ';
                    $scope.button_bar_visible = 'hide';
                } else {
                    $scope.button_bar_visible = ' ';
                    $scope.my_groups_visible = ' ';
                }
                $ionicLoading.hide();
                $scope.groups = groups;
            };
            //joinGroup: function(groupID)
            $scope.reSend = function(groupRequested) {
                console.log(groupRequested);
                Groups.reSendInvitet(groupRequested.id, groupRequested.membership_id).then(function(response) { //Groups.joinGroup(memberID).then(function(response) {
                    console.log('Groups response----', response);
                    if (response.data.error)
                        customElements.alert('Invite status', "<style>.popup-buttons .button.button-positive { margin-left: 25%; margin-right: 25%; }</style><p>Your invite has been sent again</p>", 'ok', 'button-positive');
                    else
                        customElements.alert('Invite re-sent!', "<style>.popup-buttons .button.button-positive { margin-left: 25%; margin-right: 25%; }</style><p>Your group invitation has been sent successfully</p>", 'ok', 'button-positive');
                });
            };
            $scope.cancelRequest = function(groupRequested) {
                console.log('cancelRequest ---', groupRequested);
                //  customElements.alert('Invite removed', "<style>.popup-buttons .button.button-positive { margin-left: 25%; margin-right: 25%; }</style><p>Your request has been sent again</p>", 'ok', 'button-positive');
                $ionicPopup.show({
                    title: 'Are you sure?',
                    template: 'Are you sure you want to cancel your request?',
                    buttons: [{text: 'no, cancel'}, {
                            text: '<b>yes</b>',
                            type: 'button-positive',
                            onTap: function() {
                                console.log('groupRequested -', groupRequested);
                                Groups.deleteInvitedGroup(groupRequested.id, groupRequested.membership_id).then(function(response) {
                                    console.log('deleteInvitedGroup response----', response);
                                    if (response.data.error)
                                        customElements.alert('Request Cancelled.', "<style>.popup-buttons .button.button-positive { margin-left: 25%; margin-right: 25%; }</style><p>Your request has been cancelled successfully.</p>", 'ok', 'button-positive');
                                    else
                                        $scope.groups.requested.data.splice($scope.groups.requested.data.indexOf(groupRequested), 1);
                                });
                            }
                        }
                    ]
                });
            };
            $scope.viewDelete = function(one_news) {
                if ($scope.ionClassCreated == 'hide' && $scope.ionClassDeleted == 'show') {
                    $scope.ionClassCreated = 'show';
                    $scope.ionClassDeleted = 'hide';
                } else {
                    $scope.ionClassCreated = 'hide';
                    $scope.ionClassDeleted = 'show';
                }
            };
            $scope.acceptInvite = function(groupInvitation) {
                Groups.accept(groupInvitation.id).then(function(response) {
                    console.log('accept response = ', response);
                    if (response) {
                        customElements.alert('You\'re in!', "<style>.popup-buttons .button.button-positive { margin-left: 25%; margin-right: 25%; }</style><p>You are now a member of " + groupInvitation.title + " </p>", 'ok', 'button-positive');
                        $scope.groupsInviting.splice($scope.groupsInviting.indexOf(groupInvitation), 1);
                        $scope.viewGroups('joined', 'groups/joined/', 'You haven’t joined any groups');
                        if ($scope.groupsInviting.length == 0)
                            $scope.viewGroups('invited', 'groups/invited/', 'No group invitations');
                    }
                });
            };
            $scope.declineInvite = function(groupInvitation) {
                console.log('declineinvite id = ', groupInvitation);
                console.log('groupsInviting = ', $scope.groupsInviting.length);
                $ionicPopup.show({
                    title: 'Are you sure?',
                    template: 'Are you sure you want to decline this invitation?',
                    buttons: [{text: 'no, cancel'}, {
                            text: '<b>yes</b>',
                            type: 'button-positive',
                            onTap: function() {
                                Groups.decline(groupInvitation.id).then(function(response) {
                                    console.log('decline response = ', response);
                                    if (response) {
                                        $scope.groupsInviting.splice($scope.groupsInviting.indexOf(groupInvitation), 1);
                                        if ($scope.groupsInviting.length == 0)
                                            $scope.viewGroups('invited', 'groups/invited/', 'No group invitations');
                                    }
                                });
                            }
                        }
                    ]
                });
            };
            $scope.search = function() {
                // $state.go('tab.more-search-results', {"name": $scope.searchtext.title, "tab": 'more'}, {reload: true, inherit: false});
                $state.go('tab.groups-search', {'tab': 'groups'}, {reload: true, inherit: false});
            };
            $scope.showConfirm = function() {
                var confirmPopup = $ionicPopup.confirm({
                    title: 'Consume Ice Cream',
                    template: 'Are you sure you want to eat this ice cream?'
                });
                confirmPopup.then(function(res) {
                    if (res) {
                        console.log('You are sure');
                    } else {
                        console.log('You are not sure');
                    }
                });
            };
        })
        .controller('GroupsManageCtrl', function($scope, $stateParams, globalImages, $localstorage, $state, $ionicHistory, $ionicNavBarDelegate, $ionicPopup, $localstorage, customElements, Member, Groups) {
            ga_send_pageview('Groups - Group Detail');
            $ionicNavBarDelegate.showBackButton(true);
            $scope.globalImages = {
                icon_plus_green: globalImages.icon_plus_green
            };
            $scope.getGroup = $localstorage.getObject('select_group');
            $scope.groups = {members: null, invited: null};
            $scope.footer_tabs = $localstorage.get('footer_tabs');
            $scope.requested = [];
            $scope.groupsSettings = {
                header_top: '',
                header_class: ' ',
                subheader_class: ' ',
                header_text: ' ',
                button_bar_short: ' ',
                button_bar_visible: '',
                title_div: ' ',
                group_creater: 'hide',
                invite_title: ' ',
                invite_text: ' ',
                invite_visible: false
            };
            $scope.user = $localstorage.getObject('user')
            // console.log('!!!! groupId = ', $stateParams.groupId);
            if ($stateParams.groupId)
                Member.getMembersInvited($stateParams.groupId).then(function(response) {
                    console.log('!!!! response = ', response);
                    if (response.members)
                        $scope.groups.members = response.members;
                    if (response.invited)
                        $scope.groups.invited = response.invited;
                });
            //  "type": 'own' or 'joined'
            // console.log('!!!! type = ', $stateParams.type);
            if ($stateParams.type == 'own') {
                //  $scope.buttonBar = $scope.tabReserve == 'hide' && $scope.tabRelease == 'hide' && $scope.tabPurchase == 'hide' ? 'button-bar-short' : '';

                $scope.groupsSettings = {
                    header_top: 'hide',
                    header_class: 'Manage Group',
                    subheader_class: ' ',
                    header_text: 'invite member',
                    button_bar_short: ' ',
                    button_bar_visible: ' ',
                    title_div: ' ',
                    group_creater: 'show',
                    invite_title: 'Invited',
                    invite_text: 'Once an invited member accepts your invite & signs up or logs in they instantly become members unless you remove them or they chose to leave the group.',
                    invite_visible: true
                };
            } else {
                $scope.groupsSettings = {
                    header_top: '',
                    header_class: ($stateParams.type == 'joined') ? $scope.getGroup.title : 'Group that loves you',
                    subheader_class: 'hide', //'header_class',
                    header_text: '',
                    button_bar_short: 'button-bar-short',
                    button_bar_visible: 'hide',
                    title_div: 'hide',
                    group_creater: 'show',
                    invite_title: 'Invite More Members / Remove Members',
                    invite_text: 'To remove yourself from this group, swipe left on your name. Only the creator of this group, ' + $scope.getGroup.title + ', can invite or remove members.',
                    invite_visible: false
                };
            }
            //console.log('1 $stateParams.groupId =', $stateParams.groupId);
            $scope.inviteMember = function() {
                //console.log('click inviteMember');
                //console.log('$stateParams.type =', $stateParams.type);
                //console.log('$stateParams.groupId =', $stateParams.groupId);
                if ($stateParams.type == 'own')
                    $state.go('tab.groups-invite', {"groupId": $stateParams.groupId}, {reload: true, inherit: false});
                else
                    console.log('Group that loves you');

            };
            /* Groups.getMemberGroups($stateParams.groupId).then(function(response) {
             console.log('getGroups response - -', response);
             $scope.members = response.members;
             $scope.requested = response.requested;
             });*/
            $scope.getMemberGroups = function() {
                Groups.getMemberGroups($stateParams.groupId).then(function(response) {
                    console.log('getGroups response - -', response);
                    $scope.members = response.members;
                    $scope.requested = response.requested;
                });
            };
            $scope.getMemberGroups();

            $scope.membersGroup = function(memberID) {
                console.log('memberID -', memberID);
            };
            $scope.selectMember = function(member, index) {
                $localstorage.setObject('select_member', member);

                if (member.id == $localstorage.get('userid'))
                    $state.go('tab.preferences', {"memberlistId": member.id, "name": member.name, "tab": 'groups'}, {reload: true, inherit: false});
                else
                    $state.go('tab.groups-memberlists', {"memberlistId": member.id, "name": member.name, "tab": 'groups'}, {reload: true, inherit: false});
            };
            // Allow Group Request
            $scope.allowGroup = function(request) {
                console.log('allowGroup -', request);
                Groups.allowGroup($scope.getGroup.id, request.id).then(function(response) {
                    console.log('allowGroup response - -', response);
                    if (response.data.success)
                        customElements.alert('Request declined', "<style>.popup-buttons .button.button-positive { margin-left: 25%; margin-right: 25%; }</style><p>You’ve declined Ron’s group request </p>", 'ok', 'button-positive');
                    // customElements.alert('Success!', "<style>.popup-buttons .button.button-positive { margin-left: 25%; margin-right: 25%; }</style><p>" + requeste.name + " is now a part of your group </p>", 'ok', 'button-positive');
                    $scope.requested.splice($scope.requested.indexOf(request), 1);
                    $scope.getMemberGroups();
                });
            };
            //Deny Group Request         
            $scope.denyGroup = function(request) {
                console.log('denyGroup -', request);
                Groups.denyGroup($scope.getGroup.id, request.id).then(function(response) {
                    console.log('denyGroup response - -', response);
                    if (response.data.success) {
                        customElements.alert('Success!', "<style>.popup-buttons .button.button-positive { margin-left: 25%; margin-right: 25%; }</style><p>" + request.name + " is now a part of your group </p>", 'ok', 'button-positive');
                        //  customElements.alert('Request declined', "<style>.popup-buttons .button.button-positive { margin-left: 25%; margin-right: 25%; }</style><p>You’ve declined Ron’s group request </p>", 'ok', 'button-positive');
                        $scope.requested.splice($scope.requested.indexOf(request), 1);
                        $scope.getMemberGroups();
                    }
                });
            };
            $scope.editGroupName = function(memberID) {
                $state.go('tab.groups-add-edit', {"name": "edit", "tab": "groups"}, {reload: true, inherit: false});
            };
            $scope.reSend = function(memberID) {
                Groups.reSendInvitet($stateParams.groupId, memberID).then(function(response) {
                    console.log('Groups response----', response);
                    if (response.success)
                        customElements.alert('Invite re-sent!', "<style>.popup-buttons .button.button-positive { margin-left: 25%; margin-right: 25%; }</style><p>Your group invitation has been sent successfully</p>", 'ok', 'button-positive');
                    else
                        customElements.alert('Invite status', "<style>.popup-buttons .button.button-positive { margin-left: 25%; margin-right: 25%; }</style><p>Your invite has been sent again</p>", 'ok', 'button-positive');
                });
            };
            $scope.deleteInvited = function(groupInvited) {
                console.log('deleteInvited groupInvited -', groupInvited);
                $ionicPopup.show({
                    title: 'Are you sure?',
                    template: 'Are you sure you want to remove this invitation?',
                    buttons: [{text: 'no, cancel'}, {
                            text: '<b>yes</b>',
                            type: 'button-positive',
                            onTap: function() {
                                Groups.deleteMembership($stateParams.groupId, groupInvited.membership_id).then(function(response) {
                                    if (response)
                                        $scope.groups.invited.splice($scope.groups.invited.indexOf(groupInvited), 1);
                                });
                            }
                        }
                    ]
                });
            };

            $scope.canRemoveMember = function(member, user) {
                if ( $stateParams.type == 'own' || member.id == user.id) {
                    return true;
                }
                return false;
            }

            $scope.remove = function(member) {
                console.log('remove member -', member);
                $ionicPopup.show({
                    title: 'Are you sure?',
                    template: 'Are you sure you want to remove ' + member.name + ' from ' + $scope.getGroup.title + '?',
                    buttons: [{text: 'no, cancel'}, {
                            text: '<b>yes</b>',
                            type: 'button-positive',
                            onTap: function() {
                                Groups.deleteMembership($stateParams.groupId, member.membership_id).then(function(response) {
                                    console.log('deleteMembership =', response);
                                    if (response.error)
                                        return;
                                    if (response) {
                                        $scope.members.splice($scope.members.indexOf(member), 1);
                                        if (member.child_account_ids.length != 0)
                                            $.each(member.child_account_ids, function(key, valID) {
                                                var child_accountID = valID;
                                                console.log('child_account_ids =', valID);
                                                $.each($scope.members, function(keyM, valMember) {
                                                    console.log('valMember =', valMember);
                                                    if (valMember)
                                                        if (valMember.id == child_accountID)
                                                            $scope.members.splice($scope.members.indexOf(valMember), 1);
                                                });
                                            });

                                        // If this was a 'self delete', reload state to group tab root
                                        if (member.id == $scope.user.id) {
                                            $state.go('tab.groups', {}, {reload: true, inherit: false})
                                        }
                                    }
                                });
                            }
                        }
                    ]
                });
            };
        })
        .controller('GroupsInviteCtrl', function($scope, $stateParams, $ionicModal, $cordovaContacts, $ionicPopup, customElements, Member, Groups) {
            console.log('GroupsInviteCtrl!!');
            $scope.user = {
                lastname: '',
                email: ''
            };

            $scope.isMobileWebsite = isMobileWebsite;

            $ionicModal.fromTemplateUrl('templates/groups/groups-invite-modal.html', {
                scope: $scope,
                animation: 'slide-in-up'
            }).then(function(modal) {
                $scope.modal = modal;
            });
            $scope.closeModal = function() {
                $scope.modal.hide();
            };
            $scope.$on('$destroy', function() {
                $scope.modal.remove();
            });
            $scope.inviteModal = function() {
                $scope.modal.show();
            };
            $scope.sendInvite = function(userName, userEmails) {
                if (!userEmails)
                    return customElements.alert('Message', "<style>.popup-buttons .button.button-positive {   margin-left: 25%; margin-right: 25%; }</style><p>User does not have an email address.</p>", 'ok', 'button-positive');
                var thenameemail = userName + ' ' + userEmails[0].value;
                var formattedEmail = userName + ' &lt;' + userEmails[0].value + "&gt;";
                console.log('thenameemail - ', thenameemail);
                Groups.inviteMember($stateParams.groupId, thenameemail).then(function(response) {
                    console.log(JSON.stringify(response));
                    if (response.data.error) {
                        return customElements.alert('Message', "<style>.popup-buttons .button.button-positive {   margin-left: 25%; margin-right: 25%; }</style><p>We could not send your invite. Please try again.</p>", 'ok', 'button-positive');
                    }
                    else {
                        ga_send_event('Group', 'Invite - Add');
                        customElements.alert('Message', "<style>.popup-buttons .button.button-positive {   margin-left: 25%; margin-right: 25%; }</style><p>Your invite to '" + formattedEmail + "' has been sent.</p>", 'ok', 'button-positive');
                    }

                    $scope.user.lastname = '';
                    $scope.user.email = '';
                    $('.input_lastname').val('');
                    $('.input_email').val('');
                });
            };
            $scope.invite = function() {
                if ($scope.user.lastname == '')
                    customElements.alert('Message', "<style>.popup-buttons .button.button-positive {   margin-left: 25%; margin-right: 25%; }</style><p>Please enter a name.</p>", 'ok', 'button-positive');
                else if ($scope.user.email == '')
                    customElements.alert('Message', "<style>.popup-buttons .button.button-positive {   margin-left: 25%; margin-right: 25%; }</style><p>Please enter an email address.</p>", 'ok', 'button-positive');
                else if ($scope.user.lastname != ' ' && $scope.user.email != ' ') {
                    var thenameemail = $scope.user.lastname + ' ' + $scope.user.email;
                    var formattedEmail = $scope.user.lastname + ' &lt;' + $scope.user.email + "&gt;";
                    Groups.inviteMember($stateParams.groupId, thenameemail).then(function(response) {
                        console.log(JSON.stringify(response));
                        if (response.data.error)
                            return customElements.alert('Message', "<style>.popup-buttons .button.button-positive {   margin-left: 25%; margin-right: 25%; }</style><p>We could not send your invite. Please try again.</p>", 'ok', 'button-positive');
                        else
                            customElements.alert('Message', "<style>.popup-buttons .button.button-positive {   margin-left: 25%; margin-right: 25%; }</style><p>Your invite to '" + formattedEmail + "' has been sent.</p>", 'ok', 'button-positive');

                        $scope.user.lastname = '';
                        $scope.user.email = '';
                        $('.input_lastname').val('');
                        $('.input_email').val('');
                    });
                }

            };

             $scope.pickContactUsingNativeUI = function() {
                
                $cordovaContacts.pickContact().then(function (contact) {
                    $scope.sendInvite(contact.name.formatted, contact.emails)
                });
            }
        })
        .controller('GroupsAddEditCtrl', function($scope, $localstorage, $stateParams, globalImages, Groups, $state, $ionicHistory) {
            console.log('GroupsAddEditCtrl!!');
            console.log('$stateParams---', $stateParams);
            ga_send_pageview('Groups - Add / Edit Group');
            
            $scope.globalImages = {
                icon_add_edit: ($stateParams.name == "add") ? globalImages.icon_plus_green : globalImages.icon_save
            };
            $('.bar .back-button').removeClass('hide');
            // $scope.footer_tabs = $localstorage.get('footer_tabs');
            $scope.footer_tabs = 'show';
            console.log('$scope.footer_tabs -', $scope.footer_tabs);
            $scope.addeditgroup = {
                viewtitle: " ",
                title: " ",
                description: " ",
                namebutton: ' ',
                classbutton: 'btn-edit-item',
                classbtn: 'ion-btn-edit',
                name: null,
                id: null
            };
            $scope.message = "";
            if ($stateParams.name == "add")
                $scope.addeditgroup = {
                    viewtitle: "New Group",
                    title: "Name this group*",
                    description: "Your members see this group name\n(Example: “Smith family wish lists“)",
                    namebutton: 'create group',
                    classbutton: 'btn-add-item',
                    classbtn: 'ion-btn-add',
                    name: null
                };
            else {
                var getGroup = $localstorage.getObject('select_group');
                console.log('getGroup -', getGroup);
                $scope.addeditgroup = {
                    viewtitle: "Edit Group",
                    title: "Group name*",
                    description: "Your members see this group name\n(Example: “Smith family wish lists“)",
                    namebutton: 'save',
                    classbutton: 'btn-edit-item',
                    classbtn: 'ion-btn-edit',
                    name: getGroup.title,
                    id: getGroup.id
                };
            }

            $scope.addEditGroup = function() {
                if ($('.addlist_title').val().length != 0)
                    $scope.message = '';
                else if (!$scope.addeditgroup.name)
                    return  $scope.message = 'Please enter a name for your group.';
                console.log(' - - $scope.addeditgroup - - -', $scope.addeditgroup);
                if ($stateParams.name == "add")
                    Groups.createGroup($scope.addeditgroup).then(function(response) {
                        console.log(' - - response - - -', response);
                        if (response) {
                            if (response.data.id) {
                                ga_send_event('Group', 'Add');
                                $state.go('tab.groups', {}, {reload: true, inherit: false});
                            }
                            else {
                                $scope.message = 'We could not add your group. Please try again.';
                            }
                            //  $rootScope.hideTabs = false;
                            //  $state.go('tab.preferences', {"mylistId": $stateParams.mylistId}, {reload: true});
                        }
                    });
                else
                    Groups.editGroup($scope.addeditgroup.id, $scope.addeditgroup.name).then(function(response) {
                        if (response.data.error)
                            return;
                        getGroup.title = $scope.addeditgroup.name; //set group's name
                        $localstorage.setObject('select_group', getGroup);
                        $state.go('tab.groups-manage', {"groupId": getGroup.id, "type": 'own'}, {reload: true, inherit: false});
                    });
            };
        })

        //
        //Search Tab
        //
        .controller('SearchCtrl', function($scope, $state, $ionicHistory, customElements, $rootScope, $localstorage, globalImages, $stateParams, userSettings) {
            $scope.userSettings = userSettings.setParams('hide', 'hide', '', '', 'footer_without_tabs', '', 'hide');
            $scope.footer_tabs = $localstorage.get('footer_tabs');
            $scope.globalImages = {
                icon_btn_search: globalImages.icon_btn_search
            };
            var login_token = $localstorage.get('login_token');
            $scope.footer_without_tabs = '';
            $scope.searchtext = {title: null};
            $scope.searchlist = null;
            console.log('login_token - ', login_token);

            $scope.goBack = function() {
                $ionicHistory.goBack();
            };


            if (login_token) {
                $scope.footer_tabs = 'show';
                $scope.userSettings = userSettings.setParams('hide', 'show', 'hide', 'hide', '', 'hide', '');
                $('.bar .back-button').removeClass('hide');
                ga_send_pageview('Member Search');
                
            } else {
                ga_send_pageview('Search Page Logged Out');
                
                $scope.footer_tabs = 'hide';
                $scope.footer_without_tabs = 'footer_without_tabs';
                $rootScope.$ionicGoBack = function() {
                    console.log('$ionicGoBack - ');
                    $('.bar .back-button').addClass('hide');
                    $state.go('index');
                };
            }

            var tabName = '';
            tabName = $stateParams.tab;
            console.log('tabName - - - -', tabName);
            $scope.search = function() {
                console.log('$scope.searchtext.title - - - ', $scope.searchtext.title);
                console.log('tabName - - - -', tabName);

                if (!$scope.searchtext.title) {
                    return customElements.alert('Whoops!', "<style>.popup-buttons .button.button-positive {   margin-left: 25%; margin-right: 25%; }</style><p>Please enter a name or email address</p>", 'ok', 'button-positive');
                    /*return $ionicPopup.alert({
                     template: "<style>.popup-buttons .button.button-positive {   margin-left: 25%; margin-right: 25%; }</style><p>Please enter a name or email address</p>",
                     title: 'Whoops!',
                     buttons: [{
                     text: 'ok',
                     type: 'button-positive'
                     }]
                     });*/
                }

                if (tabName == 'more')
                    $state.go('tab.more-search-results', {"name": $scope.searchtext.title, "tab": 'more'}, {reload: true, inherit: false});
                else if (tabName == 'groups')
                    $state.go('tab.groups-search-results', {"name": $scope.searchtext.title, "tab": 'groups'}, {reload: true, inherit: false});
                else if (tabName == 'news')
                    $state.go('tab.news-search-results', {"name": $scope.searchtext.title, "tab": 'news'}, {reload: true, inherit: false});
                else if (tabName == 'shop')
                    $state.go('tab.shop-search-results', {"name": $scope.searchtext.title, "tab": 'shop'}, {reload: true, inherit: false});
                else
                    $state.go('search-results', {"name": $scope.searchtext.title, "tab": 'search'}, {reload: true, inherit: false});
                //search-results
                //  $state.go('tab2.search-results', {"name": $scope.searchtext.title, "tab": 'tab2'}, {reload: true, inherit: false});
                return;
                //tab.more-search
                if ($localstorage.get('login_token'))
                    $state.go('search-results', {"name": $scope.searchtext.title}, {reload: true, inherit: false});
                else
                    $state.go('tab2.search-results', {"name": $scope.searchtext.title, "tab": 'tab2'}, {reload: true, inherit: false});
            };
        })
        .controller('SearchResultsCtrl', function($scope, $state, $localstorage, $ionicLoading, Search, userSettings, $stateParams, $ionicPopup) {
            console.log('- - -SearchResultsCtrl - - ');
            $scope.userSettings = userSettings.setParams('hide', 'hide', '', '', 'footer_without_tabs', '', 'hide');
            $scope.footer_tabs = $localstorage.get('footer_tabs');
            var login_token = $localstorage.get('login_token');
            console.log('login_token - ', login_token);
            if (login_token) {
                $scope.footer_tabs = 'show';
                $scope.userSettings = userSettings.setParams('hide', 'show', 'hide', 'hide', '', 'hide', '');
            } else {
                $scope.footer_tabs = 'hide';
                $scope.footer_without_tabs = 'footer_without_tabs';
            }
            $scope.settingsDiv = {list: 'hide', error: 'hide'};
            var name_ = $stateParams.name;
            console.log('name_ =', name_);
            Search.memberSearch(name_).then(function(response) {
                console.log(' - - response - - -', response);
                if (!response || !response.length) {
                    $scope.settingsDiv.error = 'show';
                } else {
                    $scope.searchlist = response;
                    $scope.settingsDiv.list = 'show';
                }
                //customElements.alert('Bummer…', "<style>.popup-buttons .button.button-positive {   margin-left: 25%; margin-right: 25%; }</style><p>We couldn’t find that member. Try again?</p>", 'ok', 'button-positive');
                /*  $ionicPopup.alert({
                 template: "<style>.popup-buttons .button.button-positive {   margin-left: 25%; margin-right: 25%; }</style><p>We couldn’t find that member. Try again?</p>",
                 title: 'Bummer…',
                 //subTitle: 'We couldn’t find that member. Try again?',
                 buttons: [{
                 text: 'ok',
                 type: 'button-positive'
                 }]
                 });*/
            }).finally(function() {
                if (!$scope.searchlist) {
                    $ionicLoading.hide();
                    $scope.settingsDiv.error = 'show';
                }
            });
            $scope.selectItems = function(memberId, nameMemder) {
                console.log(' - - memberId - - -', memberId);
                console.log(' - - nameMemder - -', nameMemder);
                $localstorage.set('search_member', nameMemder);
                if ($stateParams.tab == 'more')
                    $state.go('tab.more-search-result-member', {"memberId": memberId, "tab": 'more'}, {reload: true, inherit: false});
                else if ($stateParams.tab == 'shop')
                    $state.go('tab.shop-search-result-member', {"memberId": memberId, "tab": 'shop'}, {reload: true, inherit: false});
                else if ($stateParams.tab == 'groups')
                    $state.go('tab.groups-search-result-member', {"memberId": memberId, "tab": 'groups'}, {reload: true, inherit: false});
                else if ($stateParams.tab == 'news')
                    $state.go('tab.news-search-result-member', {"memberId": memberId, "tab": 'news'}, {reload: true, inherit: false});
                else if ($stateParams.tab == 'tab2')
                    $state.go('tab2.search-result-member', {"memberId": memberId, "tab": 'tab2'}, {reload: true, inherit: false});
                else
                    $state.go('search-result-member', {"memberId": memberId, "tab": ''}, {reload: true, inherit: false});
            };
        })
        .controller('SearchResultMemberCtrl', function($scope, $state, globalImages, customElements, $localstorage, Search, userSettings, $stateParams, $ionicPopup, Groups) {
            console.log('SearchResultMemberCtrl!!');
            $scope.globalImages = {
                icon_join: globalImages.icon_arrow
            };
            $scope.userSettings = userSettings.setParams('hide', 'hide', '', '', 'footer_without_tabs', '', 'hide');
            $scope.footer_tabs = $localstorage.get('footer_tabs');
            $scope.listsInfo = '';
            $scope.groupsInfo = '';
            $scope.memberRes = [];
            $scope.preferences = [];
            $scope.memberId = $stateParams.memberId;
            if ($localstorage.get('login_token')) {
                $scope.footer_tabs = 'show';
                $scope.userSettings = userSettings.setParams('hide', 'show', 'hide', 'hide', '', 'hide', '');
            } else {
                $scope.footer_tabs = 'hide';
                $scope.footer_without_tabs = 'footer_without_tabs';
            }
            var memberID_ = $scope.memberId;
            console.log('memberID_ =', memberID_);
            var member = Search.getMemberResult(memberID_);
            console.log('member =', member);
            if (!member)
                return;

            // Sometimes users are missing gift preference object
            if (member.preferences.length > 0 ) {
                $scope.preferences = member.preferences;
                $scope.canViewPrefs =member.preferences[0].preferences;
            } else {
                $scope.preferences = null;
                $scope.canViewPrefs = false;
            }

            $scope.canViewPrefs = member.data.preferences;
            $scope.userData = member.data;

            $scope.memberRes = member.data;
            //console.log('memberRes- - ', $scope.memberRes);
            $scope.groupsInfo = member.settings.groups_info;
            $scope.listsInfo = member.settings.lists_info;
            $scope.selectPreferences = function(memberRes) {
                console.log('!!! - - selectPreferences $scope.memberRes.id - - -', memberRes);
                $localstorage.setObject('select_member', memberRes);
                if ($stateParams.tab == 'more')
                    $state.go('tab.more-search-preferences', {"memberId": memberRes.id, "tab": 'more'}, {reload: true, inherit: false});
                else if ($stateParams.tab == 'shop')
                    $state.go('tab.shop-search-preferences', {"memberId": memberRes.id, "tab": 'shop'}, {reload: true, inherit: false});
                else if ($stateParams.tab == 'news')
                    $state.go('tab.news-search-preferences', {"memberId": memberRes.id, "tab": 'news'}, {reload: true, inherit: false});
                else if ($stateParams.tab == 'groups')
                    $state.go('tab.groups-search-preferences', {"memberId": memberRes.id, "tab": 'groups'}, {reload: true, inherit: false});
                else if ($stateParams.tab == 'tab2' || $stateParams.tab == 'search')
                    $state.go('tab2.search-preferences', {"memberId": memberRes.id, "tab": $stateParams.tab}, {reload: true, inherit: false});
                else
                    $state.go('search-preferences', {"memberId": memberRes.id, "tab": '0'}, {reload: true, inherit: false});
            };
            $scope.selectList = function(listId) {
                console.log(' - - list - - -', listId);
                console.log(' - - memberID_ - - -', memberID_);
                $localstorage.setObject('select_wishlist', listId);
                $localstorage.setObject('select_member', $scope.preferences[0]);
                if ($stateParams.tab == 'more')
                    $state.go('tab.more-search-mylists-list', {"memberlistId": memberID_, "listId": listId.id, "tab": 'more', "type": 'search'}, {reload: true, inherit: false});
                else if ($stateParams.tab == 'shop')
                    $state.go('tab.shop-search-mylists-list', {"mylistId": listId.id, "tab": 'shop', "type": 'search'}, {reload: true, inherit: false});
                else if ($stateParams.tab == 'news')
                    $state.go('tab.news-search-mylists-list', {"memberId": listId.id, "tab": 'news', "type": 'search'}, {reload: true, inherit: false});
                else if ($stateParams.tab == 'groups')
                    $state.go('tab.groups-memberlists-list', {"memberlistId": memberID_, "listId": listId.id, "tab": 'groups', "type": 'search'}, {reload: true, inherit: false});
                else if ($stateParams.tab == 'tab2')
                    $state.go('tab2.search-mylists-list', {"mylistId": listId.id, "tab": 'tab2', "type": 'search'}, {reload: true, inherit: false});
                else
                    $state.go('search-memberlists-list', {"memberlistId": memberID_, "listId": listId.id, "tab": 'search', "type": 'search'}, {reload: true, inherit: false});

            };
            $scope.joinGroup = function(grouprId) {
                // console.log(' - - grouprId - - -', grouprId);
                if ($localstorage.get('login_token'))
                    Groups.joinGroup(grouprId).then(function(response) {
                        console.log('Groups response----', response);
                        if (response.data.error) {
                            customElements.alert('Membership status', "<style>.popup-buttons .button.button-positive {   margin-left: 25%; margin-right: 25%; }</style><p>You already have a request, invite or membership in this group</p>", 'ok', 'button-positive');
                        }
                        else {
                            ga_send_event('Group', 'Request');
                            customElements.alert('Success!', "<style>.popup-buttons .button.button-positive {   margin-left: 25%; margin-right: 25%; }</style><p>Your group membership request has been sent. Fingers crossed!</p>", 'ok', 'button-positive');
                        }
                    });
                else {
                    customElements.popup('To complete request', 'Sign up or login, repeat this search, and send your request', 'sign up', 'button-positive', '<b>login</b>', 'yellow-btn').then(function(response) {
                        console.log('response ---', response);
                        if (response) {
                            if ($stateParams.tab == 'tab2')
                                $state.go('tab2.login', {}, {reload: true, inherit: true});
                            else
                                $state.go('login-tabs', {}, {reload: true, inherit: true});
                        } else {
                            $state.go('signup', {}, {reload: true, inherit: true});
                        }
                    });
                }
            };
        })

        //
        //Search ->SearchResultCtrl -> SearchPreferencesCtrl
        //
        .controller('SearchPreferencesCtrl', function($scope, $stateParams, $ionicModal, AuthService, customElements, userSettings, $localstorage, Lists) {
            console.log('--- SearchPreferencesCtrl ---');
            $scope.userSettings = userSettings.setParams('hide', 'hide', '', '', 'footer_without_tabs', '', 'hide');
            $scope.footer_tabs = $localstorage.get('footer_tabs');
            $scope.list_activeButton = null;
            $scope.send_visible = 'hide';
            $scope.last_updated_visible = 'hide';
            $scope.preferences_class_size = 'hide';
            $scope.preferences_class_interests = 'hide';
            $scope.preferences_class_address = 'hide';
            $scope.pointer_class_size = 'ion-chevron-down';
            $scope.pointer_class_interests = 'ion-chevron-down';
            $scope.pointer_class_address = 'ion-chevron-down';
            $scope.gift_preferences = null;
            $scope.last_updated = '';
            $scope.userName = '';
            var selectMember = $localstorage.getObject('select_member');
            console.log('selectMember  =', selectMember);
            $scope.userName = selectMember.name;
            console.log('$scope.userName  =', $scope.userName);
            $scope.formData = {};
            $scope.interestsData = {};
            if ($localstorage.get('login_token')) {
                $scope.send_visible = 'show';
                $scope.footer_tabs = 'show';
                $scope.userSettings = userSettings.setParams('hide', 'show', 'hide', 'hide', '', 'hide', '');
            } else {
                $scope.footer_tabs = 'hide';
                $scope.footer_without_tabs = 'footer_without_tabs';
            }
            Lists.getListStatus($stateParams.memberId).then(function(response) {
                console.log('getListStatus response=', response);
                if (response.error)
                    return $scope.last_updated_visible = 'hide';
                else
                    $scope.last_updated_visible = 'show';

                $scope.last_updated = customElements.dateDiffFormat(response.modified);
            });
            console.log('$stateParams.memberId----', $stateParams.memberId);
            Lists.giftPreferences($stateParams.memberId, false).then(function(response) {
                console.log('$scope.giftPreferencesMemberID----', response);
                if (response.gift_preferences)
                    $scope.formData.gift_preferences = response.gift_preferences;

                if (response.extra_sizes && response.extra_sizes.length != 0)
                    $.each(response.extra_sizes, function(key, val) {
                        $scope.interestsData['extrasize_name' + key] = val.name;
                        $scope.interestsData['extrasize_size' + key] = val.size;
                    });

                if (response.empty == false)
                    $scope.send_visible = 'hide';
                //console.log('response.gift_preferences----', response.gift_preferences);
                //console.log('response.gift_preferences.length----', response.gift_preferences.length);

                if (response.gift_preferences.shoe_size || response.gift_preferences.casual_shirt_size || response.gift_preferences.dress_shirt_size || response.gift_preferences.pants_size || response.gift_preferences.jacket_size || response.gift_preferences.dress_size || response.gift_preferences.hat_size)
                    $scope.showHide('1');
                if ($scope.interestsData.extrasize_name0 || $scope.interestsData.extrasize_size0 || $scope.interestsData.extrasize_name1 || $scope.interestsData.extrasize_size1 || response.gift_preferences.hobbies || response.gift_preferences.other || response.gift_preferences.favorites)
                    $scope.showHide('2');
                if (response.gift_preferences.full_name || response.gift_preferences.street1 || response.gift_preferences.street2 || response.gift_preferences.city || response.gift_preferences.state || response.gift_preferences.postal_code || response.gift_preferences.country || response.gift_preferences.phone_number)
                    $scope.showHide('3');
            });

            $ionicModal.fromTemplateUrl('templates/shop/send-update-reminder-modal.html', {
                scope: $scope,
                animation: 'slide-in-up'
            }).then(function(modal) {
                $scope.modal = modal;
            });
            $scope.closeModal = function() {
                $scope.modal.hide();
            };
            $scope.$on('$destroy', function() {
                $scope.modal.remove();
            });
            $scope.sendUpdateReminder = function() {
                console.log(' - - sendUpdateReminder- - -');
                $scope.modal.show();
            };
            $scope.incident = {name: '', comment: ''};

            $scope.send = function() {
                console.log(' - - send!!!- - -');
                if ($scope.incident.name == '')
                    $scope.incident.name = 'Anonymous';
                AuthService.sendReminder(selectMember.id, $scope.incident.comment, $scope.incident.name).then(function(response) {
                    if (response.data.success)
                        customElements.alert('Success!', "<style>.popup-buttons .button.button-positive {   margin-left: 25%; margin-right: 25%; }</style><p>Message sent from giftster.</p>", 'ok', 'button-positive');
                    else
                        customElements.alert('ERROR', "<style>.popup-buttons .button.button-positive {   margin-left: 25%; margin-right: 25%; }</style><p>ERROR!</p>", 'ok', 'button-positive');
                    $scope.modal.remove();
                });
            };
            $scope.showHide = function(index) {
                if (index == '1') {
                    $scope.preferences_class_size = ($scope.preferences_class_size == 'hide') ? ' ' : 'hide';
                    $scope.pointer_class_size = ($scope.pointer_class_size == 'ion-chevron-down') ? 'ion-chevron-up' : 'ion-chevron-down';
                }
                if (index == '2') {
                    $scope.preferences_class_interests = ($scope.preferences_class_interests == 'hide') ? ' ' : 'hide';
                    $scope.pointer_class_interests = ($scope.pointer_class_interests == 'ion-chevron-down') ? 'ion-chevron-up' : 'ion-chevron-down';
                }
                if (index == '3') {
                    $scope.preferences_class_address = ($scope.preferences_class_address == 'hide') ? ' ' : 'hide';
                    $scope.pointer_class_address = ($scope.pointer_class_address == 'ion-chevron-down') ? 'ion-chevron-up' : 'ion-chevron-down';
                }
            }
            ;
        }
        )

        .controller('SearchSendRemindertCtrl', function($scope, $stateParams, $localstorage, customElements, userSettings, AuthService) {
            console.log('SearchSendRemindertCtrl!!');
            $scope.userSettings = userSettings.setParams('hide', 'hide', '', '', 'footer_without_tabs', '', 'hide');
            $scope.footer_tabs = $localstorage.get('footer_tabs');

            $scope.incident = {name: '', comment: ''};
            $scope.search_member = '';
            $scope.search_member = $localstorage.get('search_member');
            $scope.sendReminder = function() {
                if ($scope.incident.name == '')
                    $scope.incident.name = 'Anonymous';
                AuthService.sendReminder($stateParams.mylistId, $scope.incident.comment, $scope.incident.name).then(function(response) {
                    if (response.data.success)
                        customElements.alert('Success!', "<style>.popup-buttons .button.button-positive {   margin-left: 25%; margin-right: 25%; }</style><p>Message sent from giftster.</p>", 'ok', 'button-positive');
                    else
                        customElements.alert('ERROR', "<style>.popup-buttons .button.button-positive {   margin-left: 25%; margin-right: 25%; }</style><p>ERROR!</p>", 'ok', 'button-positive');
                });
            };
        })

        /****************** THE SCROLL HEADER ******************/

        .directive('headerShrink', function($document) {
            var fadeAmt;
            var shrink = function(header, content, amt, max) {
                amt = Math.min(max, amt);
                fadeAmt = 1 - amt / max;
                ionic.requestAnimationFrame(function() {
                    header.style[ionic.CSS.TRANSFORM] = 'translate3d(0, -' + amt + 'px, 0)';
                    for (var i = 0, j = header.children.length; i < j; i++) {
                        header.children[i].style.opacity = fadeAmt;
                    }
                });
            };
            return {
                restrict: 'A',
                link: function($scope, $element, $attr) {
                    // if($scope.get_started_visible != 'hide')
                    //  return;
                    var y = 0;
                    var prevY = 0;
                    var scrollDelay = 0.4;
                    var fadeAmt;
                    var header = $document[0].body.querySelector('.bar-subheader');
                    var header2 = document.body.querySelectorAll('.bar-subheader');
                    if (header2.length > 1) {
                        var num = header2.length - 1;
                        header = header2[num];
                    }

                    var headerHeight = header.offsetHeight;
                    function onScroll(e) {
                        var headerShort = $document[0].body.querySelector('.button-bar-short');
                        if (headerShort)
                            return;
                        var scrollTop = e.originalEvent.detail.scrollTop;
                        //console.log('!!! scrollTop---', scrollTop);
                        if (scrollTop >= 0 && scrollTop <= 40) {
                            y = Math.min(headerHeight / scrollDelay, Math.max(0, y + scrollTop - prevY));
                        } else if (scrollTop >= 40) {
                            y = 40;
                        } else {
                            y = 0;
                        }
                        ionic.requestAnimationFrame(function() {
                            fadeAmt = 1 - (y / headerHeight);
                            header.style[ionic.CSS.TRANSFORM] = 'translate3d(0, ' + -y + 'px, 0)';
                            for (var i = 0, j = header.children.length; i < j; i++) {
                                // header.children[i].style.opacity = fadeAmt;
                            }
                        });
                        prevY = scrollTop;
                    }
                    $element.bind('scroll', onScroll);
                }
            };
        })
        /**************************** / END THE SCROLL HEADER ********************************/


        .controller('FriendsCtrl', function($scope, Friends) {
            $scope.friends = Friends.all();
        })

        .controller('FriendDetailCtrl', function($scope, $stateParams, Friends) {
            $scope.friend = Friends.get($stateParams.friendId);
        })

        .controller('MoreCtrl', function($scope, $state, $ionicHistory, globalImages, Mores, $localstorage, AuthService) {
            ga_send_pageview('More - Home Tab');
            
            $scope.globalImages = {
                icon_help: globalImages.icon_help,
                icon_settings: globalImages.icon_settings
            };
            $scope.mores = Mores.all();

            $('.bar .back-button').addClass('hide');

            $scope.about = function() {
                $state.go('tab.more-about', {}, {reload: true, inherit: false});
            };
            $scope.settings = function() {
                $state.go('tab.more-settings', {}, {reload: true, inherit: false});
            };
            $scope.quickStart = function() {
                $state.go('tab.more-quickstart', {"tab": 'more'}, {reload: true, inherit: false});
            };
            $scope.shoppingList = function() {
                $state.go('tab.more-shoppinglist', {'tab': 'more'}, {reload: true, inherit: false});
            };
            $scope.events = function() {
                $state.go('tab.more-events', {}, {reload: true, inherit: false});
            };
            $scope.blog = function() {
                $state.go('tab.more-blog', {}, {reload: true, inherit: false});
            };
            $scope.about = function() {
                $state.go('tab.more-about', {}, {reload: true, inherit: false});
            };
            $scope.search = function() {
                $state.go('tab.more-search', {"tab": 'more'}, {reload: true, inherit: false});
            };
            $scope.logout = function() {
                if ($localstorage.getObject('user'))
                    $localstorage.setObject('user', []);
                AuthService.logout();
            };

        })
        .controller('QuickStartCtrl', function($scope, $state, $stateParams) {
            console.log('$stateParams - ', $stateParams);
            ga_send_pageview('More - Quick Start');
            

            $('.bar .back-button').removeClass('hide');
            $scope.getAddGroup = function(value) {
                $state.go('tab.more-groups-add-edit', {"name": "add", "tab": $stateParams.tab}, {reload: true, inherit: false});
                //  $state.go('tab.more-groups-add-edit', {"name": "add", "tab": "shop"}, {reload: true, inherit: false});
            };
            $scope.memberSearch = function(value) {
                $state.go('tab.more-search', {"tab": 'more'}, {reload: true, inherit: false});
            };
            $scope.getAddLists = function(value) {
                $state.go('tab.more-mylists-add', {"tab": 'more'}, {reload: true, inherit: false});
            };
        })
        .controller('MoreMySettingsCtrl', function($scope, globalImages, Mores, AuthService, $ionicPopup, customElements, $localstorage, $filter) {
            ga_send_pageview('More - Settings');
            
            $('.bar .back-button').removeClass('hide');
            $scope.globalImages = {
                icon_save: globalImages.icon_save
            };
            $scope.user = [];
            $scope.userData = [];
            $scope.birthday = [];

            $scope.changeMonth = function(val) {
                $scope.birthday.birthday_month = val;
            };

            $scope.changeDay = function(val) {
                $scope.birthday.birthday_day = val;
            };

            $scope.changeYear = function(val) {
                $scope.birthday.birthday_year = val;
            };

            Mores.getUserSettings().then(function(response) {
                console.log('Groups response----', response);
                if (response.error)
                    return customElements.alert('Error', "<style>.popup-buttons .button.button-positive {   margin-left: 25%; margin-right: 25%; }</style><p>" + response.error + "</p>", 'ok', 'button-positive');
                $scope.user = response;
                $scope.birthday.birthday_month = response.userprofile.birthday_month;
                $scope.birthday.birthday_day = response.userprofile.birthday_day;
                $scope.birthday.birthday_year = (!response.userprofile.birthday_year) ? 0 : response.userprofile.birthday_year;

                // $scope.birthday.birthday_month = response.userprofile.birthday_month;
                // $scope.birthday.birthday_day = response.userprofile.birthday_day;
                // $scope.birthday.birthday_year = response.userprofile.birthday_year;
            });
            /* $scope.changeDate = function() {
             $scope.birthday.birthday_month = $filter("date")($scope.userData.birthday_date, 'MM');
             $scope.birthday.birthday_day = $filter("date")($scope.userData.birthday_date, 'dd');
             $scope.birthday.birthday_year = $filter("date")($scope.userData.birthday_date, 'yyyy');
             };*/
            $scope.save = function() {
                //Update User Settings
                Mores.updateUserSettings($scope.user, $scope.birthday).then(function(response) {
                    console.log('updateUserSettings response----', response);
                    if (!response.data) {
                        return customElements.alert('Error', "<style>.popup-buttons .button.button-positive {   margin-left: 25%; margin-right: 25%; }</style><p>" + response.error + "</p>", 'ok', 'button-positive');
                    } else if (response.data.success == false) {
                        return customElements.alert('Error', "<style>.popup-buttons .button.button-positive {   margin-left: 25%; margin-right: 25%; }</style><p>Please ensure all fields are filled completely.</p>", 'ok', 'button-positive');
                    } else {
                        $localstorage.setObject('user', response.data);
                        $localstorage.set('login_token', response.data.token);
                        customElements.alert('Success!', "<style>.popup-buttons .button.button-positive {   margin-left: 25%; margin-right: 25%; }</style><p>Your account changes have been saved.</p>", 'ok', 'button-positive');
                    }
                    //$state.go('tab.more', {}, {reload: true, inherit: false});
                });
            };
            $scope.closeAccount = function() {
                Mores.closeUserAccount().then(function(response) {
                    var alertPopup = $ionicPopup.alert({
                        title: 'Success!',
                        template: "<style>.popup-buttons .button.button-positive {   margin-left: 25%; margin-right: 25%; }</style><p>" + response.data.success + "</p>",
                        buttons: [{
                                text: 'ok',
                                type: 'button-positive'
                            }]
                    });
                    alertPopup.then(function() {
                        AuthService.logout();
                    });
                });
            };
        })
        .controller('AboutCtrl', function($scope, $window, $ionicLoading) {
            ga_send_pageview('More - About Giftster');
            
            if (isMobileWebsite) {
                $scope.platform = 'mobilesite';
            } else if (ionic.Platform.isIOS()) {
                $scope.platform = 'ios';                
            } else {
                $scope.platform = 'android';
            }


            $('.bar .back-button').removeClass('hide');
            console.log('AboutCtrl!!');
            var urliTunes = 'https://itunes.apple.com/us/app/giftster-wish-list-registry/id478126039';
            var urlGooglePlay = 'https://play.google.com/store/apps/details?id=com.Giftster.Giftster';
            $scope.goToiTunes = function(url) {
                $window.open(urliTunes, '_system', 'location=yes,enableViewportScale=yes');
            };
            $scope.goToGooglePlay = function(url) {
                console.log(' - - goToiGooglePlay - - ');
                $window.open(urlGooglePlay, '_system', 'location=yes,enableViewportScale=yes');
            };



        })
        .controller('EventsCtrl', function($scope, AllEvents) {
            ga_send_pageview('More - Events');
            
            $('.bar .back-button').removeClass('hide');
            $scope.events = null;
            AllEvents.all().then(function(events) {
                $scope.events = events;
            });
        })
        .controller('BlogCtrl', function($scope, Blog, apiUrl, $localstorage, $ionicLoading, ModificationOfData) {
            ga_send_pageview('More - Blog');            
            
            $('.bar .back-button').removeClass('hide');
            $scope.blogNews = null;
            var allBlogNews = [];
            $ionicLoading.show();
            Blog.all().then(function(blogNews) {
                //console.log('blogNews--', blogNews);
                $(blogNews).find("item").each(function() {
                    var title = $(this).children("title").text();
                    var description = $(this).children("description").text();
                    var link = '<a href="' + $(this).children("link").text() + '">More on web</a>'
                    var myitem = null;
                    myitem = {
                        'title': title,
                        'description': ModificationOfData.decodeText(description), //str_replace(find, replace, description), //$(this).children("description").text(),
                        'link': link
                    };
                    allBlogNews.push(myitem);
                });
                console.log('allBlogNews---', allBlogNews);
                $scope.blogNews = allBlogNews;
                $ionicLoading.hide();
            });
        })




//
//Not using now
//
        .controller('LoginCtrl', function($scope, $state, $timeout, $ionicHistory, $ionicViewService, AuthService, EVENTS, $rootScope) {
            console.log('-- LoginCtrl - -');
            console.log('-- back-button.length - -', $('.back-button').length);
            if ($('.back-button').length == 2) {
                $timeout(function() {
                    $('.back-button').css('display', 'none');
                }, 200);
            }
            $scope.goBack = function() {
                console.log('-- goBack- -');
                //$ionicHistory.goBack();
                //$ionicHistory.currentView($ionicHistory.backView());
                $state.go('index', {}, {reload: true});
                //  $state.go('index', {}, {location: 'replace', notify: false});
                //  $ionicViewService.clearHistory();
            };
            $scope.message = "";
            $scope.type_pass = 'password';
            $scope.user = {
                username: null,
                password: null
            };
            //////// Test ////////
            $scope.currentUser = null;
            $scope.isAuthorized = AuthService.isAuthorized;
            $scope.setCurrentUser = function(user) {
                $scope.currentUser = user;
            };
            function logout() {
                AuthService.logout();
            }
            function redirectToLogin() {
                $state.go('login-tabs');
            }
            $scope.credentials = {
                username: '',
                password: ''
            };



            $scope.login = function() {
                AuthService.getToken(userData).then(function(response) {
                    // console.log('AuthService.getToken response--', response);
                    // console.log('EVENTS --', EVENTS);
                    // console.log('token--', response.data.token);
                    if (response.data.token) {
                        AuthService.login(response.data.token).then(function(user) {
                            console.log('AuthService.login user--', user);
                            console.log('EVENTS.loginSuccess --', EVENTS.loginSuccess);
                            $('.bar .back-button').addClass('hide');
                            $rootScope.$broadcast(EVENTS.loginSuccess);
                            $scope.setCurrentUser(user);
                            $state.go('tab.members');
                            //$state.go('tab.members', {}, {reload: true, inherit: false});
                        });
                    } else {
                        $scope.message = 'Please ensure this is a good email and password for an active Giftster account.';
                        $rootScope.$broadcast(EVENTS.loginFailed);
                    }
                });
            };
            //////// END Test ////////

            $scope.showPassword = function() {
                $scope.type_pass = ($scope.type_pass == 'password') ? 'text' : 'password';
                document.getElementById('input_pass').type = $scope.type_pass;
            };
            $scope.forgotPassword = function() {
                //  $state.go('tab2.login-forgotpassword', {}, {reload: true});
                // $state.go('tab2.login-forgotpassword', {}, {});
                $ionicViewService.clearHistory();
                console.log(' - - - forgotPassword - - - ');
                $state.go('tab2.login-forgotpassword', {}, {reload: true});
                /* $ionicHistory.currentView($ionicHistory.backView());
                 $state.go('tab2.login-forgotpassword', {}, {
                 location: 'replace',
                 notify: false
                 });*/
            };
        })
        //ForgotPasswordCtrl
        .controller('ForgotPasswordCtrl', function($scope, $rootScope, $timeout, $state, $ionicViewService, $ionicHistory, $ionicPopup, AuthService) {
            console.log('-- ForgotPasswordCtrl - -');
            console.log('-- back-button.length - -', $('.back-button').length);
            if ($('.back-button').length == 2) {
                $timeout(function() {
                    // alert('1');
                    //  console.log('-- back-button.length - -', $('.back-button').length);
                    $('.back-button').first().css('display', 'none');
                }, 200);
            }

            $scope.user = {useremail: null};
            $scope.goBack = function() {
                $state.go('tab2.login', {}, {reload: true});
                //  $state.go('index', {}, {location: 'replace', notify: false});
                // $ionicViewService.clearHistory();
            };
            /*  $rootScope.$ionicGoBack = function() {
             //$('.bar .back-button').addClass('hide');
             //$ionicHistory.goBack();
             // window.history.back();
             $state.go('tab2.login');
             
             };*/
            /*
             $scope.goBack = function() {
             console.log('-- goBack- -');
             //$ionicHistory.goBack();
             //$ionicHistory.currentView($ionicHistory.backView());
             $state.go('tab2.login', {}, {reload: true});
             //  $state.go('index', {}, {location: 'replace', notify: false});
             $ionicViewService.clearHistory();
             };*/
            $scope.resetPassword = function() {
                var useremail = '';
                useremail = $scope.user.useremail;
                console.log("$scope.user.useremail: " + $scope.user.useremail);
                if (useremail == '' || useremail == null)
                    useremail = 'noemail';
                var userData = {email: useremail};
                AuthService.forgotPassword(userData).then(function(response) {
                    console.log('forgotPassword - ', response);
                    if (response.data.success == false) {
                        return $ionicPopup.alert({
                            template: "<style>.popup-buttons .button.button-positive {   margin-left: 25%; margin-right: 25%; }</style><p>We could not complete your request. Please try again.</p>",
                            title: 'Whoops!',
                            buttons: [{
                                    text: 'ok',
                                    type: 'button-positive'
                                }]
                        });
                    } else {
                        return $ionicPopup.alert({
                            template: "<style>.popup-buttons .button.button-positive {   margin-left: 25%; margin-right: 25%; }</style><p>We have e-mailed you instructions for re-setting your password. You should receive it shortly.</p>",
                            title: 'You’ve got mail!',
                            buttons: [{
                                    text: 'ok',
                                    type: 'button-positive'
                                }]
                        });
                    }
                });
            };
        })
        .controller('SearchTabsCtrl', function($scope, $state, $ionicHistory, $ionicViewService, $rootScope, $localstorage, $ionicPopup, $stateParams, userSettings) {
            $scope.userSettings = userSettings.setParams('hide', 'hide', '', '', 'footer_without_tabs', '', 'hide');
            $scope.footer_tabs = $localstorage.get('footer_tabs');
            var login_token = $localstorage.get('login_token');
            $scope.footer_without_tabs = '';
            $scope.searchtext = {title: null};
            $scope.searchlist = null;
            console.log('login_token - ', login_token);
            $scope.goBack = function() {
                $state.go('tab2.login', {}, {reload: true});
                //  $state.go('index', {}, {location: 'replace', notify: false});
                //  $ionicViewService.clearHistory();
            };
            if (login_token) {
                $scope.footer_tabs = 'show';
                $scope.userSettings = userSettings.setParams('hide', 'show', 'hide', 'hide', '', 'hide', '');
            } else {

                $scope.footer_tabs = 'hide';
                $scope.footer_without_tabs = 'footer_without_tabs';
                $rootScope.$ionicGoBack = function() {
                    console.log('$ionicGoBack - ');
                    $('.bar .back-button').addClass('hide');
                    $state.go('index');
                };
            }

            var tabName = '';
            tabName = $stateParams.tab;
            console.log('tabName - - - -', tabName);
            $scope.search = function() {
                console.log('$scope.searchtext.title - - - ', $scope.searchtext.title);
                if (!$scope.searchtext.title) {
                    return $ionicPopup.alert({
                        template: "<style>.popup-buttons .button.button-positive {   margin-left: 25%; margin-right: 25%; }</style><p>Please enter a name or email address</p>",
                        title: 'Whoops!',
                        buttons: [{
                                text: 'ok',
                                type: 'button-positive'
                            }]
                    });
                }

                if (tabName == 'more')
                    $state.go('tab.more-search-results', {"name": $scope.searchtext.title, "tab": 'more'}, {reload: true, inherit: false});
                else if (tabName == 'groups')
                    $state.go('tab.groups-search-results', {"name": $scope.searchtext.title, "tab": 'groups'}, {reload: true, inherit: false});
                else if (tabName == 'tab2')
                    $state.go('tab2.search-results', {"name": $scope.searchtext.title, "tab": 'tab2'}, {reload: true, inherit: false});
                else
                    $state.go('search-results', {"name": $scope.searchtext.title, "tab": ''}, {reload: true, inherit: false});
                return;
                //tab.more-search
                if ($localstorage.get('login_token'))
                    $state.go('search-results', {"name": $scope.searchtext.title}, {reload: true, inherit: false});
                else
                    $state.go('tab2.search-results', {"name": $scope.searchtext.title, "tab": 'tab2'}, {reload: true, inherit: false});
            };
        })

        .controller('TimeOutCtrl', function($scope, $state, $window, $ionicLoading, $ionicHistory, AuthService) {
            
            // Never show back button for this page since history is broken
            $('.bar .back-button').addClass('hide');

            $scope.isAuthenticated = AuthService.isAuthenticated();
            
            $scope.backToShopTab = function() {
                $('.bar .back-button').addClass('hide'); // Show back button again
                $state.go('tab.members', {}, {reload: true, inherit: false});
            }

            $scope.redirectToLogin = function() {
                AuthService.logout();
                $('.bar .back-button').addClass('hide'); // Show back button again
                $state.go('index', {}, {reload: true, inherit: false});
            }

        })        

        .filter('hrefToJS', function($sce, $sanitize) {
            return function(text) {
                var regex = /href="([\S]+)"/g;
                var newString = $sanitize(text).replace(regex, "onClick=\"window.open('$1', '_system', 'location=yes,enableViewportScale=yes')\"");

                return $sce.trustAsHtml(newString);
            }
        })
        ;
function str_replace(search, replace, subject, count) {
    //   example 1: str_replace(' ', '.', 'Kevin van Zonneveld');
    //   returns 1: 'Kevin.van.Zonneveld'
    //   example 2: str_replace(['{name}', 'l'], ['hello', 'm'], '{name}, lars');
    //   returns 2: 'hemmo, mars'

    var i = 0,
            j = 0,
            temp = '',
            repl = '',
            sl = 0,
            fl = 0,
            f = [].concat(search),
            r = [].concat(replace),
            s = subject,
            ra = Object.prototype.toString.call(r) == '[object Array]',
            sa = Object.prototype.toString.call(s) == '[object Array]';
    s = [].concat(s);
    if (count) {
        this.window[count] = 0;
    }

    for (i = 0, sl = s.length; i < sl; i++) {
        if (s[i] == '') {
            continue;
        }
        for (j = 0, fl = f.length; j < fl; j++) {
            temp = s[i] + '';
            repl = ra ? (r[j] !== undefined ? r[j] : '') : r[0];
            s[i] = (temp)
                    .split(f[j])
                    .join(repl);
            if (count && s[i] !== temp) {
                this.window[count] += (temp.length - s[i].length) / f[j].length;
            }
        }
    }
    return sa ? s : s[0];
}

function ga_send_pageview(pageTitle) {
    if (isMobileWebsite) {
        return ga('send', {
            hitType: 'pageview',
            title: pageTitle 
        })
    } else {
        return ''
    }
}

function ga_send_event(category, action, label) {

    label = typeof label !== 'undefined' ? label : null;

    if (isMobileWebsite) {        
        // Label is optional, set default to null
        
        return ga('send', {
            hitType: 'event',
            eventCategory: category,
            eventAction: action,
            eventLabel: label
        })
    
    } else {
        return ''
    }
}

